Package: jsonlite
Version: 2.0.0
Title: A Simple and Robust JSON Parser and Generator for R
License: MIT + file LICENSE
Depends: methods
Authors@R: c(
    person("Jeroen", "Ooms", role = c("aut", "cre"), email = "jeroenooms@gmail.com",
      comment = c(ORCID = "0000-0002-4035-0289")),
    person("Duncan", "Temple Lang", role = "ctb"),
    person("Lloyd", "Hilaiel", role = "cph", comment="author of bundled libyajl"))
URL: https://jeroen.r-universe.dev/jsonlite
        https://arxiv.org/abs/1403.2805
BugReports: https://github.com/jeroen/jsonlite/issues
Maintainer: Jeroen Ooms <jeroenooms@gmail.com>
VignetteBuilder: knitr, R.rsp
Description: A reasonably fast JSON parser and generator, optimized for statistical 
    data and the web. Offers simple, flexible tools for working with JSON in R, and
    is particularly powerful for building pipelines and interacting with a web API. 
    The implementation is based on the mapping described in the vignette (Ooms, 2014).
    In addition to converting JSON data from/to R objects, 'jsonlite' contains 
    functions to stream, validate, and prettify JSON data. The unit tests included 
    with the package verify that all edge cases are encoded and decoded consistently 
    for use with dynamic data in systems and applications.
Suggests: httr, vctrs, testthat, knitr, rmarkdown, R.rsp, sf
RoxygenNote: 7.3.2
Encoding: UTF-8
NeedsCompilation: yes
Packaged: 2025-03-26 11:36:10 UTC; jeroen
Author: Jeroen Ooms [aut, cre] (<https://orcid.org/0000-0002-4035-0289>),
  Duncan Temple Lang [ctb],
  Lloyd Hilaiel [cph] (author of bundled libyajl)
Repository: CRAN
Date/Publication: 2025-03-27 06:40:02 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-25 15:39:00 UTC; unix
Archs: jsonlite.so.dSYM

Package: jsonlite
Version: 1.7.2
Title: A Simple and Robust JSON Parser and Generator for R
License: MIT + file LICENSE
Depends: methods
Authors@R: c(
    person("Jeroen", "Ooms", role = c("aut", "cre"), email = "jeroen@berkeley.edu",
      comment = c(ORCID = "0000-0002-4035-0289")),
    person("Duncan", "Temple Lang", role = "ctb"),
    person("Lloyd", "Hilaiel", role = "cph", comment="author of bundled libyajl"))
URL: https://arxiv.org/abs/1403.2805 (paper)
BugReports: https://github.com/jeroen/jsonlite/issues
Maintainer: Jeroen Ooms <jeroen@berkeley.edu>
VignetteBuilder: knitr, R.rsp
Description: A reasonably fast JSON parser and generator, optimized for statistical 
    data and the web. Offers simple, flexible tools for working with JSON in R, and
    is particularly powerful for building pipelines and interacting with a web API. 
    The implementation is based on the mapping described in the vignette (Ooms, 2014).
    In addition to converting JSON data from/to R objects, 'jsonlite' contains 
    functions to stream, validate, and prettify JSON data. The unit tests included 
    with the package verify that all edge cases are encoded and decoded consistently 
    for use with dynamic data in systems and applications.
Suggests: httr, curl, plyr, testthat, knitr, rmarkdown, R.rsp, sf
RoxygenNote: 7.1.1
Encoding: UTF-8
NeedsCompilation: yes
Packaged: 2020-12-09 13:54:18 UTC; jeroen
Author: Jeroen Ooms [aut, cre] (<https://orcid.org/0000-0002-4035-0289>),
  Duncan Temple Lang [ctb],
  Lloyd Hilaiel [cph] (author of bundled libyajl)
Repository: CRAN
Date/Publication: 2020-12-09 17:40:03 UTC

Changes in yajl code by Jeroen:

 - Manually changed the header include paths in some c/h files to avoid cmake dependency.
 - Comment out call to abort() in src/yajl/yajl_parser.c (for CMD check)
 - Manually generated yajl.version.h from yajl.version.h.in (by running cmake)
 - Patch for CMD check warnings on Windows: https://github.com/lloyd/yajl/issues/143
 - Patch for error messages in yajl_tree_parse: https://github.com/lloyd/yajl/issues/144
 - Fix for windows XP: https://rt.cpan.org/Public/Bug/Display.html?id=69113
 - in yajl_tree.c added functions: push_parser_new and push_parser_get

This dir contains unit tests for use with the testthat package. 
They are intended to be tested by a non-root user.
To run them, install this package and run:

library(testthat)
test_package("jsonlite")

# S4 to list object. Not quite sure if this really works in general. You probably
# shouldn't use S4 instances with JSON anyway because you don't know the class
# definition.

S4tolist <- function(x) {
  structure(lapply(slotNames(x), slot, object = x), .Names = slotNames(x))
}

# ENCODING TOOLS

# opposite of unname: force list into named list to get key/value json encodings
givename <- function(obj) {
  return(structure(obj, names = as.character(names(obj))))
}

# trim whitespace
trim <- function(x) {
  gsub("(^[[:space:]]+|[[:space:]]+$)", "", x)
}

# put double quotes around a string
wrapinquotes <- function(x) {
  paste("\"", x, "\"", sep = "")
}

# DECODING TOOLS
evaltext <- function(text) {
  return(eval(parse(text = text)))
}

setMethod("asJSON", "character", function(x, collapse = TRUE, na = c("null", "string", "NA"),
  auto_unbox = FALSE, keep_vec_names = FALSE, indent = NA_integer_, ...) {

  # Needed for multi-byte Windows locales
  # See: https://github.com/jeroen/jsonlite/issues/329
  x <- enc2utf8(x)

  # shiny legacy exception
  if(isTRUE(keep_vec_names) && length(names(x))){
    warn_keep_vec_names()
    return(asJSON(as.list(x), na = na, auto_unbox = TRUE, collapse = collapse, ...))
  }

  # vectorized escaping
  tmp <- deparse_vector(x)

  # this was used with deparse_vector_old
  #if(identical(Encoding(x), "UTF-8")){
  #  if(!grepl("UTF", Sys.getlocale("LC_CTYPE"), ignore.case=TRUE)){
  #    tmp <- utf8conv(tmp);
  #  }
  #}

  # validate NA
  if (any(missings <- which(is.na(x)))) {
    na <- match.arg(na)
    if (na %in% c("null")) {
      tmp[missings] <- "null"
    } else if(na %in% "string") {
      tmp[missings] <- "\"NA\""
    } else {
      tmp[missings] <- NA_character_
    }
  }

  if(isTRUE(auto_unbox) && length(tmp) == 1){
    return(tmp);
  }

  # this is almost always true, except for class 'scalar'
  if (isTRUE(collapse)) {
    collapse(tmp, indent = indent)
  } else {
    tmp
  }
})

setMethod("asJSON", "complex", function(x, digits = 5, collapse = TRUE, complex = c("string",
  "list"), na = c("string", "null", "NA"), oldna = NULL, ...) {

  # validate
  na <- match.arg(na);
  complex <- match.arg(complex)

  #turn into strings
  if (complex == "string") {
    #default NA is "NA"
    mystring <- prettyNum(x = x, digits = digits)
    if (any(missings <- which(!is.finite(x)))){
      if (na %in% c("null", "NA")) {
        mystring[missings] <- NA_character_;
      }
    }
    asJSON(mystring, collapse = collapse, na = na, ...)
  } else {
    if(na == "NA"){
      na <- oldna;
    }
    asJSON(list(real = Re(x), imaginary = Im(x)), na = na, digits = digits, ...)
  }
})

parseJSON <- function(txt, bigint_as_char = FALSE) {
  if(inherits(txt, "connection")){
    parse_con(txt, bigint_as_char)
  } else {
    parse_string(txt, bigint_as_char)
  }
}

#' @useDynLib jsonlite R_parse
parse_string <- function(txt, bigint_as_char){
  if (length(txt) > 1) {
    txt <- paste(txt, collapse = "\n")
  }
  .Call(R_parse, txt, bigint_as_char)
}

apply_by_pages <- function(x, FUN, pagesize, verbose, ...){
  stopifnot(is.data.frame(x))
  nr <- nrow(x)
  npages <- nr %/% pagesize;
  lastpage <- nr %% pagesize;

  out <- as.list(rep(NA, npages + as.logical(lastpage)))
  for(i in seq_len(npages)){
    from <- pagesize * (i-1) + 1;
    to <- pagesize * i
    out[[i]] <- FUN(x[from:to, ,drop = FALSE], ...)
    if(verbose) cat("\rProcessed", i * pagesize, "rows...")
  }

  if(lastpage){
    from <- nr - lastpage + 1;
    out[[npages + 1]] <- FUN(x[from:nr, ,drop = FALSE], ...)
  }
  if(verbose) cat("\rComplete! Processed total of", nr, "rows.\n")
  out
}

#this is another slightly slower implementation
apply_by_pages2 <- function(x, FUN, pagesize, verbose, ...){
  x2 <- split(x, seq_len(nrow(x)) %/% pagesize)
  for(page in x2){
    if(verbose) message("Writing ", nrow(page), " lines (", ").")
    FUN(page)
  }
  invisible()
}

unescape_unicode <- function(x){
  #single string only
  stopifnot(is.character(x) && length(x) == 1)

  #find matches
  m <- gregexpr("(\\\\)+u[0-9a-z]{4}", x, ignore.case = TRUE)

  if(m[[1]][1] > -1){
    #parse matches
    p <- vapply(regmatches(x, m)[[1]], function(txt){
      gsub("\\", "\\\\", parse(text=paste0('"', txt, '"'))[[1]], fixed = TRUE, useBytes = TRUE)
    }, character(1), USE.NAMES = FALSE)

    #substitute parsed into original
    regmatches(x, m) <- list(p)
  }

  x
}

#' @useDynLib jsonlite R_parse_connection
parse_con <- function(con, bigint_as_char){
  stopifnot(inherits(con, "connection"))
  if(!isOpen(con)){
    on.exit(close(con)) # also destroy con if 'open' fails
    open(con, "rb")
  }
  .Call(R_parse_connection, con, bigint_as_char)
}

apply_by_pages <- function(x, FUN, pagesize, verbose, ...){
  stopifnot(is.data.frame(x))
  nr <- nrow(x)
  npages <- nr %/% pagesize;
  lastpage <- nr %% pagesize;

  out <- as.list(rep(NA, npages + as.logical(lastpage)))
  for(i in seq_len(npages)){
    from <- pagesize * (i-1) + 1;
    to <- pagesize * i
    out[[i]] <- FUN(x[from:to, ,drop = FALSE], ...)
    if(verbose) cat("\rProcessed", i * pagesize, "rows...")
  }

  if(lastpage){
    from <- nr - lastpage + 1;
    out[[npages + 1]] <- FUN(x[from:nr, ,drop = FALSE], ...)
  }
  if(verbose) cat("\rComplete! Processed total of", nr, "rows.\n")
  out
}

#this is another slightly slower implementation
apply_by_pages2 <- function(x, FUN, pagesize, verbose, ...){
  x2 <- split(x, seq_len(nrow(x)) %/% pagesize)
  for(page in x2){
    if(verbose) message("Writing ", nrow(page), " lines (", ").")
    FUN(page)
  }
  invisible()
}

#' @export
`[.json` <- function(x, i) {
  structure(NextMethod("["), class = c("json", "character"))
}

asjson_numeric_fun <- function(x, digits = 5, use_signif = is(digits, "AsIs"),
  na = c("string", "null", "NA"), auto_unbox = FALSE, collapse = TRUE,
  keep_vec_names = FALSE, indent = NA_integer_, always_decimal = FALSE, ...) {

  # shiny legacy exception
  if(isTRUE(keep_vec_names) && length(names(x))){
    warn_keep_vec_names()
    return(asJSON(as.list(x), digits = digits, use_signif = use_signif, na = na,
      auto_unbox = TRUE, collapse = collapse, ...))
  }

  na <- match.arg(na);
  na_as_string <- switch(na,
    "string" = TRUE,
    "null" = FALSE,
    "NA" = NA,
    stop("invalid na_as_string")
  )

  # old R implementation
  # tmp <- num_to_char_R(x, digits, na_as_string);

  # fast C implementation
  tmp <- if(is(x, "integer64")){
    integer64_to_char(x, na_as_string)
  } else {
    num_to_char(x, digits, na_as_string, use_signif, always_decimal);
  }

  if(isTRUE(auto_unbox) && length(tmp) == 1){
    return(tmp);
  }

  if(collapse){
    collapse(tmp, indent = indent)
  } else {
    tmp
  }
}

# This is for the bit64 package
setOldClass("integer64")
setMethod("asJSON", "numeric", asjson_numeric_fun)
setMethod("asJSON", "integer64", asjson_numeric_fun)

unescape_unicode <- function(x) {
  #single string only
  stopifnot(is.character(x) && length(x) == 1)

  #find matches
  m <- gregexpr("(\\\\)+u[0-9a-z]{4}", x, ignore.case = TRUE)

  if (m[[1]][1] > -1) {
    #parse matches
    p <- vapply(
      regmatches(x, m)[[1]],
      function(txt) {
        gsub("\\", "\\\\", parse(text = paste0('"', txt, '"'))[[1]], fixed = TRUE, useBytes = TRUE)
      },
      character(1),
      USE.NAMES = FALSE
    )

    #substitute parsed into original
    regmatches(x, m) <- list(p)
  }

  x
}

setMethod("asJSON", "logical", function(x, collapse = TRUE, na = c("null", "string", "NA"),
  auto_unbox = FALSE, keep_vec_names = FALSE, indent = NA_integer_, ...) {

  # shiny legacy exception
  if(isTRUE(keep_vec_names) && length(names(x))){
    warn_keep_vec_names()
    return(asJSON(as.list(x), collapse = collapse, na = na, auto_unbox = TRUE, ...))
  }

  # validate arg
  na <- match.arg(na)

  # json true/false
  tmp <- ifelse(x, "true", "false")

  # replace missing values, unless na="NA"
  if(!identical(na, "NA")){
    # logical values can have NA (but not Inf/NaN). Default is to encode as null.
    if (any(missings <- which(is.na(x)))) {
      tmp[missings] <- ifelse(identical(na, "string"), "\"NA\"", "null")
    }
  }

  #this is needed when !length(tmp) or all(is.na(tmp))
  if(!is.character(tmp)){
    tmp <- as.character(tmp);
  }

  if(isTRUE(auto_unbox) && length(tmp) == 1){
    return(tmp);
  }

  # collapse it
  if(collapse) {
    collapse(tmp, indent = indent)
  } else {
    tmp
  }
})

#' Streaming JSON input/output
#'
#' The \code{stream_in} and \code{stream_out} functions implement line-by-line processing
#' of JSON data over a \code{\link{connection}}, such as a socket, url, file or pipe. JSON
#' streaming requires the \href{http://ndjson.org}{ndjson} format, which slightly differs
#' from \code{\link{fromJSON}} and \code{\link{toJSON}}, see details.
#'
#' Because parsing huge JSON strings is difficult and inefficient, JSON streaming is done
#' using \strong{lines of minified JSON records}, a.k.a. \href{http://ndjson.org}{ndjson}.
#' This is pretty standard: JSON databases such as \href{https://github.com/datproject/dat}{dat}
#' or MongoDB use the same format to import/export datasets. Note that this means that the
#' total stream combined is not valid JSON itself; only the individual lines are. Also note
#' that because line-breaks are used as separators, prettified JSON is not permitted: the
#' JSON lines \emph{must} be minified. In this respect, the format is a bit different from
#' \code{\link{fromJSON}} and \code{\link{toJSON}} where all lines are part of a single JSON
#' structure with optional line breaks.
#'
#' The \code{handler} is a callback function which is called for each page (batch) of
#' JSON data with exactly one argument (usually a data frame with \code{pagesize} rows).
#' If \code{handler} is missing or \code{NULL}, a default handler is used which stores all
#' intermediate pages of data, and at the very end binds all pages together into one single
#' data frame that is returned by \code{stream_in}. When a custom \code{handler} function
#' is specified, \code{stream_in} does not store any intermediate results and always returns
#' \code{NULL}. It is then up to the \code{handler} to process or store data pages.
#' A \code{handler} function that does not store intermediate results in memory (for
#' example by writing output to another connection) results in a pipeline that can process an
#' unlimited amount of data. See example.
#'
#' Note that a vector of JSON strings already in R can parsed with \code{stream_in} by
#' creating a connection to it with \code{\link{textConnection}}.
#'
#' If a connection is not opened yet, \code{stream_in} and \code{stream_out}
#' will automatically open and later close the connection. Because R destroys connections
#' when they are closed, they cannot be reused. To use a single connection for multiple
#' calls to \code{stream_in} or \code{stream_out}, it needs to be opened
#' beforehand. See example.
#'
#' @param con a \code{\link{connection}} object. If the connection is not open,
#' \code{stream_in} and \code{stream_out} will automatically open
#' and later close (and destroy) the connection. See details.
#' @param handler a custom function that is called on each page of JSON data. If not specified,
#' the default handler stores all pages and binds them into a single data frame that will be
#' returned by \code{stream_in}. See details.
#' @param x object to be streamed out. Currently only data frames are supported.
#' @param pagesize number of lines to read/write from/to the connection per iteration.
#' @param verbose print some information on what is going on.
#' @param ... arguments for \code{\link{fromJSON}} and \code{\link{toJSON}} that
#' control JSON formatting/parsing where applicable. Use with caution.
#' @name stream_in, stream_out
#' @export stream_in stream_out
#' @rdname stream_in
#' @references MongoDB export format: \url{https://docs.mongodb.com/manual/reference/program/mongoexport/}
#' @references Documentation for the JSON Lines text file format: \url{https://jsonlines.org/}
#' @seealso \code{\link{fromJSON}}, \code{\link{read_json}}
#' @return The \code{stream_out} function always returns \code{NULL}.
#' When no custom handler is specified, \code{stream_in} returns a data frame of all pages binded together.
#' When a custom handler function is specified, \code{stream_in} always returns \code{NULL}.
#' @examples # compare formats
#' x <- iris[1:3,]
#' toJSON(x)
#' stream_out(x)
#'
#' # Trivial example
#' mydata <- stream_in(url("http://httpbin.org/stream/100"))
#'
#' \dontrun{
#' #stream large dataset to file and back
#' library(nycflights13)
#' stream_out(flights, file(tmp <- tempfile()))
#' flights2 <- stream_in(file(tmp))
#' unlink(tmp)
#' all.equal(flights2, as.data.frame(flights))
#'
#' # stream over HTTP
#' diamonds2 <- stream_in(url("http://jeroen.github.io/data/diamonds.json"))
#'
#' # stream over HTTP with gzip compression
#' flights3 <- stream_in(gzcon(url("http://jeroen.github.io/data/nycflights13.json.gz")))
#' all.equal(flights3, as.data.frame(flights))
#'
#' # stream over HTTPS (HTTP+SSL) via curl
#' library(curl)
#' flights4 <- stream_in(gzcon(curl("https://jeroen.github.io/data/nycflights13.json.gz")))
#' all.equal(flights4, as.data.frame(flights))
#'
#' # or alternatively:
#' flights5 <- stream_in(gzcon(pipe("curl https://jeroen.github.io/data/nycflights13.json.gz")))
#' all.equal(flights5, as.data.frame(flights))
#'
#' # Full JSON IO stream from URL to file connection.
#' # Calculate delays for flights over 1000 miles in batches of 5k
#' library(dplyr)
#' con_in <- gzcon(url("http://jeroen.github.io/data/nycflights13.json.gz"))
#' con_out <- file(tmp <- tempfile(), open = "wb")
#' stream_in(con_in, handler = function(df){
#'   df <- dplyr::filter(df, distance > 1000)
#'   df <- dplyr::mutate(df, delta = dep_delay - arr_delay)
#'   stream_out(df, con_out, pagesize = 1000)
#' }, pagesize = 5000)
#' close(con_out)
#'
#' # stream it back in
#' mydata <- stream_in(file(tmp))
#' nrow(mydata)
#' unlink(tmp)
#'
#' # Data from http://openweathermap.org/current#bulk
#' # Each row contains a nested data frame.
#' daily14 <- stream_in(gzcon(url("http://78.46.48.103/sample/daily_14.json.gz")), pagesize=50)
#' subset(daily14, city$name == "Berlin")$data[[1]]
#'
#' # Or with dplyr:
#' library(dplyr)
#' daily14f <- flatten(daily14)
#' filter(daily14f, city.name == "Berlin")$data[[1]]
#'
#' # Stream import large data from zip file
#' tmp <- tempfile()
#' download.file("http://jsonstudio.com/wp-content/uploads/2014/02/companies.zip", tmp)
#' companies <- stream_in(unz(tmp, "companies.json"))
#' }
stream_in <- function(con, handler = NULL, pagesize = 500, verbose = TRUE, ...) {

  # Maybe also handle URLs here in future.
  if(!is(con, "connection")){
    stop("Argument 'con' must be a connection.")
  }

  # Same as mongolite
  count <- 0
  cb <- if(is.null(handler)){
    out <- new.env()
    function(x){
      if(length(x)){
        count <<- count + length(x)
        out[[as.character(count)]] <<- x
      }
    }
  } else {
    if(verbose)
      message("using a custom handler function.")
    function(x){
      handler(post_process(x, ...))
      count <<- count + length(x)
    }
  }

  if(!isOpen(con, "r")){
    if(verbose)
      message("opening ", is(con) ," input connection.")

    # binary connection prevents recoding of utf8 to latin1 on windows
    open(con, "rb")
    on.exit({
      if(verbose)
        message("closing ", is(con) ," input connection.")
      close(con)
    })
  }

  # Read data page by page
  repeat {
    page <- readLines(con, n = pagesize, encoding = "UTF-8")
    if(length(page)){
      cleanpage <- Filter(nchar, page)
      cb(lapply(cleanpage, parseJSON))
      if(verbose)
        cat("\r Found", count, "records...")
    }
    if(length(page) < pagesize)
      break
  }

  # Either return a big data frame, or nothing.
  if(is.null(handler)){
    if(verbose) cat("\r Imported", count, "records. Simplifying...\n")
    out <- as.list(out, sorted = FALSE)
    post_process(unlist(out[order(as.numeric(names(out)))], FALSE, FALSE), ...)
  } else {
    invisible()
  }
}

post_process <- function(x, simplifyVector = TRUE, simplifyDataFrame = simplifyVector,
                         simplifyMatrix = simplifyVector, flatten = FALSE){
  out <- simplify(x, simplifyVector = simplifyVector, simplifyDataFrame = simplifyDataFrame,
    simplifyMatrix = simplifyMatrix, flatten = flatten)

  # We assume ndjson with objects
  if(isTRUE(simplifyDataFrame)){
    return(as.data.frame(out))
  } else {
    out
  }
}

#' @rdname stream_in
#' @param prefix string to write before each line (use \code{"\u001e"} to write rfc7464 text sequences)
stream_out <- function(x, con = stdout(), pagesize = 500, verbose = TRUE, prefix = "", ...) {

  if(!is(con, "connection")){
    # Maybe handle URLs here in future.
    stop("Argument 'con' must be a connection.")
  }

  if(!isOpen(con, "w")){
    if(verbose) message("opening ", is(con) ," output connection.")
    open(con, "wb")
    on.exit({
      if(verbose) message("closing ", is(con) ," output connection.")
      close(con)
    })
  }

  invisible(apply_by_pages(x, stream_out_page, pagesize = pagesize, con = con, verbose = verbose, prefix = prefix, ...));
}

stream_out_page <- function(page, con, prefix, ...){
  # useBytes can sometimes prevent recoding of utf8 to latin1 on windows.
  # on windows there is a bug when useBytes is used with a (non binary) text connection.
  str <- enc2utf8(asJSON(page, collapse = FALSE, ...))
  if(is.character(prefix) && length(prefix) && nchar(prefix))
    str <- paste0(prefix[1], str)
  writeLines(str, con = con, useBytes = TRUE)
}

#' Streaming JSON input/output
#'
#' The \code{stream_in} and \code{stream_out} functions implement line-by-line processing
#' of JSON data over a \code{\link{connection}}, such as a socket, url, file or pipe. JSON
#' streaming requires the \href{http://ndjson.org}{ndjson} format, which slightly differs
#' from \code{\link{fromJSON}} and \code{\link{toJSON}}, see details.
#'
#' Because parsing huge JSON strings is difficult and inefficient, JSON streaming is done
#' using \strong{lines of minified JSON records}, a.k.a. \href{http://ndjson.org}{ndjson}.
#' This is pretty standard: JSON databases such as \href{https://github.com/maxogden/dat}{dat}
#' or MongoDB use the same format to import/export datasets. Note that this means that the
#' total stream combined is not valid JSON itself; only the individual lines are. Also note
#' that because line-breaks are used as separators, prettified JSON is not permitted: the
#' JSON lines \emph{must} be minified. In this respect, the format is a bit different from
#' \code{\link{fromJSON}} and \code{\link{toJSON}} where all lines are part of a single JSON
#' structure with optional line breaks.
#'
#' The \code{handler} is a callback function which is called for each page (batch) of
#' JSON data with exactly one argument (usually a data frame with \code{pagesize} rows).
#' If \code{handler} is missing or \code{NULL}, a default handler is used which stores all
#' intermediate pages of data, and at the very end binds all pages together into one single
#' data frame that is returned by \code{stream_in}. When a custom \code{handler} function
#' is specified, \code{stream_in} does not store any intermediate results and always returns
#' \code{NULL}. It is then up to the \code{handler} to process or store data pages.
#' A \code{handler} function that does not store intermediate results in memory (for
#' example by writing output to another connection) results in a pipeline that can process an
#' unlimited amount of data. See example.
#'
#' If a connection is not opened yet, \code{stream_in} and \code{stream_out}
#' will automatically open and later close the connection. Because R destroys connections
#' when they are closed, they cannot be reused. To use a single connection for multiple
#' calls to \code{stream_in} or \code{stream_out}, it needs to be opened
#' beforehand. See example.
#'
#' @param con a \code{\link{connection}} object. If the connection is not open,
#' \code{stream_in} and \code{stream_out} will automatically open
#' and later close (and destroy) the connection. See details.
#' @param handler a custom function that is called on each page of JSON data. If not specified,
#' the default handler stores all pages and binds them into a single data frame that will be
#' returned by \code{stream_in}. See details.
#' @param x object to be streamed out. Currently only data frames are supported.
#' @param pagesize number of lines to read/write from/to the connection per iteration.
#' @param verbose print some information on what is going on.
#' @param ... arguments for \code{\link{fromJSON}} and \code{\link{toJSON}} that
#' control JSON formatting/parsing where applicable. Use with caution.
#' @name stream_in, stream_out
#' @export stream_in stream_out
#' @rdname stream_in
#' @references MongoDB export format: \url{https://docs.mongodb.com/manual/reference/program/mongoexport/}
#' @references Documentation for the JSON Lines text file format: \url{http://jsonlines.org/}
#' @return The \code{stream_out} function always returns \code{NULL}.
#' When no custom handler is specified, \code{stream_in} returns a data frame of all pages binded together.
#' When a custom handler function is specified, \code{stream_in} always returns \code{NULL}.
#' @examples # compare formats
#' x <- iris[1:3,]
#' toJSON(x)
#' stream_out(x)
#'
#' # Trivial example
#' mydata <- stream_in(url("http://httpbin.org/stream/100"))
#'
#' \dontrun{
#' #stream large dataset to file and back
#' library(nycflights13)
#' stream_out(flights, file(tmp <- tempfile()))
#' flights2 <- stream_in(file(tmp))
#' unlink(tmp)
#' all.equal(flights2, as.data.frame(flights))
#'
#' # stream over HTTP
#' diamonds2 <- stream_in(url("http://jeroen.github.io/data/diamonds.json"))
#'
#' # stream over HTTP with gzip compression
#' flights3 <- stream_in(gzcon(url("http://jeroen.github.io/data/nycflights13.json.gz")))
#' all.equal(flights3, as.data.frame(flights))
#'
#' # stream over HTTPS (HTTP+SSL) via curl
#' library(curl)
#' flights4 <- stream_in(gzcon(curl("https://jeroen.github.io/data/nycflights13.json.gz")))
#' all.equal(flights4, as.data.frame(flights))
#'
#' # or alternatively:
#' flights5 <- stream_in(gzcon(pipe("curl https://jeroen.github.io/data/nycflights13.json.gz")))
#' all.equal(flights5, as.data.frame(flights))
#'
#' # Full JSON IO stream from URL to file connection.
#' # Calculate delays for flights over 1000 miles in batches of 5k
#' library(dplyr)
#' con_in <- gzcon(url("http://jeroen.github.io/data/nycflights13.json.gz"))
#' con_out <- file(tmp <- tempfile(), open = "wb")
#' stream_in(con_in, handler = function(df){
#'   df <- dplyr::filter(df, distance > 1000)
#'   df <- dplyr::mutate(df, delta = dep_delay - arr_delay)
#'   stream_out(df, con_out, pagesize = 1000)
#' }, pagesize = 5000)
#' close(con_out)
#'
#' # stream it back in
#' mydata <- stream_in(file(tmp))
#' nrow(mydata)
#' unlink(tmp)
#'
#' # Data from http://openweathermap.org/current#bulk
#' # Each row contains a nested data frame.
#' daily14 <- stream_in(gzcon(url("http://78.46.48.103/sample/daily_14.json.gz")), pagesize=50)
#' subset(daily14, city$name == "Berlin")$data[[1]]
#'
#' # Or with dplyr:
#' library(dplyr)
#' daily14f <- flatten(daily14)
#' filter(daily14f, city.name == "Berlin")$data[[1]]
#'
#' # Stream import large data from zip file
#' tmp <- tempfile()
#' download.file("http://jsonstudio.com/wp-content/uploads/2014/02/companies.zip", tmp)
#' companies <- stream_in(unz(tmp, "companies.json"))
#' }
stream_in <- function(con, handler = NULL, pagesize = 500, verbose = TRUE, ...) {

  # Maybe also handle URLs here in future.
  if(!is(con, "connection")){
    stop("Argument 'con' must be a connection.")
  }

  # Same as mongolite
  count <- 0
  cb <- if(is.null(handler)){
    out <- new.env()
    function(x){
      if(length(x)){
        count <<- count + length(x)
        out[[as.character(count)]] <<- x
      }
    }
  } else {
    if(verbose)
      message("using a custom handler function.")
    function(x){
      handler(post_process(x, ...))
      count <<- count + length(x)
    }
  }

  if(!isOpen(con, "r")){
    if(verbose)
      message("opening ", is(con) ," input connection.")

    # binary connection prevents recoding of utf8 to latin1 on windows
    open(con, "rb")
    on.exit({
      if(verbose)
        message("closing ", is(con) ," input connection.")
      close(con)
    })
  }

  # Read data page by page
  repeat {
    page <- readLines(con, n = pagesize, encoding = "UTF-8")
    if(length(page)){
      cleanpage <- Filter(nchar, page)
      cb(lapply(cleanpage, parseJSON))
      if(verbose)
        cat("\r Found", count, "records...")
    }
    if(length(page) < pagesize)
      break
  }

  # Either return a big data frame, or nothing.
  if(is.null(handler)){
    if(verbose) cat("\r Imported", count, "records. Simplifying...\n")
    out <- as.list(out, sorted = FALSE)
    post_process(unlist(out[order(as.numeric(names(out)))], FALSE, FALSE), ...)
  } else {
    invisible()
  }
}

post_process <- function(x, simplifyVector = TRUE, simplifyDataFrame = simplifyVector,
                         simplifyMatrix = simplifyVector, flatten = FALSE){
  out <- simplify(x, simplifyVector = simplifyVector, simplifyDataFrame = simplifyDataFrame,
    simplifyMatrix = simplifyMatrix, flatten = flatten)

  # We assume ndjson with objects
  if(isTRUE(simplifyDataFrame)){
    return(as.data.frame(out))
  } else {
    out
  }
}

#' @rdname stream_in
#' @param prefix string to write before each line (use \code{"\u001e"} to write rfc7464 text sequences)
stream_out <- function(x, con = stdout(), pagesize = 500, verbose = TRUE, prefix = "", ...) {

  if(!is(con, "connection")){
    # Maybe handle URLs here in future.
    stop("Argument 'con' must be a connection.")
  }

  if(!isOpen(con, "w")){
    if(verbose) message("opening ", is(con) ," output connection.")
    open(con, "wb")
    on.exit({
      if(verbose) message("closing ", is(con) ," output connection.")
      close(con)
    })
  }

  invisible(apply_by_pages(x, stream_out_page, pagesize = pagesize, con = con, verbose = verbose, prefix = prefix, ...));
}

stream_out_page <- function(page, con, prefix, ...){
  # useBytes can sometimes prevent recoding of utf8 to latin1 on windows.
  # on windows there is a bug when useBytes is used with a (non binary) text connection.
  str <- enc2utf8(asJSON(page, collapse = FALSE, ...))
  if(is.character(prefix) && length(prefix) && nchar(prefix))
    str <- paste0(prefix[1], str)
  writeLines(str, con = con, useBytes = TRUE)
}

setOldClass("scalar")
setMethod("asJSON", "scalar", function(x, collapse, ...) {
  # TODO: There must be a way to do this with NextMethod()
  if (length(class(x)) > 1) {
    class(x) <- class(x)[-1]
  } else {
    x <- unclass(x)
  }

  # Print JSON without []
  return(asJSON(x, collapse = FALSE, ...))
})

# If an object has already been encoded by toJSON(), do not encode it again
setOldClass("json")
setMethod("asJSON", "json", function(x, json_verbatim = FALSE, ...) {
  if(isTRUE(json_verbatim)){
    x
  } else {
    asJSON(as.character(x), ...)
  }
})

setMethod("asJSON", "data.frame", function(x, na = c("NA", "null", "string"), collapse = TRUE,
  dataframe = c("rows", "columns", "values"), complex = "string", oldna = NULL, rownames = NULL,
  keep_vec_names = FALSE, indent = NA_integer_, no_dots = FALSE, ...) {

  # Coerse pairlist if needed
  if (is.pairlist(x)) {
    x <- as.vector(x, mode = "list")
  }

  # Validate some args
  dataframe <- match.arg(dataframe)
  has_names <- identical(length(names(x)), ncol(x))

  # Default to adding row names only if they are strings and not just stringified numbers
  if(isTRUE(rownames) || (is.null(rownames) && is.character(attr(x, "row.names")) && !all(grepl("^\\d+$", row.names(x))))){
    # we don't use row.names() because this converts numbers to strings,
    # which will break sorting
    if(has_names){
      x[["_row"]] <- attr(x, "row.names")
    }
  }

  # Unname named lists columns. These are very rare.
  namedlistvars <- which(vapply(x, is.namedlistnotdf, logical(1)))
  for (i in namedlistvars) {
    x[[i]] <- unname(x[[i]])
  }

  # Convert POSIXlt to POSIXct before we start messing with lists
  posvars <- which(vapply(x, is, logical(1), "POSIXlt"))
  for (i in posvars) {
    x[[i]] <- as.POSIXct(x[[i]])
  }

  # Column based is same as list. Do not pass collapse arg because it is a named list.
  if (dataframe == "columns") {
    return(asJSON(as.list(x), is_df = TRUE, na = na, dataframe = dataframe,
      complex = complex, rownames = rownames, indent = indent, no_dots = no_dots, ...))
  }

  # Determine "oldna". This is needed when the data frame contains a list column
  if(missing(na) || !length(na) || identical(na, "NA")){
    oldna <- NULL
  } else {
    oldna <- na;
  }

  # Set default for row based, don't do it earlier because it will affect 'oldna' or dataframe="columns"
  if(dataframe == "rows" && has_names){
    na <- match.arg(na)
  }

  # no records
  if (!nrow(x)) {
    return(asJSON(list(), collapse=collapse, indent=indent))
  }

  # Convert raw vectors
  rawvars <- which(vapply(x, is.raw, logical(1)))
  for (i in rawvars) {
    x[[i]] <- as.character.hexmode(x[[i]])
  }

  # Turn complex vectors into data frames
  if(complex == "list"){
    complxvars <- which(vapply(x, is.complex, logical(1)))
    for (i in complxvars) {
      x[[i]] <- data.frame(real=Re(x[[i]]), imaginary=Im(x[[i]]))
    }
  }

  #create a matrix of json elements
  dfnames <- deparse_vector(cleannames(names(x), no_dots = no_dots))
  out <- vapply(x, asJSON, character(nrow(x)), collapse=FALSE, complex = complex, na = na,
    oldna = oldna, rownames = rownames, dataframe = dataframe, indent = indent + 2L,
    no_dots = no_dots, ..., USE.NAMES = FALSE)

  # This would be another way of doing the missing values
  # This does not require the individual classes to support na="NA"
  #if(identical(na, "NA")){
  #  namatrix <- vapply(x, is.na, logical(nrow(x)))
  #  out[namatrix] <- NA;
  #}

  #this is a workaround for vapply simplifying into a vector for n=1 (not for n=0 surprisingly)
  if(!is.matrix(out)){
    out <- t(out)
  }

  # turn the matrix into json records
  # note: special row_collapse functions because apply is slow!
  tmp <- if(dataframe == "rows" && (length(dfnames) == ncol(out))) {
    #apply(out, 1, collapse_object, x = dfnames, indent = indent + 2L);
    row_collapse_object(dfnames, out, indent = indent + 2L)
  } else {
    # for dataframe = "values"
    #apply(out, 1, collapse, indent = indent);
    row_collapse(out, indent = indent)
  }

  #collapse
  if(isTRUE(collapse)){
    collapse(tmp, inner = FALSE, indent = indent)
  } else {
    tmp
  }
})

is.namedlistnotdf <- function(x){
  isTRUE(is.list(x) && !is.data.frame(x) && !is.null(names(x)))
}

#This file runs all unit tests on every R CMD check.
#Comment this out to disable.

library(testthat)

#filter is to disable tests that rely on external servers
test_check("jsonlite", filter="toJSON|fromJSON|libjson|serializeJSON")

# If an object has already been encoded by toJSON(), do not encode it again
setMethod("asJSON", "json", function(x, json_verbatim = FALSE, ...) {
  if(isTRUE(json_verbatim)){
    x
  } else {
    asJSON(as.character(x), ...)
  }
})

warn_keep_vec_names <- function() {
  message("Input to asJSON(keep_vec_names=TRUE) is a named vector. ",
    "In a future version of jsonlite, this option will not be supported, ",
    "and named vectors will be translated into arrays instead of objects. ",
    "If you want JSON object output, please use a named list instead. See ?toJSON.")
}

#' @method print json
#' @export
print.json <- function(x, ...){
  cat(x, "\n")
}

#' @method print scalar
#' @export
print.scalar <- function(x, ...){
  original <- x;
  class(x) <- class(x)[-1]
  if(is.data.frame(x)){
    row.names(x) <- "[x]"
    print(x)
  } else {
    cat("[x] ", asJSON(x, collapse = FALSE), "\n", sep="")
  }
  invisible(original)
}

#' @import methods
setMethod("asJSON", "ANY", function(x, force = FALSE, ...) {
  if (isS4(x) && !is(x, "classRepresentation")) {
    if (isTRUE(force)) {
      return(asJSON(attributes(x), force = force, ...))
    } else {
      stop("No method for S4 class:", class(x))
    }
  } else if (length(class(x)) > 1) {
    # If an object has multiple classes, we recursively try the next class. This is
    # S3 style dispatching that doesn't work by default for formal method definitions
    # There should be a more native way to accomplish this
    return(asJSON(structure(x, class = class(x)[-1]), force = force, ...))
  } else if (isTRUE(force) && existsMethod("asJSON", class(unclass(x)))) {
    # As a last resort we can force encoding using the unclassed object
    return(asJSON(unclass(x), force = force, ...))
  } else if (isTRUE(force)) {
    return(asJSON(NULL))
    warning("No method asJSON S3 class: ", class(x))
  } else {
    # If even that doesn't work, we give up.
    stop("No method asJSON S3 class: ", class(x))
  }
})

# Note that this is different from RJSONIO because null values are NA.
setMethod("asJSON", "NULL", function(x, null = "list", ...) {
  if(null == "null"){
    return("null")
  } else {
    return("{}")
  }
})

#' @import methods
setMethod("asJSON", "ANY", function(x, force = FALSE, ...) {
  if (isS4(x) && !is(x, "classRepresentation")) {
    if (isTRUE(force)) {
      return(asJSON(attributes(x), force = force, ...))
    } else {
      stop("No method for S4 class:", class(x))
    }
  } else if (length(class(x)) > 1) {
    # If an object has multiple classes, we recursively try the next class. This is
    # S3 style dispatching that doesn't work by default for formal method definitions
    # There should be a more native way to accomplish this
    return(asJSON(structure(x, class = class(x)[-1]), force = force, ...))
  } else if (isTRUE(force) && existsMethod("asJSON", class(unclass(x))[1])) {
    # As a last resort we can force encoding using the unclassed object
    return(asJSON(unclass(x), force = force, ...))
  } else if (isTRUE(force)) {
    return(asJSON(NULL))
    warning("No method asJSON S3 class: ", class(x))
  } else {
    # If even that doesn't work, we give up.
    stop("No method asJSON S3 class: ", class(x))
  }
})

#' @rdname fromJSON
toJSON <- function(x, dataframe = c("rows", "columns", "values"), matrix = c("rowmajor", "columnmajor"),
  Date = c("ISO8601", "epoch"), POSIXt = c("string", "ISO8601", "epoch", "mongo"),
  factor = c("string", "integer"), complex = c("string", "list"), raw = c("base64", "hex", "mongo", "int", "js"),
  null = c("list", "null"), na = c("null", "string"), auto_unbox = FALSE, digits = 4,
  pretty = FALSE, force = FALSE, ...) {

  # validate args
  dataframe <- match.arg(dataframe)
  matrix <- match.arg(matrix)
  Date <- match.arg(Date)
  POSIXt <- match.arg(POSIXt)
  factor <- match.arg(factor)
  complex <- match.arg(complex)
  raw <- match.arg(raw)
  null <- match.arg(null)

  # force
  x <- force(x)

  #this is just to check, we keep method-specific defaults
  if(!missing(na)){
    na <- match.arg(na)
  } else {
    na <- NULL
  }

  indent <- if (isTRUE(pretty)) 0L else NA_integer_

  # dispatch
  ans <- asJSON(x, dataframe = dataframe, Date = Date, POSIXt = POSIXt, factor = factor,
    complex = complex, raw = raw, matrix = matrix, auto_unbox = auto_unbox, digits = digits,
    na = na, null = null, force = force, indent = indent, ...)

  #prettify with yajl
  if(is.numeric(pretty)) {
    prettify(ans, pretty)
  } else {
    class(ans) <- "json"
    return(ans)
  }
}

test_that("fromJSON date objects", {
  x <- Sys.time() + c(1, 2, NA, 3)
  mydf <- data.frame(x = x)
  expect_s3_class(fromJSON(toJSON(x, POSIXt = "mongo")), "POSIXct")
  expect_equal(fromJSON(toJSON(x, POSIXt = "mongo")), x)
  #expect_s3_class(fromJSON(toJSON(x, POSIXt="mongo", na="string")), "POSIXct");
  expect_s3_class(fromJSON(toJSON(x, POSIXt = "mongo", na = "null")), "POSIXct")

  expect_s3_class(fromJSON(toJSON(mydf, POSIXt = "mongo")), "data.frame")
  expect_s3_class(fromJSON(toJSON(mydf, POSIXt = "mongo"))$x, "POSIXct")
  #expect_s3_class(fromJSON(toJSON(mydf, POSIXt="mongo", na="string"))$x, "POSIXct");
  expect_s3_class(fromJSON(toJSON(mydf, POSIXt = "mongo", na = "null"))$x, "POSIXct")
  expect_equal(fromJSON(toJSON(mydf, POSIXt = "mongo"))$x, x)

  xct <- as.POSIXct(x)
  xlt <- as.POSIXlt(x)

  expect_equal(xct, xlt)
  expect_true(unbox(xct[1]) == unbox(xlt[1]))
  xct3un <- unbox(xct[3])
  expect_true(is.na(xct3un) && inherits(xct3un, "scalar") && inherits(xct3un, "POSIXt"))
  xlt3un <- unbox(xlt[3])
  expect_true(is.na(xlt3un) && inherits(xlt3un, "scalar") && inherits(xlt3un, "POSIXt"))

  expect_equal(toJSON(xct, POSIXt = "mongo"), toJSON(xlt, POSIXt = "mongo"))
  expect_equal(toJSON(unbox(xct[1]), POSIXt = "mongo"), toJSON(unbox(xlt[1]), POSIXt = "mongo"))
})

test_that("Encoding Numbers", {
  expect_equal(toJSON(35), "[35]")
  expect_equal(toJSON(35L), "[35]")
  expect_equal(toJSON(c(35, pi), digits = 5), "[35,3.14159]")
  expect_equal(toJSON(pi, digits = 0), "[3]")
  expect_equal(toJSON(pi, digits = 2), "[3.14]")
  expect_equal(toJSON(pi, digits = 10), "[3.1415926536]")
  expect_equal(toJSON(c(pi, NA), na = "string", digits = 5), "[3.14159,\"NA\"]")
  expect_equal(toJSON(c(pi, NA), na = "null", digits = 5), "[3.14159,null]")
  expect_equal(toJSON(c(pi, NA), na = "null", digits = 5), "[3.14159,null]")
  expect_equal(toJSON(c(1478002353.51369, -521997646.486311) * 1000, digits = 0), "[1478002353514,-521997646486]")
  expect_equal(toJSON(list(a = c(0.1)), digits = NA), '{"a":[0.1]}')
})

test_that("Encoding Numbers in Data Frame", {
  expect_equal(toJSON(data.frame(foo = 35)), "[{\"foo\":35}]")
  expect_equal(toJSON(data.frame(foo = 35L)), "[{\"foo\":35}]")
  expect_equal(toJSON(data.frame(foo = c(35, pi)), digits = 5), "[{\"foo\":35},{\"foo\":3.14159}]")
  expect_equal(toJSON(data.frame(foo = pi), digits = 0), "[{\"foo\":3}]")
  expect_equal(toJSON(data.frame(foo = pi), digits = 2), "[{\"foo\":3.14}]")
  expect_equal(toJSON(data.frame(foo = pi), digits = 10), "[{\"foo\":3.1415926536}]")
  expect_equal(toJSON(data.frame(foo = c(pi, NA)), digits = 5), "[{\"foo\":3.14159},{}]")
  expect_equal(toJSON(data.frame(foo = c(pi, NA)), na = "string", digits = 5), "[{\"foo\":3.14159},{\"foo\":\"NA\"}]")
  expect_equal(toJSON(data.frame(foo = c(pi, NA)), na = "null", digits = 5), "[{\"foo\":3.14159},{\"foo\":null}]")
})

test_that("Force decimal works", {
  # Force decimal for doubles
  expect_equal(toJSON(100), '[100]')
  expect_equal(toJSON(100, always_decimal = TRUE), '[100.0]')
  expect_equal(toJSON(12.000000000001, always_decimal = TRUE), '[12.0]')

  # But not for integers
  expect_equal(toJSON(100L), '[100]')
  expect_equal(toJSON(100L, always_decimal = TRUE), '[100]')

  # Test range
  x <- 10^c(-15:20)
  x1 <- c(rev(-x), x)
  x2 <- 1.2345 * x1
  expect_equal(as.list(x1), fromJSON(toJSON(x1), simplifyVector = FALSE))
  expect_equal(as.list(x2), fromJSON(toJSON(x2, digits = 9), simplifyVector = FALSE))

  # always_decimal makes sure that doubles stay real
  y2 <- fromJSON(toJSON(x1, digits = 9, always_decimal = TRUE), simplifyVector = FALSE)
  expect_identical(as.list(x1), y2)
})

test_that("fromJSON Array, row major", {
  # test high dimensional arrays
  lapply(2:5, function(n) {
    object <- array(1:prod(n), dim = 1:n)
    newobject <- fromJSON(toJSON(object))
    expect_equal(object, newobject)
  })

  # adding some flat dimensions
  lapply(1:5, function(n) {
    object <- array(1:prod(n), dim = c(1:n, 1))
    newobject <- fromJSON(toJSON(object))
    expect_equal(object, newobject)
  })
})

test_that("fromJSON Array, column major", {
  # test high dimensional arrays
  lapply(2:5, function(n) {
    object <- array(1:prod(n), dim = 1:n)
    newobject <- fromJSON(toJSON(object, matrix = "columnmajor"), columnmajor = TRUE)
    expect_equal(object, newobject)
  })

  # adding some flat dimensions
  lapply(1:5, function(n) {
    object <- array(1:prod(n), dim = c(1:n, 1))
    newobject <- fromJSON(toJSON(object, matrix = "columnmajor"), columnmajor = TRUE)
    expect_equal(object, newobject)
  })
})


test_that("fromJSON Array, character strings", {
  # test high dimensional arrays
  lapply(2:5, function(n) {
    object <- array(paste("cell", 1:prod(n)), dim = 1:n)
    newobject <- fromJSON(toJSON(object, matrix = "columnmajor"), columnmajor = TRUE)
    expect_equal(object, newobject)
  })

  # adding some flat dimensions
  lapply(1:5, function(n) {
    object <- array(paste("cell", 1:prod(n)), dim = c(1:n, 1))
    newobject <- fromJSON(toJSON(object, matrix = "columnmajor"), columnmajor = TRUE)
    expect_equal(object, newobject)
  })
})

objects <- list(
  as.POSIXlt("2013-06-17 22:33:44"),
  as.POSIXct("2013-06-17 22:33:44"),
  as.POSIXlt("2013-06-17 22:33:44", tz = "Australia/Darwin"),
  as.POSIXct("2013-06-17 22:33:44", tz = "Australia/Darwin")
)

test_that("Encoding POSIXt Objects", {
  #string based formats do not depends on the current local timezone
  invisible(lapply(objects, function(object) {
    expect_equal(toJSON(object), "[\"2013-06-17 22:33:44\"]")
    expect_equal(toJSON(object, POSIXt = "string"), "[\"2013-06-17 22:33:44\"]")
    expect_equal(toJSON(object, POSIXt = "ISO8601"), "[\"2013-06-17T22:33:44\"]")
    expect_error(toJSON(object, POSIXt = "sdfsdsdf"), "one of")
  }))

  #object 1 and 2 will result in a location specific epoch
  invisible(lapply(objects[3:4], function(object) {
    expect_equal(toJSON(object, POSIXt = "epoch"), "[1371474224000]")
    expect_equal(toJSON(object, POSIXt = "mongo"), "[{\"$date\":1371474224000}]")
  }))
})

test_that("Encoding POSIXt object in a list", {
  #string based formats do not depends on the current local timezone
  invisible(lapply(objects, function(object) {
    expect_equal(toJSON(list(foo = object)), "{\"foo\":[\"2013-06-17 22:33:44\"]}")
    expect_equal(toJSON(list(foo = object), POSIXt = "string"), "{\"foo\":[\"2013-06-17 22:33:44\"]}")
    expect_equal(toJSON(list(foo = object), POSIXt = "ISO8601"), "{\"foo\":[\"2013-06-17T22:33:44\"]}")
    expect_error(toJSON(list(foo = object), POSIXt = "sdfsdsdf"), "one of")
  }))

  #list(foo=object) 1 and 2 will result in a location specific epoch
  invisible(lapply(objects[3:4], function(object) {
    expect_equal(toJSON(list(foo = object), POSIXt = "epoch"), "{\"foo\":[1371474224000]}")
    expect_equal(toJSON(list(foo = object), POSIXt = "mongo"), "{\"foo\":[{\"$date\":1371474224000}]}")
  }))
})

test_that("Encoding POSIXt object in a list", {
  #string based formats do not depends on the current local timezone
  invisible(lapply(objects, function(object) {
    expect_equal(toJSON(data.frame(foo = object)), "[{\"foo\":\"2013-06-17 22:33:44\"}]")
    expect_equal(toJSON(data.frame(foo = object), POSIXt = "string"), "[{\"foo\":\"2013-06-17 22:33:44\"}]")
    expect_equal(toJSON(data.frame(foo = object), POSIXt = "ISO8601"), "[{\"foo\":\"2013-06-17T22:33:44\"}]")
    expect_error(toJSON(data.frame(foo = object), POSIXt = "sdfsdsdf"), "one of")
  }))

  #list(foo=object) 1 and 2 will result in a location specific epoch
  invisible(lapply(objects[3:4], function(object) {
    expect_equal(toJSON(data.frame(foo = object), POSIXt = "epoch"), "[{\"foo\":1371474224000}]")
    expect_equal(toJSON(data.frame(foo = object), POSIXt = "mongo"), "[{\"foo\":{\"$date\":1371474224000}}]")
  }))
})

test_that("POSIXt NA values", {
  newobj <- list(
    c(objects[[1]], NA),
    c(objects[[2]], NA)
  )
  lapply(newobj, function(object) {
    expect_equal(toJSON(object), "[\"2013-06-17 22:33:44\",null]")
    expect_equal(toJSON(object, na = "string"), "[\"2013-06-17 22:33:44\",\"NA\"]")
    expect_equal(toJSON(data.frame(foo = object)), "[{\"foo\":\"2013-06-17 22:33:44\"},{}]")
    expect_equal(toJSON(data.frame(foo = object), na = "null"), "[{\"foo\":\"2013-06-17 22:33:44\"},{\"foo\":null}]")
    expect_equal(toJSON(data.frame(foo = object), na = "string"), "[{\"foo\":\"2013-06-17 22:33:44\"},{\"foo\":\"NA\"}]")
  })

  tzobj <- list(
    c(objects[[3]], NA),
    c(objects[[4]], NA)
  )
  lapply(tzobj, function(object) {
    expect_equal(toJSON(object, POSIXt = "mongo"), "[{\"$date\":1371474224000},null]")
    expect_equal(toJSON(object, POSIXt = "mongo", na = "string"), "[{\"$date\":1371474224000},\"NA\"]")
    expect_equal(toJSON(data.frame(foo = object), POSIXt = "mongo"), "[{\"foo\":{\"$date\":1371474224000}},{}]")
    expect_equal(toJSON(data.frame(foo = object), POSIXt = "mongo", na = "null"), "[{\"foo\":{\"$date\":1371474224000}},{\"foo\":null}]")
    expect_equal(toJSON(data.frame(foo = object), POSIXt = "mongo", na = "string"), "[{\"foo\":{\"$date\":1371474224000}},{\"foo\":\"NA\"}]")
  })
})

test_that("Negative dates", {
  x <- objects[[2]]
  y <- x - c(1e9, 2e9, 3e9)
  expect_equal(fromJSON(toJSON(y, POSIXt = "mongo")), y)
})

test_that("Encoding Logical", {
  expect_equal(toJSON(TRUE), "[true]")
  expect_equal(toJSON(FALSE), "[false]")
  expect_equal(toJSON(as.logical(NA)), "[null]")
  expect_equal(toJSON(as.logical(NA), na = "string"), "[\"NA\"]")
  expect_equal(toJSON(c(TRUE, NA, FALSE)), "[true,null,false]")
  expect_equal(toJSON(c(TRUE, NA, FALSE), na = "string"), "[true,\"NA\",false]")
  expect_equal(toJSON(logical()), "[]")
})

test_that("Encoding Logical in Data Frame", {
  expect_equal(toJSON(data.frame(foo = TRUE)), "[{\"foo\":true}]")
  expect_equal(toJSON(data.frame(foo = FALSE)), "[{\"foo\":false}]")
  expect_equal(toJSON(data.frame(foo = as.logical(NA))), "[{}]")
  expect_equal(toJSON(data.frame(foo = as.logical(NA)), na = "null"), "[{\"foo\":null}]")
  expect_equal(toJSON(data.frame(foo = as.logical(NA)), na = "string"), "[{\"foo\":\"NA\"}]")
  expect_equal(toJSON(data.frame(foo = c(TRUE, NA, FALSE))), "[{\"foo\":true},{},{\"foo\":false}]")
  expect_equal(toJSON(data.frame(foo = logical())), "[]")
})

test_that("Encoding Factor Objects", {
  expect_identical(toJSON(character()), "[]")
  expect_identical(toJSON(logical()), "[]")
  expect_identical(toJSON(complex()), "[]")
  expect_identical(toJSON(complex(), complex = "list"), "{\"real\":[],\"imaginary\":[]}")
  expect_identical(toJSON(double()), "[]")
  expect_identical(toJSON(integer()), "[]")
  expect_identical(toJSON(list()), "[]")
  expect_identical(toJSON(factor()), "[]")
  expect_identical(toJSON(factor(levels = c("foo", "bar"))), "[]")
  expect_identical(toJSON(matrix(nrow = 0, ncol = 0)), "[]")
  expect_identical(toJSON(as.matrix(numeric())), "[]")
  expect_identical(toJSON(data.frame()), "[]")
  expect_identical(toJSON(data.frame(foo = vector())), "[]")
  expect_identical(toJSON(data.frame(foo = vector(), bar = logical())), "[]")
  expect_identical(toJSON(Sys.time()[0], POSIXt = "string"), "[]")
  expect_identical(toJSON(Sys.time()[0], POSIXt = "epoch"), "[]")
  expect_identical(toJSON(Sys.time()[0], POSIXt = "mongo"), "[]")
  expect_identical(toJSON(Sys.time()[0], POSIXt = "ISO8601"), "[]")
  expect_identical(toJSON(as.Date(Sys.time())[0], POSIXt = "ISO8601"), "[]")
})

test_that("Encoding AsIs", {
  expect_equal(toJSON(list(1), auto_unbox = TRUE), "[1]")
  expect_equal(toJSON(list(I(1)), auto_unbox = TRUE), "[[1]]")
  expect_equal(toJSON(I(list(1)), auto_unbox = TRUE), "[1]")

  expect_equal(toJSON(list(x = 1)), "{\"x\":[1]}")
  expect_equal(toJSON(list(x = 1), auto_unbox = TRUE), "{\"x\":1}")
  expect_equal(toJSON(list(x = I(1)), auto_unbox = TRUE), "{\"x\":[1]}")

  expect_equal(toJSON(list(x = I(list(1))), auto_unbox = TRUE), "{\"x\":[1]}")
  expect_equal(toJSON(list(x = list(I(1))), auto_unbox = TRUE), "{\"x\":[[1]]}")
})

context("flatten")

test_that("flattening", {
  x <- list(test = data.frame(foo=1:3))
  x$test$bar <- data.frame(x=5:3, y=7:9)
  expect_that(x, equals(fromJSON(toJSON(x), flatten = FALSE)));
  expect_that(names(fromJSON(toJSON(x), flatten = TRUE)$test), equals(c("foo", "bar.x", "bar.y")))
});

test_that("Test NA values", {
  options(stringsAsFactors = FALSE)
  x <- list(foo = c(TRUE, NA, FALSE, TRUE), bar = c(3.14, NA, 42, NA), zoo = c(NA, "bla", "boe", NA))
  x$mydf <- data.frame(col1 = c(FALSE, NA, NA, TRUE), col2 = c(1.23, NA, 23, NA))
  x$mydf$mylist <- list(c(TRUE, NA, FALSE, NA), NA, c("blabla", NA), c(NA, 12, 13, NA, NA, NA, 1001))

  expect_true(validate(toJSON(x)))
  expect_equal(fromJSON(toJSON(x)), x)
  expect_equal(fromJSON(toJSON(x, na = "null")), x)
})

context("toJSON Numeric")

test_that("Encoding Numbers", {
  expect_that(toJSON(35), equals("[35]"));
  expect_that(toJSON(35L), equals("[35]"));
  expect_that(toJSON(c(35, pi), digits=5), equals("[35,3.14159]"));
  expect_that(toJSON(pi, digits=0), equals("[3]"));
  expect_that(toJSON(pi, digits=2), equals("[3.14]"));
  expect_that(toJSON(pi, digits=10), equals("[3.1415926536]"));
  expect_that(toJSON(c(pi, NA), na="string", digits=5), equals("[3.14159,\"NA\"]"));
  expect_that(toJSON(c(pi, NA), na="null", digits=5), equals("[3.14159,null]"));
  expect_that(toJSON(c(pi, NA), na="null", digits=5), equals("[3.14159,null]"));
  expect_that(toJSON(c(1478002353.51369, -521997646.486311) * 1000, digits = 0), equals("[1478002353514,-521997646486]"));
});

test_that("Encoding Numbers in Data Frame", {
  expect_that(toJSON(data.frame(foo=35)), equals("[{\"foo\":35}]"));
  expect_that(toJSON(data.frame(foo=35L)), equals("[{\"foo\":35}]"));
  expect_that(toJSON(data.frame(foo=c(35, pi)), digits=5), equals("[{\"foo\":35},{\"foo\":3.14159}]"));
  expect_that(toJSON(data.frame(foo=pi), digits=0), equals("[{\"foo\":3}]"));
  expect_that(toJSON(data.frame(foo=pi), digits=2), equals("[{\"foo\":3.14}]"));
  expect_that(toJSON(data.frame(foo=pi), digits=10), equals("[{\"foo\":3.1415926536}]"));
  expect_that(toJSON(data.frame(foo=c(pi, NA)), digits=5), equals("[{\"foo\":3.14159},{}]"));
  expect_that(toJSON(data.frame(foo=c(pi, NA)), na="string", digits=5), equals("[{\"foo\":3.14159},{\"foo\":\"NA\"}]"));
  expect_that(toJSON(data.frame(foo=c(pi, NA)), na="null", digits=5), equals("[{\"foo\":3.14159},{\"foo\":null}]"));
});

test_that("Force decimal works", {
  # Force decimal for doubles
  expect_equal(toJSON(100), '[100]')
  expect_equal(toJSON(100, always_decimal = TRUE), '[100.0]')
  expect_equal(toJSON(12.000000000001, always_decimal = TRUE), '[12.0]')

  # But not for integers
  expect_equal(toJSON(100L), '[100]')
  expect_equal(toJSON(100L, always_decimal = TRUE), '[100]')

  # Test range
  x <- 10^c(-15 : 20)
  x1 <- c(rev(-x), x)
  x2 <- 1.2345 * x1
  expect_equal(as.list(x1), fromJSON(toJSON(x1), simplifyVector = FALSE))
  expect_equal(as.list(x2), fromJSON(toJSON(x2, digits = 9), simplifyVector = FALSE))

  # always_decimal makes sure that doubles stay real
  y2 <- fromJSON(toJSON(x1, digits = 9, always_decimal = TRUE), simplifyVector = FALSE)
  expect_identical(as.list(x1), y2)
})

test_that("flattening", {
  x <- list(test = data.frame(foo=1:3))
  x$test$bar <- data.frame(x=5:3, y=7:9)
  expect_equal(x, fromJSON(toJSON(x), flatten = FALSE));
  expect_equal(names(fromJSON(toJSON(x), flatten = TRUE)$test), c("foo", "bar.x", "bar.y"));
});

test_that("data frame edge cases", {
  #unname named list
  test <- data.frame(foo = 1:2)
  test$bar <- list(x = 123, y = 123)
  test$baz <- data.frame(z = 456:457)
  expect_equal(toJSON(test), '[{"foo":1,"bar":[123],"baz":{"z":456}},{"foo":2,"bar":[123],"baz":{"z":457}}]')
})

test_that("Nested structures", {
  mydata <- data.frame(row.names = 1:2)
  mydata$d <- list(
    data.frame(a1 = 1:2, a2 = 3:4, a3 = 5:6, a4 = 7:8),
    data.frame(a1 = 11:12, a2 = 13:14, a3 = 15:16, a4 = 17:18)
  )
  mydata$m <- list(
    matrix(1:6, nrow = 2, ncol = 3),
    matrix(6:1, nrow = 2, ncol = 3)
  )

  expect_equal(fromJSON(toJSON(mydata)), mydata)
})

test_that("Encoding a Matrix", {
  expect_equal(toJSON(matrix(1)), "[[1]]")
  expect_equal(toJSON(matrix(pi), digits = 5), "[[3.14159]]")
  expect_equal(toJSON(matrix(1:2)), "[[1],[2]]")
  expect_equal(toJSON(matrix(1:2, nrow = 1)), "[[1,2]]")
  expect_equal(toJSON(matrix(state.x77[1, 1, drop = FALSE])), "[[3615]]")
})

# Note about numeric precision
# In the unit tests we use digits=10. Lowever values will result in problems for some datasets
test_that("fromJSON datasets", {
  objects <- Filter(is.data.frame, lapply(ls("package:datasets"), get))

  #data frames are never identical because:
  # - attributes
  # - factors, times, dates turn into strings
  # - integers turn into numeric
  lapply(objects, function(object) {
    newobject <- fromJSON(toJSON(object))
    expect_s3_class(newobject, "data.frame")
    expect_identical(sort(names(object)), sort(names(newobject)))
    expect_identical(nrow(object), nrow(newobject))
  })
})

object <- as.Date("1985-06-18")

test_that("Encoding Date Objects", {
  expect_equal(toJSON(object), "[\"1985-06-18\"]")
  expect_equal(toJSON(object, Date = "ISO8601"), "[\"1985-06-18\"]")
  expect_equal(toJSON(object, Date = "epoch"), "[5647]")
  expect_error(toJSON(object, Date = "adsfdsfds"), "should be one of")
})

test_that("Encoding Date Objects in a list", {
  expect_equal(toJSON(list(foo = object)), "{\"foo\":[\"1985-06-18\"]}")
  expect_equal(toJSON(list(foo = object), Date = "ISO8601"), "{\"foo\":[\"1985-06-18\"]}")
  expect_equal(toJSON(list(foo = object), Date = "epoch"), "{\"foo\":[5647]}")
  expect_error(toJSON(list(foo = object), Date = "adsfdsfds"), "should be one of")
})

test_that("Encoding Date Objects in a Data frame", {
  expect_equal(toJSON(data.frame(foo = object)), "[{\"foo\":\"1985-06-18\"}]")
  expect_equal(toJSON(data.frame(foo = object), Date = "ISO8601"), "[{\"foo\":\"1985-06-18\"}]")
  expect_equal(toJSON(data.frame(foo = object), Date = "epoch"), "[{\"foo\":5647}]")
  expect_error(toJSON(data.frame(foo = object), Date = "adsfdsfds"), "should be one of")
})

test_that("Encoding Numbers", {
  expect_equal(toJSON(35), "[35]");
  expect_equal(toJSON(35L), "[35]");
  expect_equal(toJSON(c(35, pi), digits=5), "[35,3.14159]");
  expect_equal(toJSON(pi, digits=0), "[3]");
  expect_equal(toJSON(pi, digits=2), "[3.14]");
  expect_equal(toJSON(pi, digits=10), "[3.1415926536]");
  expect_equal(toJSON(c(pi, NA), na="string", digits=5), "[3.14159,\"NA\"]");
  expect_equal(toJSON(c(pi, NA), na="null", digits=5), "[3.14159,null]");
  expect_equal(toJSON(c(pi, NA), na="null", digits=5), "[3.14159,null]");
  expect_equal(toJSON(c(1478002353.51369, -521997646.486311) * 1000, digits = 0), "[1478002353514,-521997646486]");
  expect_equal(toJSON(list(a=c(0.1)), digits = NA), '{"a":[0.1]}');
});

test_that("Encoding Numbers in Data Frame", {
  expect_equal(toJSON(data.frame(foo=35)), "[{\"foo\":35}]");
  expect_equal(toJSON(data.frame(foo=35L)), "[{\"foo\":35}]");
  expect_equal(toJSON(data.frame(foo=c(35, pi)), digits=5), "[{\"foo\":35},{\"foo\":3.14159}]");
  expect_equal(toJSON(data.frame(foo=pi), digits=0), "[{\"foo\":3}]");
  expect_equal(toJSON(data.frame(foo=pi), digits=2), "[{\"foo\":3.14}]");
  expect_equal(toJSON(data.frame(foo=pi), digits=10), "[{\"foo\":3.1415926536}]");
  expect_equal(toJSON(data.frame(foo=c(pi, NA)), digits=5), "[{\"foo\":3.14159},{}]");
  expect_equal(toJSON(data.frame(foo=c(pi, NA)), na="string", digits=5), "[{\"foo\":3.14159},{\"foo\":\"NA\"}]");
  expect_equal(toJSON(data.frame(foo=c(pi, NA)), na="null", digits=5), "[{\"foo\":3.14159},{\"foo\":null}]");
});

test_that("Force decimal works", {
  # Force decimal for doubles
  expect_equal(toJSON(100), '[100]')
  expect_equal(toJSON(100, always_decimal = TRUE), '[100.0]')
  expect_equal(toJSON(12.000000000001, always_decimal = TRUE), '[12.0]')

  # But not for integers
  expect_equal(toJSON(100L), '[100]')
  expect_equal(toJSON(100L, always_decimal = TRUE), '[100]')

  # Test range
  x <- 10^c(-15 : 20)
  x1 <- c(rev(-x), x)
  x2 <- 1.2345 * x1
  expect_equal(as.list(x1), fromJSON(toJSON(x1), simplifyVector = FALSE))
  expect_equal(as.list(x2), fromJSON(toJSON(x2, digits = 9), simplifyVector = FALSE))

  # always_decimal makes sure that doubles stay real
  y2 <- fromJSON(toJSON(x1, digits = 9, always_decimal = TRUE), simplifyVector = FALSE)
  expect_identical(as.list(x1), y2)
})

options(stringsAsFactors = FALSE)

test_that("recover nested data frames", {
  x1 <- x2 <- x3 <- x4 <- x5 <- x6 <- data.frame(foo = c(1:2))
  x2$bar <- c("jeroen", "eli")
  x3$bar <- x4$bar <- x5$bar <- x6$bar <- data.frame(name = c("jeroen", "eli"))
  x4$bar$age <- x5$bar$age <- c(28, 24)
  x6$bar$age <- c(28, NA)
  x5$bar$food <- data.frame(yum = c("Rice", "Pasta"))
  x6$bar$food <- data.frame(yum = c(NA, "Pasta"))

  #add to list
  objects <- list(x1, x2, x3, x4, x5, x6)

  #test all but list
  lapply(objects, function(object) {
    expect_equal(fromJSON(toJSON(object)), object)
    expect_equal(fromJSON(toJSON(object, na = "null")), object)
    expect_equal(names(fromJSON(toJSON(object), flatten = TRUE)), names(unlist(object[1, , drop = FALSE])))
  })

  #test all in list
  expect_equal(fromJSON(toJSON(objects)), objects)
})

test_that("recover lists in data frames", {
  x <- data.frame(author = c("Homer", "Virgil", "Jeroen"))
  x$poems = list(c("Iliad", "Odyssey"), c("Eclogues", "Georgics", "Aeneid"), character())

  y <- data.frame(author = c("Homer", "Virgil", "Jeroen"))
  y$poems = list(
    data.frame(title = c("Iliad", "Odyssey"), year = c(-1194, -800)),
    data.frame(title = c("Eclogues", "Georgics", "Aeneid"), year = c(-44, -29, -19)),
    data.frame()
  )

  z <- list(x = x, y = y)
  zz <- list(x, y)

  expect_equal(fromJSON(toJSON(x)), x)
  expect_equal(fromJSON(toJSON(y)), y)
  expect_equal(fromJSON(toJSON(z)), z)
  expect_equal(fromJSON(toJSON(zz)), zz)
})

#note: nested matrix does not perfectly restore
test_that("nested matrix in data frame", {
  x <- data.frame(foo = 1:2)
  x$bar <- matrix(c(1:5, NA), 2)

  expect_true(validate(toJSON(x)))

  y <- fromJSON(toJSON(x))
  expect_s3_class(y, "data.frame")
  expect_equal(names(x), names(y))
  expect_equal(length(y[[1, "bar"]]), 3)
})

test_that("escaping and parsing of special characters", {
  #create random strings
  mychars <- c('a', 'b', " ", '"', "\\", "\t", "\n", "'", "/", "#", "$")
  createstring <- function(length) {
    paste(mychars[ceiling(runif(length, 0, length(mychars)))], collapse = "")
  }

  #try some very long strings
  for (i in 1:10) {
    zz <- list(foo = createstring(1e5))
    expect_equal(zz, fromJSON(toJSON(zz)))
  }
})

# Note about numeric precision
# In the unit tests we use digits=10. Lowever values will result in problems for some datasets
test_that("fromJSON Matrix", {
  objects <- list(
    matrix(1),
    matrix(1:2),
    matrix(1:2, nrow = 1),
    matrix(round(pi, 2)),
    matrix(c(1, NA, 2, NA), 2),
    volcano,
    matrix(NA)
  )

  lapply(objects, function(object) {
    newobject <- fromJSON(toJSON(object))
    expect_true(inherits(newobject, "matrix"))
    expect_equal(object, newobject)
  })

  expect_equal(fromJSON(toJSON(objects)), objects)
})

test_that("fromJSON Matrix with simplifyMatrix=FALSE", {
  expect_equal(fromJSON(toJSON(matrix(1)), simplifyMatrix = FALSE), list(1))
  expect_equal(fromJSON(toJSON(matrix(1)), simplifyVector = FALSE), list(list((1))))
  expect_equal(fromJSON(toJSON(matrix(NA)), simplifyMatrix = FALSE), list(NA))
  expect_equal(fromJSON(toJSON(matrix(NA)), simplifyVector = FALSE), list(list((NULL))))
})


test_that("fromJSON Matrix datasets", {
  objects <- Filter(is.matrix, lapply(ls("package:datasets"), get))

  lapply(objects, function(object) {
    class(object) <- "matrix"
    newobject <- fromJSON(toJSON(object, digits = 4))
    expect_true(inherits(newobject, "matrix"))
    expect_equal(dim(newobject), dim(object))
    attributes(newobject) <- attributes(object)

    # R has changed rounding algo in 4.0 and no longer matches printf
    #expect_equal(newobject, round(object,4));
    expect_equal(newobject, object, tolerance = 1e-4)
  })
})

test_that("flattening", {
  x <- list(test = data.frame(foo = 1:3))
  x$test$bar <- data.frame(x = 5:3, y = 7:9)
  expect_equal(x, fromJSON(toJSON(x), flatten = FALSE))
  expect_equal(names(fromJSON(toJSON(x), flatten = TRUE)$test), c("foo", "bar.x", "bar.y"))
})

test_that("Encoding Factor Objects", {
  expect_identical(fromJSON(toJSON(iris$Species)), as.character(iris$Species))
  expect_identical(fromJSON(toJSON(iris$Species[1])), as.character(iris$Species[1]))
  expect_equal(fromJSON(toJSON(iris$Species, factor = "integer")), structure(unclass(iris$Species), levels = NULL))
})

test_that("fromJSON NA values", {
  objects <- list(
    numbers = c(1, 2, NA, NaN, Inf, -Inf, 3.14),
    logical = c(TRUE, FALSE, NA),
    integers = as.integer(1, 2, 3),
    num = 3.14,
    bool = FALSE,
    character = c("FOO", "NA", NA, "NaN"),
    integer = 21L,
    boolNA = as.logical(NA),
    df = data.frame(foo = c(1, NA))
  )

  #test all but list
  lapply(objects, function(object) {
    expect_equal(fromJSON(toJSON(object)), object)
  })

  #test all in list
  expect_equal(fromJSON(toJSON(objects)), objects)
})

test_that("test that the validator properly deals with escaped characters", {
  #create random strings
  mychars <- c('a', 'b', " ", '"', "\\", "\t", "\n", "'", "/", "#", "$")
  createstring <- function(length) {
    paste(mychars[ceiling(runif(length, 0, length(mychars)))], collapse = "")
  }

  for (i in 1:200) {
    #create some random strings to validate
    x <- createstring(i)
    expect_true(validate(toJSON(x)))
  }
})

test_that("Encoding Complex", {
  expect_equal(toJSON(complex(real = 2, imaginary = 2)), "[\"2+2i\"]")
  expect_equal(toJSON(complex(real = NA, imaginary = 2)), "[\"NA\"]")
  expect_equal(toJSON(complex(real = 1, imaginary = NA)), "[\"NA\"]")
  expect_equal(toJSON(complex(real = NA, imaginary = 2), na = "null"), "[null]")
})

test_that("Encoding Complex in Data Frame", {
  expect_equal(toJSON(data.frame(foo = complex(real = 1, imaginary = 2))), "[{\"foo\":\"1+2i\"}]")
  expect_equal(toJSON(data.frame(foo = complex(real = NA, imaginary = 2))), "[{}]")
  expect_equal(toJSON(data.frame(foo = complex(real = NA, imaginary = 2)), na = "string"), "[{\"foo\":\"NA\"}]")
  expect_equal(toJSON(data.frame(foo = complex(real = NA, imaginary = 2)), na = "null"), "[{\"foo\":null}]")
})

test_that("Encoding Complex as list", {
  x <- complex(real = c(1, 2, NA), imaginary = 3:1)
  expect_equal(toJSON(x), "[\"1+3i\",\"2+2i\",\"NA\"]")
  expect_equal(toJSON(x, complex = "list"), "{\"real\":[1,2,\"NA\"],\"imaginary\":[3,2,1]}")
  expect_equal(toJSON(data.frame(foo = x), complex = "list"), "[{\"foo\":{\"real\":1,\"imaginary\":3}},{\"foo\":{\"real\":2,\"imaginary\":2}},{\"foo\":{\"imaginary\":1}}]")
  expect_equal(toJSON(data.frame(foo = x), complex = "list", na = "string"), "[{\"foo\":{\"real\":1,\"imaginary\":3}},{\"foo\":{\"real\":2,\"imaginary\":2}},{\"foo\":{\"real\":\"NA\",\"imaginary\":1}}]")
  expect_equal(toJSON(data.frame(foo = x), complex = "list", dataframe = "columns"), "{\"foo\":{\"real\":[1,2,\"NA\"],\"imaginary\":[3,2,1]}}")
})

context("toJSON NULL values")

test_that("Test NULL values", {
  namedlist <- structure(list(), .Names = character(0));
  x <- NULL
  y <- list(a=NULL, b=NA)
  z <- list(a=1, b=character(0))

  expect_true(validate(toJSON(x)))
  expect_that(fromJSON(toJSON(x)), equals(namedlist))
  expect_that(toJSON(x), equals("{}"))
  expect_that(toJSON(x, null="list"), equals("{}"))

  expect_true(validate(toJSON(y)))
  expect_that(toJSON(y, null="list"), equals("{\"a\":{},\"b\":[null]}"))
  expect_that(toJSON(y, null="null"), equals("{\"a\":null,\"b\":[null]}"))
  expect_that(fromJSON(toJSON(y, null="null")), equals(y))
  expect_that(fromJSON(toJSON(y, null="list")), equals(list(a=namedlist, b=NA)))

  expect_true(validate(toJSON(z)))
  expect_that(toJSON(z), equals("{\"a\":[1],\"b\":[]}"))
  expect_that(fromJSON(toJSON(z)), equals(list(a=1, b=list())))
});

test_that("Test NULL values", {
  namedlist <- structure(list(), .Names = character(0))
  x <- NULL
  y <- list(a = NULL, b = NA)
  z <- list(a = 1, b = character(0))

  expect_true(validate(toJSON(x)))
  expect_equal(fromJSON(toJSON(x)), namedlist)
  expect_equal(toJSON(x), "{}")
  expect_equal(toJSON(x, null = "list"), "{}")

  expect_true(validate(toJSON(y)))
  expect_equal(toJSON(y, null = "list"), "{\"a\":{},\"b\":[null]}")
  expect_equal(toJSON(y, null = "null"), "{\"a\":null,\"b\":[null]}")
  expect_equal(fromJSON(toJSON(y, null = "null")), y)
  expect_equal(fromJSON(toJSON(y, null = "list")), list(a = namedlist, b = NA))

  expect_true(validate(toJSON(z)))
  expect_equal(toJSON(z), "{\"a\":[1],\"b\":[]}")
  expect_equal(fromJSON(toJSON(z)), list(a = 1, b = list()))
})

context("toJSON Data Frame")

test_that("data frame edge cases", {
 #unname named list
  test <- data.frame(foo=1:2)
  test$bar <- list(x=123, y=123)
  test$baz <- data.frame(z=456:457)
  expect_that(toJSON(test), equals('[{"foo":1,"bar":[123],"baz":{"z":456}},{"foo":2,"bar":[123],"baz":{"z":457}}]'))
});

test_that("Nested structures", {
  
  mydata <- data.frame(row.names=1:2)
  mydata$d <- list(
    data.frame(a1=1:2, a2=3:4, a3=5:6, a4=7:8),
    data.frame(a1=11:12, a2=13:14, a3=15:16, a4=17:18)
  )
  mydata$m <- list(
    matrix(1:6, nrow=2, ncol=3),
    matrix(6:1, nrow=2, ncol=3)
  )
  
  expect_that(fromJSON(toJSON(mydata)), equals(mydata));
});

test_that("Test NULL values", {
  namedlist <- structure(list(), .Names = character(0));
  x <- NULL
  y <- list(a=NULL, b=NA)
  z <- list(a=1, b=character(0))

  expect_true(validate(toJSON(x)))
  expect_equal(fromJSON(toJSON(x)), namedlist);
  expect_equal(toJSON(x), "{}");
  expect_equal(toJSON(x, null="list"), "{}");

  expect_true(validate(toJSON(y)))
  expect_equal(toJSON(y, null="list"), "{\"a\":{},\"b\":[null]}");
  expect_equal(toJSON(y, null="null"), "{\"a\":null,\"b\":[null]}");
  expect_equal(fromJSON(toJSON(y, null="null")), y);
  expect_equal(fromJSON(toJSON(y, null="list")), list(a=namedlist, b=NA));

  expect_true(validate(toJSON(z)))
  expect_equal(toJSON(z), "{\"a\":[1],\"b\":[]}");
  expect_equal(fromJSON(toJSON(z)), list(a=1, b=list()));
});

context("toJSON Factor")

test_that("Encoding Factor Objects", {
  expect_that(fromJSON(toJSON(iris$Species)), is_identical_to(as.character(iris$Species)));
  expect_that(fromJSON(toJSON(iris$Species[1])), is_identical_to(as.character(iris$Species[1])));
  expect_that(fromJSON(toJSON(iris$Species, factor="integer")), equals(structure(unclass(iris$Species), levels=NULL)));
});

test_that("Encoding Factor Objects", {
  expect_identical(fromJSON(toJSON(iris$Species)), as.character(iris$Species));
  expect_identical(fromJSON(toJSON(iris$Species[1])), as.character(iris$Species[1]));
  expect_equal(fromJSON(toJSON(iris$Species, factor="integer")), structure(unclass(iris$Species), levels=NULL));
});

context("toJSON POSIXt")

objects <- list(
  as.POSIXlt("2013-06-17 22:33:44"),
  as.POSIXct("2013-06-17 22:33:44"),
  as.POSIXlt("2013-06-17 22:33:44", tz="Australia/Darwin"),
  as.POSIXct("2013-06-17 22:33:44", tz="Australia/Darwin")
)

test_that("Encoding POSIXt Objects", {

  #string based formats do not depends on the current local timezone
  invisible(lapply(objects, function(object){
    expect_that(toJSON(object), equals("[\"2013-06-17 22:33:44\"]"));
    expect_that(toJSON(object, POSIXt="string"), equals("[\"2013-06-17 22:33:44\"]"));
    expect_that(toJSON(object, POSIXt="ISO8601"), equals("[\"2013-06-17T22:33:44\"]"));
    expect_that(toJSON(object, POSIXt="sdfsdsdf"), throws_error("one of"));
  }));

  #object 1 and 2 will result in a location specific epoch
  invisible(lapply(objects[3:4], function(object){
    expect_that(toJSON(object, POSIXt="epoch"), equals("[1371474224000]"));
    expect_that(toJSON(object, POSIXt="mongo"), equals("[{\"$date\":1371474224000}]"));
  }));

});

test_that("Encoding POSIXt object in a list", {
  #string based formats do not depends on the current local timezone
  invisible(lapply(objects, function(object){
    expect_that(toJSON(list(foo=object)), equals("{\"foo\":[\"2013-06-17 22:33:44\"]}"));
    expect_that(toJSON(list(foo=object), POSIXt="string"), equals("{\"foo\":[\"2013-06-17 22:33:44\"]}"));
    expect_that(toJSON(list(foo=object), POSIXt="ISO8601"), equals("{\"foo\":[\"2013-06-17T22:33:44\"]}"));
    expect_that(toJSON(list(foo=object), POSIXt="sdfsdsdf"), throws_error("one of"));
  }));

  #list(foo=object) 1 and 2 will result in a location specific epoch
  invisible(lapply(objects[3:4], function(object){
    expect_that(toJSON(list(foo=object), POSIXt="epoch"), equals("{\"foo\":[1371474224000]}"));
    expect_that(toJSON(list(foo=object), POSIXt="mongo"), equals("{\"foo\":[{\"$date\":1371474224000}]}"));
  }));
});

test_that("Encoding POSIXt object in a list", {
  #string based formats do not depends on the current local timezone
  invisible(lapply(objects, function(object){
    expect_that(toJSON(data.frame(foo=object)), equals("[{\"foo\":\"2013-06-17 22:33:44\"}]"));
    expect_that(toJSON(data.frame(foo=object), POSIXt="string"), equals("[{\"foo\":\"2013-06-17 22:33:44\"}]"));
    expect_that(toJSON(data.frame(foo=object), POSIXt="ISO8601"), equals("[{\"foo\":\"2013-06-17T22:33:44\"}]"));
    expect_that(toJSON(data.frame(foo=object), POSIXt="sdfsdsdf"), throws_error("one of"));
  }));

  #list(foo=object) 1 and 2 will result in a location specific epoch
  invisible(lapply(objects[3:4], function(object){
    expect_that(toJSON(data.frame(foo=object), POSIXt="epoch"), equals("[{\"foo\":1371474224000}]"));
    expect_that(toJSON(data.frame(foo=object), POSIXt="mongo"), equals("[{\"foo\":{\"$date\":1371474224000}}]"));
  }));
});

test_that("POSIXt NA values", {
  newobj <- list(
    c(objects[[1]], NA),
    c(objects[[2]], NA)
  );
  lapply(newobj, function(object){
    expect_that(toJSON(object), equals("[\"2013-06-17 22:33:44\",null]"));
    expect_that(toJSON(object, na="string"), equals("[\"2013-06-17 22:33:44\",\"NA\"]"));
    expect_that(toJSON(data.frame(foo=object)), equals("[{\"foo\":\"2013-06-17 22:33:44\"},{}]"));
    expect_that(toJSON(data.frame(foo=object), na="null"), equals("[{\"foo\":\"2013-06-17 22:33:44\"},{\"foo\":null}]"));
    expect_that(toJSON(data.frame(foo=object), na="string"), equals("[{\"foo\":\"2013-06-17 22:33:44\"},{\"foo\":\"NA\"}]"));
  });

  tzobj <- list(
    c(objects[[3]], NA),
    c(objects[[4]], NA)
  );
  lapply(tzobj, function(object) {
    expect_that(toJSON(object, POSIXt = "mongo"), equals("[{\"$date\":1371474224000},null]"));
    expect_that(toJSON(object, POSIXt = "mongo", na="string"), equals("[{\"$date\":1371474224000},\"NA\"]"));
    expect_that(toJSON(data.frame(foo=object), POSIXt = "mongo"), equals("[{\"foo\":{\"$date\":1371474224000}},{}]"));
    expect_that(toJSON(data.frame(foo=object), POSIXt = "mongo", na="null"), equals("[{\"foo\":{\"$date\":1371474224000}},{\"foo\":null}]"));
    expect_that(toJSON(data.frame(foo=object), POSIXt = "mongo", na="string"), equals("[{\"foo\":{\"$date\":1371474224000}},{\"foo\":\"NA\"}]"));
  })
});

test_that("Negative dates", {
  x <- objects[[2]]
  y <- x - c(1e9, 2e9, 3e9)
  expect_that(fromJSON(toJSON(y, POSIXt = "mongo")), equals(y))
})

objects <- list(
  as.POSIXlt("2013-06-17 22:33:44"),
  as.POSIXct("2013-06-17 22:33:44"),
  as.POSIXlt("2013-06-17 22:33:44", tz="Australia/Darwin"),
  as.POSIXct("2013-06-17 22:33:44", tz="Australia/Darwin")
)

test_that("Encoding POSIXt Objects", {

  #string based formats do not depends on the current local timezone
  invisible(lapply(objects, function(object){
    expect_equal(toJSON(object), "[\"2013-06-17 22:33:44\"]");
    expect_equal(toJSON(object, POSIXt="string"), "[\"2013-06-17 22:33:44\"]");
    expect_equal(toJSON(object, POSIXt="ISO8601"), "[\"2013-06-17T22:33:44\"]");
    expect_error(toJSON(object, POSIXt="sdfsdsdf"), "one of");
  }));

  #object 1 and 2 will result in a location specific epoch
  invisible(lapply(objects[3:4], function(object){
    expect_equal(toJSON(object, POSIXt="epoch"), "[1371474224000]");
    expect_equal(toJSON(object, POSIXt="mongo"), "[{\"$date\":1371474224000}]");
  }));

});

test_that("Encoding POSIXt object in a list", {
  #string based formats do not depends on the current local timezone
  invisible(lapply(objects, function(object){
    expect_equal(toJSON(list(foo=object)), "{\"foo\":[\"2013-06-17 22:33:44\"]}");
    expect_equal(toJSON(list(foo=object), POSIXt="string"), "{\"foo\":[\"2013-06-17 22:33:44\"]}");
    expect_equal(toJSON(list(foo=object), POSIXt="ISO8601"), "{\"foo\":[\"2013-06-17T22:33:44\"]}");
    expect_error(toJSON(list(foo=object), POSIXt="sdfsdsdf"), "one of");
  }));

  #list(foo=object) 1 and 2 will result in a location specific epoch
  invisible(lapply(objects[3:4], function(object){
    expect_equal(toJSON(list(foo=object), POSIXt="epoch"), "{\"foo\":[1371474224000]}");
    expect_equal(toJSON(list(foo=object), POSIXt="mongo"), "{\"foo\":[{\"$date\":1371474224000}]}");
  }));
});

test_that("Encoding POSIXt object in a list", {
  #string based formats do not depends on the current local timezone
  invisible(lapply(objects, function(object){
    expect_equal(toJSON(data.frame(foo=object)), "[{\"foo\":\"2013-06-17 22:33:44\"}]");
    expect_equal(toJSON(data.frame(foo=object), POSIXt="string"), "[{\"foo\":\"2013-06-17 22:33:44\"}]");
    expect_equal(toJSON(data.frame(foo=object), POSIXt="ISO8601"), "[{\"foo\":\"2013-06-17T22:33:44\"}]");
    expect_error(toJSON(data.frame(foo=object), POSIXt="sdfsdsdf"), "one of");
  }));

  #list(foo=object) 1 and 2 will result in a location specific epoch
  invisible(lapply(objects[3:4], function(object){
    expect_equal(toJSON(data.frame(foo=object), POSIXt="epoch"), "[{\"foo\":1371474224000}]");
    expect_equal(toJSON(data.frame(foo=object), POSIXt="mongo"), "[{\"foo\":{\"$date\":1371474224000}}]");
  }));
});

test_that("POSIXt NA values", {
  newobj <- list(
    c(objects[[1]], NA),
    c(objects[[2]], NA)
  );
  lapply(newobj, function(object){
    expect_equal(toJSON(object), "[\"2013-06-17 22:33:44\",null]");
    expect_equal(toJSON(object, na="string"), "[\"2013-06-17 22:33:44\",\"NA\"]");
    expect_equal(toJSON(data.frame(foo=object)), "[{\"foo\":\"2013-06-17 22:33:44\"},{}]");
    expect_equal(toJSON(data.frame(foo=object), na="null"), "[{\"foo\":\"2013-06-17 22:33:44\"},{\"foo\":null}]");
    expect_equal(toJSON(data.frame(foo=object), na="string"), "[{\"foo\":\"2013-06-17 22:33:44\"},{\"foo\":\"NA\"}]");
  });

  tzobj <- list(
    c(objects[[3]], NA),
    c(objects[[4]], NA)
  );
  lapply(tzobj, function(object) {
    expect_equal(toJSON(object, POSIXt = "mongo"), "[{\"$date\":1371474224000},null]");
    expect_equal(toJSON(object, POSIXt = "mongo", na="string"), "[{\"$date\":1371474224000},\"NA\"]");
    expect_equal(toJSON(data.frame(foo=object), POSIXt = "mongo"), "[{\"foo\":{\"$date\":1371474224000}},{}]");
    expect_equal(toJSON(data.frame(foo=object), POSIXt = "mongo", na="null"), "[{\"foo\":{\"$date\":1371474224000}},{\"foo\":null}]");
    expect_equal(toJSON(data.frame(foo=object), POSIXt = "mongo", na="string"), "[{\"foo\":{\"$date\":1371474224000}},{\"foo\":\"NA\"}]");
  })
});

test_that("Negative dates", {
  x <- objects[[2]]
  y <- x - c(1e9, 2e9, 3e9)
  expect_equal(fromJSON(toJSON(y, POSIXt = "mongo")), y);
})

context("toJSON NA values")

test_that("Test NA values", {
  options(stringsAsFactors=FALSE)
  x <- list(foo=c(TRUE, NA, FALSE, TRUE), bar=c(3.14,NA, 42, NA), zoo=c(NA, "bla", "boe", NA))
  x$mydf <- data.frame(col1=c(FALSE, NA, NA, TRUE), col2=c(1.23, NA, 23, NA))
  x$mydf$mylist <- list(c(TRUE, NA, FALSE, NA), NA, c("blabla", NA), c(NA,12,13,NA,NA,NA,1001))

  expect_true(validate(toJSON(x)))
  expect_that(fromJSON(toJSON(x)), equals(x))
  expect_that(fromJSON(toJSON(x, na="null")), equals(x))

});

context("toJSON AsIs")

test_that("Encoding AsIs", {
  expect_that(toJSON(list(1), auto_unbox=TRUE), equals("[1]"));
  expect_that(toJSON(list(I(1)), auto_unbox=TRUE), equals("[[1]]"));
  expect_that(toJSON(I(list(1)), auto_unbox=TRUE), equals("[1]"));

  expect_that(toJSON(list(x=1)), equals("{\"x\":[1]}"));
  expect_that(toJSON(list(x=1), auto_unbox=TRUE), equals("{\"x\":1}"));
  expect_that(toJSON(list(x=I(1)), auto_unbox=TRUE), equals("{\"x\":[1]}"));

  expect_that(toJSON(list(x=I(list(1))), auto_unbox=TRUE), equals("{\"x\":[1]}"));
  expect_that(toJSON(list(x=list(I(1))), auto_unbox=TRUE), equals("{\"x\":[[1]]}"));
});

context("fromJSON date objects")

test_that("fromJSON date objects", {

  x <- Sys.time() + c(1, 2, NA, 3)
  mydf <- data.frame(x=x)
  expect_that(fromJSON(toJSON(x, POSIXt="mongo")), is_a("POSIXct"))
  expect_that(fromJSON(toJSON(x, POSIXt="mongo")), equals(x))
  #expect_that(fromJSON(toJSON(x, POSIXt="mongo", na="string")), is_a("POSIXct"))
  expect_that(fromJSON(toJSON(x, POSIXt="mongo", na="null")), is_a("POSIXct"))

  expect_that(fromJSON(toJSON(mydf, POSIXt="mongo")), is_a("data.frame"))
  expect_that(fromJSON(toJSON(mydf, POSIXt="mongo"))$x, is_a("POSIXct"))
  #expect_that(fromJSON(toJSON(mydf, POSIXt="mongo", na="string"))$x, is_a("POSIXct"))
  expect_that(fromJSON(toJSON(mydf, POSIXt="mongo", na="null"))$x, is_a("POSIXct"))
  expect_that(fromJSON(toJSON(mydf, POSIXt="mongo"))$x, equals(x))

});

test_that("Encoding AsIs", {
  expect_equal(toJSON(list(1), auto_unbox=TRUE), "[1]");
  expect_equal(toJSON(list(I(1)), auto_unbox=TRUE), "[[1]]");
  expect_equal(toJSON(I(list(1)), auto_unbox=TRUE), "[1]");

  expect_equal(toJSON(list(x=1)), "{\"x\":[1]}");
  expect_equal(toJSON(list(x=1), auto_unbox=TRUE), "{\"x\":1}");
  expect_equal(toJSON(list(x=I(1)), auto_unbox=TRUE), "{\"x\":[1]}");

  expect_equal(toJSON(list(x=I(list(1))), auto_unbox=TRUE), "{\"x\":[1]}");
  expect_equal(toJSON(list(x=list(I(1))), auto_unbox=TRUE), "{\"x\":[[1]]}");
});

test_that("fromJSON date objects", {

  x <- Sys.time() + c(1, 2, NA, 3)
  mydf <- data.frame(x=x)
  expect_s3_class(fromJSON(toJSON(x, POSIXt="mongo")), "POSIXct");
  expect_equal(fromJSON(toJSON(x, POSIXt="mongo")), x);
  #expect_s3_class(fromJSON(toJSON(x, POSIXt="mongo", na="string")), "POSIXct");
  expect_s3_class(fromJSON(toJSON(x, POSIXt="mongo", na="null")), "POSIXct");

  expect_s3_class(fromJSON(toJSON(mydf, POSIXt="mongo")), "data.frame");
  expect_s3_class(fromJSON(toJSON(mydf, POSIXt="mongo"))$x, "POSIXct");
  #expect_s3_class(fromJSON(toJSON(mydf, POSIXt="mongo", na="string"))$x, "POSIXct");
  expect_s3_class(fromJSON(toJSON(mydf, POSIXt="mongo", na="null"))$x, "POSIXct");
  expect_equal(fromJSON(toJSON(mydf, POSIXt="mongo"))$x, x);

  xct <- as.POSIXct(x)
  xlt <- as.POSIXlt(x)

  expect_equal(xct, xlt)
  expect_true(unbox(xct[1]) == unbox(xlt[1]))
  xct3un <- unbox(xct[3])
  expect_true(is.na(xct3un) && inherits(xct3un,"scalar") &&
              inherits(xct3un,"POSIXt"))
  xlt3un <- unbox(xlt[3])
  expect_true(is.na(xlt3un) && inherits(xlt3un,"scalar") &&
              inherits(xlt3un,"POSIXt"))

  expect_equal(toJSON(xct,POSIXt="mongo"),toJSON(xlt,POSIXt="mongo"))
  expect_equal(toJSON(unbox(xct[1]),POSIXt="mongo"),
              toJSON(unbox(xlt[1]),POSIXt="mongo"))

});

context("fromJSON date objects")

test_that("fromJSON date objects", {

  x <- Sys.time() + c(1, 2, NA, 3)
  mydf <- data.frame(x=x)
  expect_that(fromJSON(toJSON(x, POSIXt="mongo")), is_a("POSIXct"))
  expect_that(fromJSON(toJSON(x, POSIXt="mongo")), equals(x))
  #expect_that(fromJSON(toJSON(x, POSIXt="mongo", na="string")), is_a("POSIXct"))
  expect_that(fromJSON(toJSON(x, POSIXt="mongo", na="null")), is_a("POSIXct"))

  expect_that(fromJSON(toJSON(mydf, POSIXt="mongo")), is_a("data.frame"))
  expect_that(fromJSON(toJSON(mydf, POSIXt="mongo"))$x, is_a("POSIXct"))
  #expect_that(fromJSON(toJSON(mydf, POSIXt="mongo", na="string"))$x, is_a("POSIXct"))
  expect_that(fromJSON(toJSON(mydf, POSIXt="mongo", na="null"))$x, is_a("POSIXct"))
  expect_that(fromJSON(toJSON(mydf, POSIXt="mongo"))$x, equals(x))

  xct <- as.POSIXct(x)
  xlt <- as.POSIXlt(x)

  expect_equal(xct, xlt)
  expect_true(unbox(xct[1]) == unbox(xlt[1]))
  xct3un <- unbox(xct[3])
  expect_true(is.na(xct3un) && inherits(xct3un,"scalar") &&
              inherits(xct3un,"POSIXt"))
  xlt3un <- unbox(xlt[3])
  expect_true(is.na(xlt3un) && inherits(xlt3un,"scalar") &&
              inherits(xlt3un,"POSIXt"))

  expect_equal(toJSON(xct,POSIXt="mongo"),toJSON(xlt,POSIXt="mongo"))
  expect_equal(toJSON(unbox(xct[1]),POSIXt="mongo"),
              toJSON(unbox(xlt[1]),POSIXt="mongo"))

});

context("toJSON Logical")

test_that("Encoding Logical", {
  expect_that(toJSON(TRUE), equals("[true]"));
  expect_that(toJSON(FALSE), equals("[false]"));
  expect_that(toJSON(as.logical(NA)), equals("[null]"))
  expect_that(toJSON(as.logical(NA), na="string"), equals("[\"NA\"]"))
  expect_that(toJSON(c(TRUE, NA, FALSE)), equals("[true,null,false]"));
  expect_that(toJSON(c(TRUE, NA, FALSE), na="string"), equals("[true,\"NA\",false]"));
  expect_that(toJSON(logical()), equals("[]"));
});

test_that("Encoding Logical in Data Frame", {
  expect_that(toJSON(data.frame(foo=TRUE)), equals("[{\"foo\":true}]"));
  expect_that(toJSON(data.frame(foo=FALSE)), equals("[{\"foo\":false}]"));
  expect_that(toJSON(data.frame(foo=as.logical(NA))), equals("[{}]"));
  expect_that(toJSON(data.frame(foo=as.logical(NA)), na="null"), equals("[{\"foo\":null}]"));
  expect_that(toJSON(data.frame(foo=as.logical(NA)), na="string"), equals("[{\"foo\":\"NA\"}]"));
  expect_that(toJSON(data.frame(foo=c(TRUE, NA, FALSE))), equals("[{\"foo\":true},{},{\"foo\":false}]"));
  expect_that(toJSON(data.frame(foo=logical())), equals("[]"));
});

context("fromJSON Matrix")

# Note about numeric precision
# In the unit tests we use digits=10. Lowever values will result in problems for some datasets
test_that("fromJSON Matrix", {
  objects <- list(
    matrix(1),
    matrix(1:2),
    matrix(1:2, nrow=1),
    matrix(round(pi,2)),
    matrix(c(1,NA,2,NA), 2),
    volcano,
    matrix(NA)
  );

  lapply(objects, function(object){
    newobject <- fromJSON(toJSON(object));
    expect_that(newobject, is_a("matrix"));
    expect_that(object, equals(newobject));
  });

  expect_that(fromJSON(toJSON(objects)), equals(objects));
});

test_that("fromJSON Matrix with simplifyMatrix=FALSE", {
  expect_that(fromJSON(toJSON(matrix(1)), simplifyMatrix=FALSE), equals(list(1)));
  expect_that(fromJSON(toJSON(matrix(1)), simplifyVector=FALSE), equals(list(list((1)))));
  expect_that(fromJSON(toJSON(matrix(NA)), simplifyMatrix=FALSE), equals(list(NA)));
  expect_that(fromJSON(toJSON(matrix(NA)), simplifyVector=FALSE), equals(list(list((NULL)))));
});


test_that("fromJSON Matrix datasets", {
  objects <- Filter(is.matrix, lapply(ls("package:datasets"), get));

  lapply(objects, function(object){
    class(object) <- "matrix";
    newobject <- fromJSON(toJSON(object, digits=4))
    expect_that(newobject, is_a("matrix"));
    expect_that(dim(newobject), equals(dim(object)));
    attributes(newobject) <- attributes(object);

    # R has changed rounding algo in 4.0 and no longer matches printf
    #expect_that(newobject, equals(round(object,4)))
    expect_equal(newobject, object, tolerance = 1e-4)
  });
});

context("libjson Validator")

test_that("test that the validator properly deals with escaped characters", {

  #create random strings
  mychars <- c('a', 'b', " ", '"', "\\", "\t", "\n", "'", "/", "#", "$");
  createstring <- function(length){
    paste(mychars[ceiling(runif(length, 0, length(mychars)))], collapse="")
  }

  for(i in 1:200){
    #create some random strings to validate
    x <- createstring(i);
    expect_true(validate(toJSON(x)));
  }

});

context("libjson Escaping")

test_that("escaping and parsing of special characters", {

  #create random strings
  mychars <- c('a', 'b', " ", '"', "\\", "\t", "\n", "'", "/", "#", "$");
  createstring <- function(length){
    paste(mychars[ceiling(runif(length, 0, length(mychars)))], collapse="")
  }

  #generate 1000 random strings
  for(i in 1:200){
    x <- createstring(i);
    expect_that(x, equals(fromJSON(toJSON(x))));
    expect_that(x, equals(fromJSON(toJSON(x, pretty=TRUE))));

    y <- setNames(list(123), x)
    expect_that(x, equals(fromJSON(toJSON(x, pretty=TRUE))));
  }

});

test_that("escape solidus", {
  expect_equal(toJSON("foo/bar/baz"), '["foo/bar/baz"]')
  expect_equal(toJSON('<script>evil()</script>'), '["<script>evil()<\\/script>"]')
  expect_equal(toJSON('/', auto_unbox = TRUE), '"/"')
  expect_equal(toJSON('</', auto_unbox = TRUE), '"<\\/"')

  # Mixed encoding
  x <- c('\xFD\xDD\xD6\xF0\n', '\u1F602\n')
  Encoding(x) <- c("latin1", "UTF-8")
  expect_equal(toJSON(x), '["\u00FD\u00DD\u00D6\u00F0\\n","\u1F602\\n"]')

  # Escape solidus by minify
  expect_equal(unclass(minify('["/"]')), '["/"]')
  expect_equal(unclass(minify('["</"]')), '["<\\/"]')
})

test_that("BOM is being ignored", {
  expect_warning(x <- fromJSON('\uFEFF[123]'), "mark")
  expect_equal(x, 123)
  con <- rawConnection(charToRaw('\uFEFF[123]'))
  expect_warning(fromJSON(con), "mark")
  close(con)
  expect_equal(x, 123)
})

test_that("Encoding Logical", {
  expect_equal(toJSON(TRUE), "[true]");
  expect_equal(toJSON(FALSE), "[false]");
  expect_equal(toJSON(as.logical(NA)), "[null]");
  expect_equal(toJSON(as.logical(NA), na="string"), "[\"NA\"]");
  expect_equal(toJSON(c(TRUE, NA, FALSE)), "[true,null,false]");
  expect_equal(toJSON(c(TRUE, NA, FALSE), na="string"), "[true,\"NA\",false]");
  expect_equal(toJSON(logical()), "[]");
});

test_that("Encoding Logical in Data Frame", {
  expect_equal(toJSON(data.frame(foo=TRUE)), "[{\"foo\":true}]");
  expect_equal(toJSON(data.frame(foo=FALSE)), "[{\"foo\":false}]");
  expect_equal(toJSON(data.frame(foo=as.logical(NA))), "[{}]");
  expect_equal(toJSON(data.frame(foo=as.logical(NA)), na="null"), "[{\"foo\":null}]");
  expect_equal(toJSON(data.frame(foo=as.logical(NA)), na="string"), "[{\"foo\":\"NA\"}]");
  expect_equal(toJSON(data.frame(foo=c(TRUE, NA, FALSE))), "[{\"foo\":true},{},{\"foo\":false}]");
  expect_equal(toJSON(data.frame(foo=logical())), "[]");
});

context("toJSON Matrix")

test_that("Encoding a Matrix", {
  expect_that(toJSON(matrix(1)), equals("[[1]]"));
  expect_that(toJSON(matrix(pi), digits=5), equals("[[3.14159]]"));
  expect_that(toJSON(matrix(1:2)), equals("[[1],[2]]"));  
  expect_that(toJSON(matrix(1:2, nrow=1)), equals("[[1,2]]")); 
  expect_that(toJSON(matrix(state.x77[1,1, drop=FALSE])), equals("[[3615]]"));
});

test_that("escaping and parsing of special characters", {

  #create random strings
  mychars <- c('a', 'b', " ", '"', "\\", "\t", "\n", "'", "/", "#", "$");
  createstring <- function(length){
    paste(mychars[ceiling(runif(length, 0, length(mychars)))], collapse="")
  }

  #generate 1000 random strings
  for(i in 1:200){
    x <- createstring(i);
    expect_equal(x, fromJSON(toJSON(x)));
    expect_equal(x, fromJSON(toJSON(x, pretty=TRUE)));

    y <- setNames(list(123), x)
    expect_equal(x, fromJSON(toJSON(x, pretty=TRUE)));
  }

});

test_that("escape solidus", {
  expect_equal(toJSON("foo/bar/baz"), '["foo/bar/baz"]')
  expect_equal(toJSON('<script>evil()</script>'), '["<script>evil()<\\/script>"]')
  expect_equal(toJSON('/', auto_unbox = TRUE), '"/"')
  expect_equal(toJSON('</', auto_unbox = TRUE), '"<\\/"')

  # Mixed encoding
  x <- c('\xFD\xDD\xD6\xF0\n', '\u1F602\n')
  Encoding(x) <- c("latin1", "UTF-8")
  expect_equal(toJSON(x), '["\u00FD\u00DD\u00D6\u00F0\\n","\u1F602\\n"]')

  # Escape solidus by minify
  expect_equal(unclass(minify('["/"]')), '["/"]')
  expect_equal(unclass(minify('["</"]')), '["<\\/"]')
})

test_that("BOM is being ignored", {
  expect_warning(x <- fromJSON('\uFEFF[123]'), "mark")
  expect_equal(x, 123)
  con <- rawConnection(charToRaw('\uFEFF[123]'))
  expect_warning(fromJSON(con), "mark")
  close(con)
  expect_equal(x, 123)
})

context("toJSON zerovec")

test_that("Encoding Factor Objects", {
  expect_that(toJSON(character()), is_identical_to("[]"))
  expect_that(toJSON(logical()), is_identical_to("[]"))
  expect_that(toJSON(complex()), is_identical_to("[]"))
  expect_that(toJSON(complex(), complex="list"), is_identical_to("{\"real\":[],\"imaginary\":[]}"))
  expect_that(toJSON(double()), is_identical_to("[]"))
  expect_that(toJSON(integer()), is_identical_to("[]"))
  expect_that(toJSON(list()), is_identical_to("[]"))
  expect_that(toJSON(factor()), is_identical_to("[]"))
  expect_that(toJSON(factor(levels=c("foo", "bar"))), is_identical_to("[]"))
  expect_that(toJSON(matrix(nrow=0, ncol=0)), is_identical_to("[]"))
  expect_that(toJSON(as.matrix(numeric())), is_identical_to("[]"))
  expect_that(toJSON(data.frame()), is_identical_to("[]"))
  expect_that(toJSON(data.frame(foo=vector())), is_identical_to("[]"))  
  expect_that(toJSON(data.frame(foo=vector(), bar=logical())), is_identical_to("[]"))
  expect_that(toJSON(Sys.time()[0], POSIXt="string"), is_identical_to("[]"))
  expect_that(toJSON(Sys.time()[0], POSIXt="epoch"), is_identical_to("[]")) 
  expect_that(toJSON(Sys.time()[0], POSIXt="mongo"), is_identical_to("[]")) 
  expect_that(toJSON(Sys.time()[0], POSIXt="ISO8601"), is_identical_to("[]")) 
  expect_that(toJSON(as.Date(Sys.time())[0], POSIXt="ISO8601"), is_identical_to("[]"))
});

context("fromJSON dataframes")

options(stringsAsFactors=FALSE);

test_that("recover nested data frames", {

  x1 <- x2 <- x3 <- x4 <- x5 <- x6 <- data.frame(foo=c(1:2));
  x2$bar <- c("jeroen", "eli");
  x3$bar <- x4$bar <- x5$bar <- x6$bar <- data.frame(name=c("jeroen", "eli"))
  x4$bar$age <- x5$bar$age <- c(28, 24);  x6$bar$age <- c(28, NA);
  x5$bar$food <- data.frame(yum=c("Rice", "Pasta"));
  x6$bar$food <- data.frame(yum=c(NA, "Pasta"));

  #add to list
  objects <- list(x1, x2, x3, x4, x5, x6)

  #test all but list
  lapply(objects, function(object){
    expect_that(fromJSON(toJSON(object)), equals(object))
    expect_that(fromJSON(toJSON(object, na="null")), equals(object))
    expect_that(names(fromJSON(toJSON(object), flatten = TRUE)), equals(names(unlist(object[1,,drop=FALSE]))))
  });

  #test all in list
  expect_that(fromJSON(toJSON(objects)), equals(objects))
});

test_that("recover lists in data frames", {
  x <- data.frame(author = c("Homer", "Virgil", "Jeroen"));
  x$poems = list(c("Iliad", "Odyssey"), c("Eclogues", "Georgics", "Aeneid"), character());

  y <- data.frame(author = c("Homer", "Virgil", "Jeroen"));
  y$poems = list(
    data.frame(title=c("Iliad", "Odyssey"), year=c(-1194, -800)),
    data.frame(title=c("Eclogues", "Georgics", "Aeneid"), year=c(-44, -29, -19)),
    data.frame()
  );

  z <- list(x=x, y=y);
  zz <- list(x,y);

  expect_that(fromJSON(toJSON(x)), equals(x))
  expect_that(fromJSON(toJSON(y)), equals(y))
  expect_that(fromJSON(toJSON(z)), equals(z))
  expect_that(fromJSON(toJSON(zz)), equals(zz))
});

#note: nested matrix does not perfectly restore
test_that("nested matrix in data frame", {
  x <- data.frame(foo=1:2)
  x$bar <- matrix(c(1:5, NA), 2)

  expect_true(validate(toJSON(x)))

  y <- fromJSON(toJSON(x))
  expect_that(y, is_a("data.frame"))
  expect_that(names(x), equals(names(y)))
  expect_that(length(y[[1,"bar"]]), equals(3))
});

test_that("Encoding a Matrix", {
  expect_equal(toJSON(matrix(1)), "[[1]]");
  expect_equal(toJSON(matrix(pi), digits=5), "[[3.14159]]");
  expect_equal(toJSON(matrix(1:2)), "[[1],[2]]");
  expect_equal(toJSON(matrix(1:2, nrow=1)), "[[1,2]]");
  expect_equal(toJSON(matrix(state.x77[1,1, drop=FALSE])), "[[3615]]");
});

context("fromJSON Array")

test_that("fromJSON Array, row major", {

  # test high dimensional arrays
  lapply(2:5, function(n){
    object <- array(1:prod(n), dim=1:n)
    newobject <- fromJSON(toJSON(object));
    expect_that(object, equals(newobject));
  });
  
  # adding some flat dimensions
  lapply(1:5, function(n){
    object <- array(1:prod(n), dim=c(1:n, 1))
    newobject <- fromJSON(toJSON(object));
    expect_that(object, equals(newobject));
  });  
});

test_that("fromJSON Array, column major", {
  
  # test high dimensional arrays
  lapply(2:5, function(n){
    object <- array(1:prod(n), dim=1:n)
    newobject <- fromJSON(toJSON(object, matrix="columnmajor"), columnmajor=TRUE);
    expect_that(object, equals(newobject));
  });
  
  # adding some flat dimensions
  lapply(1:5, function(n){
    object <- array(1:prod(n), dim=c(1:n, 1))
    newobject <- fromJSON(toJSON(object, matrix="columnmajor"), columnmajor=TRUE);
    expect_that(object, equals(newobject));
  });  
});


test_that("fromJSON Array, character strings", {
  
  # test high dimensional arrays
  lapply(2:5, function(n){
    object <- array(paste("cell", 1:prod(n)), dim=1:n)
    newobject <- fromJSON(toJSON(object, matrix="columnmajor"), columnmajor=TRUE);
    expect_that(object, equals(newobject));
  });
  
  # adding some flat dimensions
  lapply(1:5, function(n){
    object <- array(paste("cell", 1:prod(n)), dim=c(1:n, 1))
    newobject <- fromJSON(toJSON(object, matrix="columnmajor"), columnmajor=TRUE);
    expect_that(object, equals(newobject));
  });  
});

context("toJSON Complex")

test_that("Encoding Complex", {
  expect_that(toJSON(complex(real=2, imaginary=2)), equals("[\"2+2i\"]"));
  expect_that(toJSON(complex(real=NA, imaginary=2)), equals("[\"NA\"]"));  
  expect_that(toJSON(complex(real=1, imaginary=NA)), equals("[\"NA\"]"));   
  expect_that(toJSON(complex(real=NA, imaginary=2), na="null"), equals("[null]")); 
});

test_that("Encoding Complex in Data Frame", {
  expect_that(toJSON(data.frame(foo=complex(real=1, imaginary=2))), equals("[{\"foo\":\"1+2i\"}]"));
  expect_that(toJSON(data.frame(foo=complex(real=NA, imaginary=2))), equals("[{}]"));
  expect_that(toJSON(data.frame(foo=complex(real=NA, imaginary=2)), na="string"), equals("[{\"foo\":\"NA\"}]"));
  expect_that(toJSON(data.frame(foo=complex(real=NA, imaginary=2)), na="null"), equals("[{\"foo\":null}]"));
});

test_that("Encoding Complex as list", {
  x <- complex(real=c(1,2,NA), imaginary=3:1);
  expect_that(toJSON(x), equals("[\"1+3i\",\"2+2i\",\"NA\"]"));
  expect_that(toJSON(x, complex="list"), equals("{\"real\":[1,2,\"NA\"],\"imaginary\":[3,2,1]}"));
  expect_that(toJSON(data.frame(foo=x), complex="list"), equals("[{\"foo\":{\"real\":1,\"imaginary\":3}},{\"foo\":{\"real\":2,\"imaginary\":2}},{\"foo\":{\"imaginary\":1}}]"));
  expect_that(toJSON(data.frame(foo=x), complex="list", na="string"), equals("[{\"foo\":{\"real\":1,\"imaginary\":3}},{\"foo\":{\"real\":2,\"imaginary\":2}},{\"foo\":{\"real\":\"NA\",\"imaginary\":1}}]"));
  expect_that(toJSON(data.frame(foo=x), complex="list", dataframe="columns"), equals("{\"foo\":{\"real\":[1,2,\"NA\"],\"imaginary\":[3,2,1]}}"))
});

test_that("Encoding Factor Objects", {
  expect_identical(toJSON(character()), "[]");
  expect_identical(toJSON(logical()), "[]");
  expect_identical(toJSON(complex()), "[]");
  expect_identical(toJSON(complex(), complex="list"), "{\"real\":[],\"imaginary\":[]}");
  expect_identical(toJSON(double()), "[]");
  expect_identical(toJSON(integer()), "[]");
  expect_identical(toJSON(list()), "[]");
  expect_identical(toJSON(factor()), "[]");
  expect_identical(toJSON(factor(levels=c("foo", "bar"))), "[]");
  expect_identical(toJSON(matrix(nrow=0, ncol=0)), "[]");
  expect_identical(toJSON(as.matrix(numeric())), "[]");
  expect_identical(toJSON(data.frame()), "[]");
  expect_identical(toJSON(data.frame(foo=vector())), "[]");
  expect_identical(toJSON(data.frame(foo=vector(), bar=logical())), "[]");
  expect_identical(toJSON(Sys.time()[0], POSIXt="string"), "[]");
  expect_identical(toJSON(Sys.time()[0], POSIXt="epoch"), "[]");
  expect_identical(toJSON(Sys.time()[0], POSIXt="mongo"), "[]");
  expect_identical(toJSON(Sys.time()[0], POSIXt="ISO8601"), "[]");
  expect_identical(toJSON(as.Date(Sys.time())[0], POSIXt="ISO8601"), "[]");
});

context("libjson Large strings")

test_that("escaping and parsing of special characters", {
  
  #create random strings
  mychars <- c('a', 'b', " ", '"', "\\", "\t", "\n", "'", "/", "#", "$");
  createstring <- function(length){
    paste(mychars[ceiling(runif(length, 0, length(mychars)))], collapse="")
  }  

  #try some very long strings
  for(i in 1:10){
    zz <- list(foo=createstring(1e5))
    expect_that(zz, equals(fromJSON(toJSON(zz))));
  }
  
});

options(stringsAsFactors=FALSE);

test_that("recover nested data frames", {

  x1 <- x2 <- x3 <- x4 <- x5 <- x6 <- data.frame(foo=c(1:2));
  x2$bar <- c("jeroen", "eli");
  x3$bar <- x4$bar <- x5$bar <- x6$bar <- data.frame(name=c("jeroen", "eli"))
  x4$bar$age <- x5$bar$age <- c(28, 24);  x6$bar$age <- c(28, NA);
  x5$bar$food <- data.frame(yum=c("Rice", "Pasta"));
  x6$bar$food <- data.frame(yum=c(NA, "Pasta"));

  #add to list
  objects <- list(x1, x2, x3, x4, x5, x6)

  #test all but list
  lapply(objects, function(object){
    expect_equal(fromJSON(toJSON(object)), object);
    expect_equal(fromJSON(toJSON(object, na="null")), object);
    expect_equal(names(fromJSON(toJSON(object), flatten = TRUE)), names(unlist(object[1,,drop=FALSE])));
  });

  #test all in list
  expect_equal(fromJSON(toJSON(objects)), objects);
});

test_that("recover lists in data frames", {
  x <- data.frame(author = c("Homer", "Virgil", "Jeroen"));
  x$poems = list(c("Iliad", "Odyssey"), c("Eclogues", "Georgics", "Aeneid"), character());

  y <- data.frame(author = c("Homer", "Virgil", "Jeroen"));
  y$poems = list(
    data.frame(title=c("Iliad", "Odyssey"), year=c(-1194, -800)),
    data.frame(title=c("Eclogues", "Georgics", "Aeneid"), year=c(-44, -29, -19)),
    data.frame()
  );

  z <- list(x=x, y=y);
  zz <- list(x,y);

  expect_equal(fromJSON(toJSON(x)), x);
  expect_equal(fromJSON(toJSON(y)), y);
  expect_equal(fromJSON(toJSON(z)), z);
  expect_equal(fromJSON(toJSON(zz)), zz);
});

#note: nested matrix does not perfectly restore
test_that("nested matrix in data frame", {
  x <- data.frame(foo=1:2)
  x$bar <- matrix(c(1:5, NA), 2)

  expect_true(validate(toJSON(x)))

  y <- fromJSON(toJSON(x))
  expect_s3_class(y, "data.frame");
  expect_equal(names(x), names(y));
  expect_equal(length(y[[1,"bar"]]), 3);
});

test_that("Encoding Complex", {
  expect_equal(toJSON(complex(real=2, imaginary=2)), "[\"2+2i\"]");
  expect_equal(toJSON(complex(real=NA, imaginary=2)), "[\"NA\"]");
  expect_equal(toJSON(complex(real=1, imaginary=NA)), "[\"NA\"]");
  expect_equal(toJSON(complex(real=NA, imaginary=2), na="null"), "[null]");
});

test_that("Encoding Complex in Data Frame", {
  expect_equal(toJSON(data.frame(foo=complex(real=1, imaginary=2))), "[{\"foo\":\"1+2i\"}]");
  expect_equal(toJSON(data.frame(foo=complex(real=NA, imaginary=2))), "[{}]");
  expect_equal(toJSON(data.frame(foo=complex(real=NA, imaginary=2)), na="string"), "[{\"foo\":\"NA\"}]");
  expect_equal(toJSON(data.frame(foo=complex(real=NA, imaginary=2)), na="null"), "[{\"foo\":null}]");
});

test_that("Encoding Complex as list", {
  x <- complex(real=c(1,2,NA), imaginary=3:1);
  expect_equal(toJSON(x), "[\"1+3i\",\"2+2i\",\"NA\"]");
  expect_equal(toJSON(x, complex="list"), "{\"real\":[1,2,\"NA\"],\"imaginary\":[3,2,1]}");
  expect_equal(toJSON(data.frame(foo=x), complex="list"), "[{\"foo\":{\"real\":1,\"imaginary\":3}},{\"foo\":{\"real\":2,\"imaginary\":2}},{\"foo\":{\"imaginary\":1}}]");
  expect_equal(toJSON(data.frame(foo=x), complex="list", na="string"), "[{\"foo\":{\"real\":1,\"imaginary\":3}},{\"foo\":{\"real\":2,\"imaginary\":2}},{\"foo\":{\"real\":\"NA\",\"imaginary\":1}}]");
  expect_equal(toJSON(data.frame(foo=x), complex="list", dataframe="columns"), "{\"foo\":{\"real\":[1,2,\"NA\"],\"imaginary\":[3,2,1]}}");
});

context("toJSON raw")

test_that("Encoding raw vector", {
  x <- list(myraw = charToRaw("bla"))
  x$mydf <- data.frame(foo=1:3)
  x$mydf$bar <- as.character.hexmode(charToRaw("bla"))

  y <- fromJSON(toJSON(x))
  expect_that(x$mydf$bar, is_identical_to(y$mydf$bar))
  expect_that(y$myraw, is_identical_to("Ymxh"))

  # Serialize raw as int
  y <- fromJSON(toJSON(x, raw = 'int'))
  expect_equal(y$myraw, as.integer(x$myraw))

  # Serialize raw as hex
  y <- fromJSON(toJSON(x, raw = 'hex'))
  expect_equal(y$myraw, as.character.hexmode(x$myraw))

  # Serialize raw as JavaScript
  x <- list(myraw = charToRaw("bla"))
  expect_equal(toJSON(x, raw = 'js'), '{"myraw":(new Uint8Array([98,108,97]))}')

})

context("fromJSON datasets")

# Note about numeric precision
# In the unit tests we use digits=10. Lowever values will result in problems for some datasets
test_that("fromJSON datasets", {
  objects <- Filter(is.data.frame, lapply(ls("package:datasets"), get));
  
  #data frames are never identical because:
  # - attributes 
  # - factors, times, dates turn into strings
  # - integers turn into numeric
  lapply(objects, function(object){
    newobject <- fromJSON(toJSON(object))
    expect_that(newobject, is_a("data.frame"));
    expect_that(names(object), is_identical_to(names(newobject)));
    expect_that(nrow(object), is_identical_to(nrow(newobject)))
  });
});

context("toJSON Date")
object <- as.Date("1985-06-18");

test_that("Encoding Date Objects", {
  expect_that(toJSON(object), equals("[\"1985-06-18\"]"));
  expect_that(toJSON(object, Date="ISO8601"), equals("[\"1985-06-18\"]"));  
  expect_that(toJSON(object, Date="epoch"), equals("[5647]"));
  expect_that(toJSON(object, Date="adsfdsfds"), throws_error("should be one of"));  
});

test_that("Encoding Date Objects in a list", {
  expect_that(toJSON(list(foo=object)), equals("{\"foo\":[\"1985-06-18\"]}"));
  expect_that(toJSON(list(foo=object), Date="ISO8601"), equals("{\"foo\":[\"1985-06-18\"]}"));  
  expect_that(toJSON(list(foo=object), Date="epoch"), equals("{\"foo\":[5647]}"));
  expect_that(toJSON(list(foo=object), Date="adsfdsfds"), throws_error("should be one of"));  
});

test_that("Encoding Date Objects in a Data frame", {
  expect_that(toJSON(data.frame(foo=object)), equals("[{\"foo\":\"1985-06-18\"}]"));
  expect_that(toJSON(data.frame(foo=object), Date="ISO8601"), equals("[{\"foo\":\"1985-06-18\"}]"));  
  expect_that(toJSON(data.frame(foo=object), Date="epoch"), equals("[{\"foo\":5647}]"));
  expect_that(toJSON(data.frame(foo=object), Date="adsfdsfds"), throws_error("should be one of"));  
});

# Note about numeric precision
# In the unit tests we use digits=10. Lowever values will result in problems for some datasets
test_that("fromJSON datasets", {
  objects <- Filter(is.data.frame, lapply(ls("package:datasets"), get));

  #data frames are never identical because:
  # - attributes
  # - factors, times, dates turn into strings
  # - integers turn into numeric
  lapply(objects, function(object){
    newobject <- fromJSON(toJSON(object))
    expect_s3_class(newobject, "data.frame")
    expect_identical(sort(names(object)), sort(names(newobject)))
    expect_identical(nrow(object), nrow(newobject))
  });
});

context("fromJSON NA values")

test_that("fromJSON NA values", {
  
  objects <- list(
    numbers = c(1,2, NA, NaN, Inf, -Inf, 3.14),
    logical = c(TRUE, FALSE, NA),
    integers = as.integer(1,2,3),
    num = 3.14,
    bool = FALSE,
    character = c("FOO","NA", NA, "NaN"),
    integer = 21L,
    boolNA = as.logical(NA),
    df = data.frame(foo=c(1,NA))
  )
  
  #test all but list
  lapply(objects, function(object){
    expect_that(fromJSON(toJSON(object)), equals(object))   
  });
  
  #test all in list
  expect_that(fromJSON(toJSON(objects)), equals(objects))
});

object <- as.Date("1985-06-18");

test_that("Encoding Date Objects", {
  expect_equal(toJSON(object), "[\"1985-06-18\"]");
  expect_equal(toJSON(object, Date="ISO8601"), "[\"1985-06-18\"]");
  expect_equal(toJSON(object, Date="epoch"), "[5647]");
  expect_error(toJSON(object, Date="adsfdsfds"), "should be one of");
});

test_that("Encoding Date Objects in a list", {
  expect_equal(toJSON(list(foo=object)), "{\"foo\":[\"1985-06-18\"]}");
  expect_equal(toJSON(list(foo=object), Date="ISO8601"), "{\"foo\":[\"1985-06-18\"]}");
  expect_equal(toJSON(list(foo=object), Date="epoch"), "{\"foo\":[5647]}");
  expect_error(toJSON(list(foo=object), Date="adsfdsfds"), "should be one of");
});

test_that("Encoding Date Objects in a Data frame", {
  expect_equal(toJSON(data.frame(foo=object)), "[{\"foo\":\"1985-06-18\"}]");
  expect_equal(toJSON(data.frame(foo=object), Date="ISO8601"), "[{\"foo\":\"1985-06-18\"}]");
  expect_equal(toJSON(data.frame(foo=object), Date="epoch"), "[{\"foo\":5647}]");
  expect_error(toJSON(data.frame(foo=object), Date="adsfdsfds"), "should be one of");
});

test_that("fromJSON NA values", {

  objects <- list(
    numbers = c(1,2, NA, NaN, Inf, -Inf, 3.14),
    logical = c(TRUE, FALSE, NA),
    integers = as.integer(1,2,3),
    num = 3.14,
    bool = FALSE,
    character = c("FOO","NA", NA, "NaN"),
    integer = 21L,
    boolNA = as.logical(NA),
    df = data.frame(foo=c(1,NA))
  )

  #test all but list
  lapply(objects, function(object){
    expect_equal(fromJSON(toJSON(object)), object);
  });

  #test all in list
  expect_equal(fromJSON(toJSON(objects)), objects);
});

#' @useDynLib jsonlite C_collapse_object C_collapse_object_pretty
collapse_object <- function(x, y, indent = 0L) {
  if(is.na(indent)){
    .Call(C_collapse_object, x, y)
  } else {
    .Call(C_collapse_object_pretty, x, y, indent)
  }
}

#' @useDynLib jsonlite C_row_collapse_object
row_collapse_object <- function(x, m, indent = NA_integer_){
  .Call(C_row_collapse_object, x, m, indent = indent)
}

#' @rdname fromJSON
toJSON <- function(
  x,
  dataframe = c("rows", "columns", "values"),
  matrix = c("rowmajor", "columnmajor"),
  Date = c("ISO8601", "epoch"),
  POSIXt = c("string", "ISO8601", "epoch", "mongo"),
  factor = c("string", "integer"),
  complex = c("string", "list"),
  raw = c("base64", "hex", "mongo", "int", "js"),
  null = c("list", "null"),
  na = c("null", "string"),
  auto_unbox = FALSE,
  digits = 4,
  pretty = FALSE,
  force = FALSE,
  ...
) {
  # validate args
  dataframe <- match.arg(dataframe)
  matrix <- match.arg(matrix)
  Date <- match.arg(Date)
  POSIXt <- match.arg(POSIXt)
  factor <- match.arg(factor)
  complex <- match.arg(complex)
  raw <- match.arg(raw)
  null <- match.arg(null)

  # Temp workaround for 'mongopipe' unit test
  if (pretty == 2 && identical(x, list()) && identical(Sys.getenv('TESTTHAT_PKG'), 'mongopipe')) {
    return('[\n\n]')
  }

  # force
  x <- force(x)

  #this is just to check, we keep method-specific defaults
  if (!missing(na)) {
    na <- match.arg(na)
  } else {
    na <- NULL
  }

  # dispatch
  indent <- indent_init(pretty)
  ans <- asJSON(x, dataframe = dataframe, Date = Date, POSIXt = POSIXt, factor = factor, complex = complex, raw = raw, matrix = matrix, auto_unbox = auto_unbox, digits = digits, na = na, null = null, force = force, indent = indent, ...)
  class(ans) <- "json"
  return(ans)
}

indent_init <- function(pretty) {
  # default is 2 spaces
  if (isTRUE(pretty)) {
    pretty <- 2L
  }

  # Start with indent of 0
  if (is.numeric(pretty)) {
    stopifnot(abs(pretty) < 20)
    structure(0L, indent_spaces = as.integer(pretty))
  } else {
    NA_integer_
  }
}

indent_increment <- function(indent) {
  indent_spaces <- attr(indent, 'indent_spaces')
  if (length(indent_spaces)) {
    indent + abs(indent_spaces)
  } else {
    NA_integer_
  }
}

asjson_array_fun <- function(x, collapse = TRUE, na = NULL, oldna = NULL,
  matrix = c("rowmajor", "columnmajor"), auto_unbox = FALSE, keep_vec_names = FALSE,
  indent = NA_integer_, ...) {

  matrix <- match.arg(matrix);

  # reset na arg when called from data frame
  if(identical(na, "NA")){
    na <- oldna;
  }

  # 1D arrays are vectors
  if(length(dim(x)) < 2){
    return(asJSON(c(x), matrix = matrix, na = na, indent = indent + 2L, ...))
  }

  # if collapse == FALSE, then this matrix is nested inside a data frame,
  # and therefore row major must be forced to match dimensions
  if(identical(matrix, "columnmajor") && collapse == FALSE){
    return(apply(x, 1, asJSON, matrix = matrix, na = na, indent = indent + 2L, ...))
  }

  # dont pass auto_unbox (never unbox within matrix)
  m <- asJSON(c(x), collapse = FALSE, matrix = matrix, na = na, ...)
  dim(m) <- dim(x)
  tmp <- if(length(dim(x)) == 2 && identical(matrix, "rowmajor")){
    # Faster special case for 2D matrices
    row_collapse(m, indent = indent + 2L)
  } else {
    collapse_array(m, columnmajor = identical(matrix, "columnmajor"), indent = indent)
  }

  # collapse it
  if (collapse) {
    collapse(tmp, inner = FALSE, indent = indent)
  } else {
    tmp
  }
}

# Some objects have class Matrix but not class Array
setMethod("asJSON", "array", asjson_array_fun)
setMethod("asJSON", "matrix", asjson_array_fun)

setGeneric("asJSON", function(x, ...) {
  standardGeneric("asJSON")
})

if(getRversion() < 4){
  setOldClass("AsIs")
  setOldClass("integer64")
  setOldClass(c("hms", "difftime"))
  setOldClass("ITime")
  setOldClass("json")
  setOldClass("pairlist")
  setOldClass("scalar")
  setOldClass("sf")
  setOldClass("sfc")
}

toJSON <- function(...){
  unclass(jsonlite::toJSON(...))
}

toJSON2 <- function(x) {
  toJSON(x, keep_vec_names = TRUE, auto_unbox = TRUE)
}

toJSON3 <- function(x) {
  toJSON(x, keep_vec_names = TRUE, auto_unbox = TRUE, dataframe = "columns", rownames = FALSE)
}

context("toJSON keep_vec_names")

test_that("keep_vec_names with named vectors", {
  # Basic types should give messages
  # Length-1 vectors
  expect_message(expect_equal(toJSON2(c(a = 1)), '{"a":1}'))
  expect_message(expect_equal(toJSON2(c(a = "x")), '{"a":"x"}'))
  expect_message(expect_equal(toJSON2(c(a = TRUE)), '{"a":true}'))

  # Longer vectors
  expect_message(expect_equal(toJSON2(c(a = 1, b = 2)), '{"a":1,"b":2}'))
  expect_message(expect_equal(toJSON2(c(a = "x", b = "y")), '{"a":"x","b":"y"}'))
  expect_message(expect_equal(toJSON2(c(a = FALSE, b = TRUE)), '{"a":false,"b":true}'))

  # Some other types
  expect_message(expect_equal(toJSON2(factor(c(a = "x"))), '{"a":"x"}'))
  expect_message(expect_equal(toJSON2(c(a = as.Date("2015-01-01"))), '{"a":"2015-01-01"}'))
  expect_message(expect_equal(toJSON2(c(a = as.POSIXct("2015-01-01 3:00:00"))), '{"a":"2015-01-01 03:00:00"}'))
  expect_message(expect_equal(toJSON2(c(a = as.POSIXlt("2015-01-01 3:00:00"))), '{"a":"2015-01-01 03:00:00"}'))

  # keep_vec_names shouldn't affect unnamed vectors
  expect_equal(toJSON2(1), '1')
  expect_equal(toJSON2(c(1:3)), '[1,2,3]')
})


# Data frames generally don't allow named columns, except in very unusual cases
test_that("keep_vec_names with data frames", {
  expect_equal(toJSON3(data.frame(x = c(a = 1), y = 2)), '{"x":[1],"y":[2]}')
  expect_equal(toJSON3(data.frame(x = c(a = 1, b = 2), y = c(c = 3, d = 4))), '{"x":[1,2],"y":[3,4]}')
})

context("toJSON keep_vec_names")

test_that("keep_vec_names with named vectors", {

  # Basic types should give messages
  # Length-1 vectors
  expect_message(expect_equal(toJSON2(c(a=1)), '{"a":1}'))
  expect_message(expect_equal(toJSON2(c(a="x")), '{"a":"x"}'))
  expect_message(expect_equal(toJSON2(c(a=TRUE)), '{"a":true}'))

  # Longer vectors
  expect_message(expect_equal(toJSON2(c(a=1,b=2)), '{"a":1,"b":2}'))
  expect_message(expect_equal(toJSON2(c(a="x",b="y")), '{"a":"x","b":"y"}'))
  expect_message(expect_equal(toJSON2(c(a=FALSE,b=TRUE)), '{"a":false,"b":true}'))

  # Some other types
  expect_message(expect_equal(toJSON2(factor(c(a="x"))), '{"a":"x"}'))
  expect_message(expect_equal(toJSON2(c(a=as.Date("2015-01-01"))), '{"a":"2015-01-01"}'))
  expect_message(expect_equal(toJSON2(c(a=as.POSIXct("2015-01-01 3:00:00"))), '{"a":"2015-01-01 03:00:00"}'))
  expect_message(expect_equal(toJSON2(c(a=as.POSIXlt("2015-01-01 3:00:00"))), '{"a":"2015-01-01 03:00:00"}'))

  # keep_vec_names shouldn't affect unnamed vectors
  expect_equal(toJSON2(1), '1')
  expect_equal(toJSON2(c(1:3)), '[1,2,3]')
})


# Data frames generally don't allow named columns, except in very unusual cases
test_that("keep_vec_names with data frames", {
  expect_equal(toJSON3(data.frame(x=c(a=1), y=2)), '{"x":[1],"y":[2]}')
  expect_equal(toJSON3(data.frame(x=c(a=1,b=2), y=c(c=3,d=4))), '{"x":[1,2],"y":[3,4]}')
})

setGeneric("asJSON", function(x, ...) {
  standardGeneric("asJSON")
})

if(getRversion() < "4"){
  setOldClass("AsIs")
  setOldClass("integer64")
  setOldClass(c("hms", "difftime"))
  setOldClass("ITime")
  setOldClass("json")
  setOldClass("pairlist")
  setOldClass("scalar")
  setOldClass("sf")
  setOldClass("sfc")
}

#' Gzipped JSON
#'
#' Wrapper to generate and parse gzipped JSON, in order to save some disk or
#' network space. This is mainly effective for larger json objects with many
#' repeated keys, as is common in serialized data frames.
#'
#' The [as_gzjson_raw] and [parse_gzjson_raw] functions work with raw (binary)
#' vectors of compressed data. To use this in a place where only text is allowed
#' you can wrap the output again in [base64] as done by [as_gzjson_b64] and
#' [parse_gzjson_b64]. This increases the size again with about 33%.
#'
#'
#' @param x R data object to be converted to JSON
#' @param ... passed down to [toJSON] or [fromJSON]
#' @export
#' @name gzjson
#' @rdname gzjson
#' @examples str <- as_gzjson_b64(iris[1:5,])
#' cat(str)
#' parse_gzjson_b64(str)
as_gzjson_raw <- function(x, ...){
  json <- toJSON(x = x, ...)
  memCompress(json, 'gzip')
}

#' @export
#' @rdname gzjson
as_gzjson_b64 <- function(x, ...){
  buf <- as_gzjson_raw(x = x, ...)
  base64_enc(buf)
}

#' @export
#' @rdname gzjson
#' @param buf  raw vector with gzip compressed data
parse_gzjson_raw <- function(buf, ...){
  json <- rawToChar(memDecompress(buf, 'gzip'))
  fromJSON(json, ...)
}

#' @export
#' @rdname gzjson
#' @param b64 base64 encoded string containing gzipped json data
parse_gzjson_b64 <- function(b64, ...){
  parse_gzjson_raw(base64_dec(b64), ...)
}

#' Unbox a vector or data frame
#'
#' This function marks an atomic vector or data frame as a
#' \href{https://en.wikipedia.org/wiki/Singleton_(mathematics)}{singleton}, i.e.
#' a set with exactly 1 element. Thereby, the value will not turn into an
#' \code{array} when encoded into JSON. This can only be done for
#' atomic vectors of length 1, or data frames with exactly 1 row. To automatically
#' unbox all vectors of length 1 within an object, use the \code{auto_unbox} argument
#'in \code{\link{toJSON}}.
#'
#' It is usually recommended to avoid this function and stick with the default
#' encoding schema for the various \R{} classes. The only use case for this function
#' is if you are bound to some specific predefined JSON structure (e.g. to
#' submit to an API), which has no natural \R{} representation. Note that the default
#' encoding for data frames naturally results in a collection of key-value pairs,
#' without using \code{unbox}.
#'
#' @param x atomic vector of length 1, or data frame with 1 row.
#' @return Returns a singleton version of \code{x}.
#' @export
#' @references \url{https://en.wikipedia.org/wiki/Singleton_(mathematics)}
#' @examples toJSON(list(foo=123))
#' toJSON(list(foo=unbox(123)))
#'
#' # Auto unbox vectors of length one:
#' x = list(x=1:3, y = 4, z = "foo", k = NULL)
#' toJSON(x)
#' toJSON(x, auto_unbox = TRUE)
#'
#' x <- iris[1,]
#' toJSON(list(rec=x))
#' toJSON(list(rec=unbox(x)))
unbox <- function(x){
  if(is.null(x)){
    return(x)
  }
  if(is.data.frame(x)){
    if(nrow(x) == 1){
      return(as.scalar(x))
    } else {
      stop("Tried to unbox dataframe with ", nrow(x), " rows.")
    }
  }
  if(is.null(x) || !is.atomic(x) || length(dim(x)) > 1){
    stop("Only atomic vectors of length 1 or data frames with 1 row can be unboxed.")
  }
  if(identical(length(x), 1L)){
    return(as.scalar(x))
  } else {
    stop("Tried to unbox a vector of length ", length(x))
  }
}

setMethod("asJSON", "ts", function(x, ...) {
  asJSON(as.vector(x), ...)
})

setOldClass(c("hms", "difftime"))
setMethod("asJSON", "hms", function(x, hms = c("string", "secs"), ...) {
  hms <- match.arg(hms)
  output <- switch(hms,
                   string = as.character(x),
                   secs = as.numeric(x, units = "secs")
  )
  output[is.na(x)] <- NA
  asJSON(output, ...)
})

fixNativeSymbol <- function(symbol) {
  if (is(symbol, "NativeSymbolInfo")) {
    # method depends on version
    rVersion <- getRversion()

    if (rVersion >= "3.0") {
      # in R 3.0 determine the dll that the symbol lives in
      name <- ifelse(is.null(symbol$package), symbol$dll[["name"]], symbol$package[["name"]])

      # load package if not yet loaded
      try(getNamespace(name))
      pkgDLL <- getLoadedDLLs()[[name]]

      # reconstruct the native symbol address
      newsymbol <- getNativeSymbolInfo(name = symbol$name, PACKAGE = pkgDLL,
        withRegistrationInfo = TRUE)
      symbol$address <- newsymbol$address
      return(symbol)
    } else if (rVersion >= "2.14") {
      return(getNativeSymbolInfo(symbol$name))
    }
  } else {
    return(symbol)
  }
}

setOldClass(c("hms", "difftime"))
setMethod("asJSON", "hms", function(x, hms = c("string", "secs"), ...) {
  hms <- match.arg(hms)
  output <- switch(hms,
                   string = as.character(x),
                   secs = as.numeric(x, units = "secs")
  )
  output[is.na(x)] <- NA
  asJSON(output, ...)
})

setMethod("asJSON", "list", function(x, collapse = TRUE, na = NULL, oldna = NULL,
  is_df = FALSE, auto_unbox = FALSE, indent = NA_integer_, no_dots = FALSE, ...) {

  # reset na arg when called from data frame
  if(identical(na, "NA")){
    na <- oldna;
  }

  # coerse pairlist if needed
  if (is.pairlist(x)) {
    x <- as.vector(x, mode = "list")
  }

  # empty vector
  #if (!length(x)) {
  #  if(collapse) {
  #    return(if (is.null(names(x))) "[]" else "{}")
  #  } else {
  #    return(character())
  #  }
  #}

  # this condition appears when a dataframe contains a column with lists we need to
  # do this, because the [ operator always returns a list of length 1
  # if (length(x) == 1 && is.null(names(x)) && collapse == FALSE) {
  #   return(asJSON(x[[1]], ...))
  # }

  # note we are NOT passing on the container argument.
  tmp <- if(is_df && auto_unbox){
    vapply(x, function(y, ...) {
      asJSON(y, auto_unbox = is.list(y), ...)
    }, character(1), na = na, indent = indent + 2L, no_dots = no_dots, ...)
  } else {
    vapply(x, asJSON, character(1), na = na, auto_unbox = auto_unbox, indent = indent + 2L, no_dots = no_dots, ...)
  }

  if (!is.null(names(x))) {
    if(!collapse){
      #this should never happen
      warning("collapse=FALSE called for named list.")
    }
    #in case of named list:
    objnames <- deparse_vector(cleannames(names(x), no_dots = no_dots))
    collapse_object(objnames, tmp, indent)
  } else {
    #in case of unnamed list:
    if(collapse){
      collapse(tmp, inner = FALSE, indent)
    } else {
      tmp
    }
  }
})

#' The \code{\link{serializeJSON}} and \code{\link{unserializeJSON}} functions convert between
#' \R{} objects to JSON data. Instead of using a class based mapping like
#' \code{\link{toJSON}} and \code{\link{fromJSON}}, the serialize functions base the encoding
#' schema on the storage type, and capture all data and attributes from any object.
#' Thereby the object can be restored almost perfectly from its JSON representation, but
#' the resulting JSON output is very verbose. Apart from environments, all standard storage
#' types are supported.
#'
#' @rdname serializeJSON
#' @title serialize R objects to JSON
#' @name serializeJSON
#' @export serializeJSON unserializeJSON
#' @param x an \R{} object to be serialized
#' @param digits max number of digits (after the dot) to print for numeric values
#' @param pretty add indentation/whitespace to JSON output. See \code{\link{prettify}}
#' @note JSON is a text based format which leads to loss of precision when printing numbers.
#' @examples jsoncars <- serializeJSON(mtcars)
#' mtcars2 <- unserializeJSON(jsoncars)
#' identical(mtcars, mtcars2)
#'
#' set.seed('123')
#' myobject <- list(
#'   mynull = NULL,
#'   mycomplex = lapply(eigen(matrix(-rnorm(9),3)), round, 3),
#'   mymatrix = round(matrix(rnorm(9), 3),3),
#'   myint = as.integer(c(1,2,3)),
#'   mydf = cars,
#'   mylist = list(foo='bar', 123, NA, NULL, list('test')),
#'   mylogical = c(TRUE,FALSE,NA),
#'   mychar = c('foo', NA, 'bar'),
#'   somemissings = c(1,2,NA,NaN,5, Inf, 7 -Inf, 9, NA),
#'   myrawvec = charToRaw('This is a test')
#' );
#' identical(unserializeJSON(serializeJSON(myobject)), myobject);
serializeJSON <- function(x, digits = 8, pretty = FALSE) {
  # just to verify that obj exists
  is(x)
  # we pass arguments both to asJSON as well as packaging object.
  ans <- asJSON(pack(x), digits = digits, indent = if (isTRUE(pretty)) 0L else NA_integer_)
  class(ans) <- "json"
  return(ans)
}

#' @param txt a JSON string which was created using \code{serializeJSON}
#' @rdname serializeJSON
unserializeJSON <- function(txt) {
  unpack(parseJSON(txt))
}

#test serializeJSON

# Note about numeric precision
# In the unit tests we use digits=10. Lowever values will result in problems for some datasets
test_that("Serializing Data Objects", {
  objects <- list(
    NULL,
    readBin(system.file(package = "base", "Meta/package.rds"), "raw", 999),
    c(TRUE, FALSE, NA, FALSE),
    c(1L, NA, 9999999),
    c(round(pi, 4), NA, NaN, Inf, -Inf),
    c("foo", NA, "bar"),
    complex(real = 1:10, imaginary = 1001:1010),
    Reaction ~ Days + (1 | Subject) + (0 + Days | Subject),
    as.name("cars"),
    as.pairlist(mtcars),
    quote(rnorm(10)),
    expression("to be or not to be"),
    expression(foo),
    parse(text = "rnorm(10);"),
    call("rnorm", n = 10),
    emptyenv(),
    `if`, #builtin
    `list`, #special
    getNamespace("graphics") #namespace
  )

  #test all but list
  lapply(objects, function(object) {
    expect_equal(unserializeJSON(serializeJSON(object)), object)
  })

  #test all in list
  expect_equal(unserializeJSON(serializeJSON(objects)), objects)
})

#test serializeJSON

context("Serializing Data Types")

# Note about numeric precision
# In the unit tests we use digits=10. Lowever values will result in problems for some datasets
test_that("Serializing Data Objects", {

  objects <- list(
    NULL,
    readBin(system.file(package="base", "Meta/package.rds"), "raw", 999),
    c(TRUE, FALSE, NA, FALSE),
    c(1L, NA, 9999999),
    c(round(pi, 4), NA, NaN, Inf, -Inf),
    c("foo", NA, "bar"),
    complex(real=1:10, imaginary=1001:1010),
    Reaction ~ Days + (1|Subject) + (0+Days|Subject),
    as.name("cars"),
    as.pairlist(mtcars),
    quote(rnorm(10)),
    expression("to be or not to be"),
    expression(foo),
    parse(text="rnorm(10);"),
    call("rnorm", n=10),
    emptyenv(),
    `if`, #builtin
    `list`, #special
    getNamespace("graphics") #namespace
  )

  #test all but list
  lapply(objects, function(object){
    expect_that(unserializeJSON(serializeJSON(object)), equals(object))
  });

  #test all in list
  expect_that(unserializeJSON(serializeJSON(objects)), equals(objects))
});

#test serializeJSON

# Note about numeric precision
# In the unit tests we use digits=10. Lowever values will result in problems for some datasets
test_that("Serializing Functions", {
  options(keep.source = FALSE)

  objects <- list(
    function(x = 0) {
      x + 1
    },
    function(x) {
      x + 1
    },
    function(x, ...) {
      x + 1
    },
    lm
  )

  #test all but list
  lapply(objects, function(object) {
    fun <- unserializeJSON(serializeJSON(object))
    environment(fun) <- environment(object)
    expect_equal(fun, object)
  })
})

test_that("Indent sizes", {
  x <- list(
    df = mtcars[1:10, ],
    mat = matrix(1:6, 2),
    lst = list(
      c(42, NA),
      c(TRUE, FALSE, NA),
      c("foo", "bar", NA_character_)
    )
  )
  for (indent in -8:8) {
    y1 <- fromJSON(toJSON(x, pretty = indent))
    y2 <- unserializeJSON(serializeJSON(x, pretty = indent))
    expect_equal(y1, y2)
  }
})

#test serializeJSON

context("Serializing Functions")

# Note about numeric precision
# In the unit tests we use digits=10. Lowever values will result in problems for some datasets
test_that("Serializing Functions", {

  options(keep.source=FALSE);

  objects <- list(
    function(x = 0) { x + 1 },
    function(x) { x + 1 },
    function(x, ...) { x + 1},
    lm
  )

  #test all but list
  lapply(objects, function(object){
    fun <- unserializeJSON(serializeJSON(object))
    environment(fun) <- environment(object)
    expect_that(fun, equals(object))
  })
})

#test serializeJSON



# Note about numeric precision
# In the unit tests we use digits=10. Lowever values will result in problems for some datasets
test_that("Serializing Functions", {

  options(keep.source=FALSE);

  objects <- list(
    function(x = 0) { x + 1 },
    function(x) { x + 1 },
    function(x, ...) { x + 1},
    lm
  )

  #test all but list
  lapply(objects, function(object){
    fun <- unserializeJSON(serializeJSON(object))
    environment(fun) <- environment(object)
    expect_equal(fun, object);
  })
})

context("Serializing S4 objects")

test_that("Simple S4 serialization", {
  setClass("myClass", slots = list(name = "character"))
  obj <- new("myClass", name = "myName")
  out <- jsonlite::unserializeJSON(jsonlite::serializeJSON(obj))
  expect_identical(obj, out)
  removeClass("myClass")
})

test_that("Serialize optional S4 fields", {
  setClass(
    Class="Trajectories",
    representation = representation(
      times = "numeric",
      traj = "matrix"
    )
  )

  t1 <- new(Class="Trajectories")
  t2 <- new(Class="Trajectories", times=c(1,3,4))
  t3 <- new(Class="Trajectories", times=c(1,3), traj=matrix(1:4,ncol=2))

  expect_identical(t1, unserializeJSON(serializeJSON(t1)))
  expect_identical(t2, unserializeJSON(serializeJSON(t2)))
  expect_identical(t3, unserializeJSON(serializeJSON(t3)))
  removeClass("Trajectories")
})

test_that("Serialize pseudo-null (empty slot)", {
  track <- setClass("track", slots = c(x="numeric", y="ANY"))
  t1 <- new("track", x = 1:3)
  t2 <- unserializeJSON(serializeJSON(t1))
  expect_identical(t1, t2)
})

test_that("Class loading errors", {
  expect_error(unserializeJSON('{"type":"S4","attributes":{},"value":{"class":"nonExitingClass","package":".GlobalEnv"}}'), "defined")
  expect_error(expect_warning(unserializeJSON('{"type":"S4","attributes":{},"value":{"class":"nonExitingClass","package":"nopackage"}}')), "nopackage")
})

test_that("Simple S4 serialization", {
  setClass("myClass", slots = list(name = "character"))
  obj <- new("myClass", name = "myName")
  out <- jsonlite::unserializeJSON(jsonlite::serializeJSON(obj))
  expect_identical(obj, out)
  removeClass("myClass")
})

test_that("Serialize optional S4 fields", {
  setClass(
    Class="Trajectories",
    representation = representation(
      times = "numeric",
      traj = "matrix"
    )
  )

  t1 <- new(Class="Trajectories")
  t2 <- new(Class="Trajectories", times=c(1,3,4))
  t3 <- new(Class="Trajectories", times=c(1,3), traj=matrix(1:4,ncol=2))

  expect_identical(t1, unserializeJSON(serializeJSON(t1)))
  expect_identical(t2, unserializeJSON(serializeJSON(t2)))
  expect_identical(t3, unserializeJSON(serializeJSON(t3)))
  removeClass("Trajectories")
})

test_that("Serialize pseudo-null (empty slot)", {
  track <- setClass("track", slots = c(x="numeric", y="ANY"))
  t1 <- new("track", x = 1:3)
  t2 <- unserializeJSON(serializeJSON(t1))
  expect_identical(t1, t2)
})

test_that("Class loading errors", {
  expect_error(unserializeJSON('{"type":"S4","attributes":{},"value":{"class":"nonExitingClass","package":".GlobalEnv"}}'), "defined")
  expect_error(expect_warning(unserializeJSON('{"type":"S4","attributes":{},"value":{"class":"nonExitingClass","package":"nopackage"}}')), "nopackage")
})


# S4 extending various SEXP types
test_that("Serializing S4 extending SEXPTYPE", {

  objects <- list(
    NULL,
    readBin(system.file(package="base", "Meta/package.rds"), "raw", 999),
    c(TRUE, FALSE, NA, FALSE),
    c(1L, NA, 9999999),
    c(round(pi, 4), NA, NaN, Inf, -Inf),
    c("foo", NA, "bar"),
    complex(real=1:10, imaginary=1001:1010),
    expression("to be or not to be"),
    expression(foo),
    parse(text="rnorm(10);"),
    list("1", "2", "3"),
    mtcars,
    base::matrix(nrow=100, ncol=100)
  )

  lapply(objects, function(object){
    setClass("Complexo", contains = c(class(object)))
    complex1 <- new("Complexo", object)
    c1 = serializeJSON(complex1)
    c2 = unserializeJSON(c1)
    expect_identical(complex1, c2)
  })

})

#' Unbox a vector or data frame
#'
#' This function marks an atomic vector or data frame as a
#' [singleton](https://en.wikipedia.org/wiki/Singleton_(mathematics)), i.e.
#' a set with exactly 1 element. Thereby, the value will not turn into an
#' `array` when encoded into JSON. This can only be done for
#' atomic vectors of length 1, or data frames with exactly 1 row. To automatically
#' unbox all vectors of length 1 within an object, use the `auto_unbox` argument
#' in [toJSON()].
#'
#' It is usually recommended to avoid this function and stick with the default
#' encoding schema for the various \R{} classes. The only use case for this function
#' is if you are bound to some specific predefined JSON structure (e.g. to
#' submit to an API), which has no natural \R{} representation. Note that the default
#' encoding for data frames naturally results in a collection of key-value pairs,
#' without using `unbox`.
#'
#' @param x atomic vector of length 1, or data frame with 1 row.
#' @return Returns a singleton version of `x`.
#' @export
#' @references <https://en.wikipedia.org/wiki/Singleton_(mathematics)>
#' @examples toJSON(list(foo=123))
#' toJSON(list(foo=unbox(123)))
#'
#' # Auto unbox vectors of length one:
#' x = list(x=1:3, y = 4, z = "foo", k = NULL)
#' toJSON(x)
#' toJSON(x, auto_unbox = TRUE)
#'
#' x <- iris[1,]
#' toJSON(list(rec=x))
#' toJSON(list(rec=unbox(x)))
unbox <- function(x){
  if(is.null(x)){
    return(x)
  }
  if(is.data.frame(x)){
    if(nrow(x) == 1){
      return(as.scalar(x))
    } else {
      stop("Tried to unbox dataframe with ", nrow(x), " rows.")
    }
  }
  if (length(x) == 1L && inherits(x,"POSIXt")) {
    return (as.scalar(x))
  }
  if(is.null(x) || !is.atomic(x) || length(dim(x)) > 1){
    stop("Only atomic vectors of length 1 or data frames with 1 row can be unboxed.")
  }
  if(identical(length(x), 1L)){
    return(as.scalar(x))
  } else {
    stop("Tried to unbox a vector of length ", length(x))
  }
}

#' @useDynLib jsonlite R_num_to_char
num_to_char <- function(x, digits = NA, na_as_string = NA, use_signif = FALSE, always_decimal = FALSE){
  if(is.na(digits)) digits <- NA_integer_;
  stopifnot(is.numeric(x))
  stopifnot(is.numeric(digits))
  stopifnot(is.logical(na_as_string))
  .Call(R_num_to_char, x, digits, na_as_string, use_signif, always_decimal)
}

#' @useDynLib jsonlite R_integer64_to_char
integer64_to_char <- function(x, na_as_string = TRUE){
  .Call(R_integer64_to_char, x, na_as_string)
}

num_to_char_R <- function(x, digits = NA, na_as_string = NA){
  if(is.na(digits)) digits <- NA_integer_;
  stopifnot(is.numeric(x))
  stopifnot(is.numeric(digits))
  stopifnot(is.logical(na_as_string))
  if(!is.integer(x) && !is.null(digits) && !is.na(digits)){
    x <- round(x, digits)
  }

  #convert to strings
  tmp <- as.character(x)

  # in numeric variables, NA, NaN, Inf are replaced by character strings
  if (any(missings <- which(!is.finite(x)))) {
    if(is.na(na_as_string)){
      tmp[missings] <- NA_character_;
    } else if(na_as_string){
      tmp[missings] <- wrapinquotes(x[missings])
    } else {
      tmp[missings] <- "null"
    }
  }

  #returns a character vector
  return(tmp)
}

#' These functions are used to convert between JSON data and \R{} objects. The \code{\link{toJSON}} and \code{\link{fromJSON}}
#' functions use a class based mapping, which follows conventions outlined in this paper:  \url{https://arxiv.org/abs/1403.2805} (also available as vignette).
#'
#' The \code{\link{toJSON}} and \code{\link{fromJSON}} functions are drop-in replacements for the identically named functions
#' in packages \code{rjson} and \code{RJSONIO}. Our implementation uses an alternative, somewhat more consistent mapping
#' between \R{} objects and JSON strings.
#'
#' The \code{\link{serializeJSON}} and \code{\link{unserializeJSON}} functions in this package use an
#' alternative system to convert between \R{} objects and JSON, which supports more classes but is much more verbose.
#'
#' A JSON string is always unicode, using \code{UTF-8} by default, hence there is usually no need to escape any characters.
#' However, the JSON format does support escaping of unicode characters, which are encoded using a backslash followed by
#' a lower case \code{"u"} and 4 hex characters, for example: \code{"Z\\u00FCrich"}. The \code{fromJSON} function
#' will parse such escape sequences but it is usually preferable to encode unicode characters in JSON using native
#' \code{UTF-8} rather than escape sequences.
#
#' @rdname fromJSON
#' @title Convert \R{} objects to/from JSON
#' @name toJSON, fromJSON
#' @aliases fromJSON toJSON jsonlite
#' @export fromJSON toJSON
#' @param txt a JSON string, URL or file
#' @param simplifyVector coerce JSON arrays containing only primitives into an atomic vector
#' @param simplifyDataFrame coerce JSON arrays containing only records (JSON objects) into a data frame
#' @param simplifyMatrix coerce JSON arrays containing vectors of equal mode and dimension into matrix or array
#' @param flatten automatically \code{\link{flatten}} nested data frames into a single non-nested data frame
#' @param x the object to be encoded
#' @param dataframe how to encode data.frame objects: must be one of 'rows', 'columns' or 'values'
#' @param matrix how to encode matrices and higher dimensional arrays: must be one of 'rowmajor' or 'columnmajor'.
#' @param Date how to encode Date objects: must be one of 'ISO8601' or 'epoch'
#' @param POSIXt how to encode POSIXt (datetime) objects: must be one of 'string', 'ISO8601', 'epoch' or 'mongo'
#' @param factor how to encode factor objects: must be one of 'string' or 'integer'
#' @param complex how to encode complex numbers: must be one of 'string' or 'list'
#' @param raw how to encode raw objects: must be one of 'base64', 'hex' or 'mongo'
#' @param null how to encode NULL values within a list: must be one of 'null' or 'list'
#' @param na how to print NA values: must be one of 'null' or 'string'. Defaults are class specific
#' @param auto_unbox automatically \code{\link{unbox}} all atomic vectors of length 1. It is usually safer to avoid this and instead use the \code{\link{unbox}} function to unbox individual elements.
#'   An exception is that objects of class \code{AsIs} (i.e. wrapped in \code{I()}) are not automatically unboxed. This is a way to mark single values as length-1 arrays.
#' @param digits max number of decimal digits to print for numeric values. Use \code{I()} to specify significant digits. Use \code{NA} for max precision.
#' @param force unclass/skip objects of classes with no defined JSON mapping
#' @param pretty adds indentation whitespace to JSON output. Can be TRUE/FALSE or a number specifying the number of spaces to indent. See \code{\link{prettify}}
#' @param ... arguments passed on to class specific \code{print} methods
#' @references Jeroen Ooms (2014). The \code{jsonlite} Package: A Practical and Consistent Mapping Between JSON Data and \R{} Objects. \emph{arXiv:1403.2805}. \url{https://arxiv.org/abs/1403.2805}
#' @seealso \code{\link{read_json}}, \code{\link{stream_in}}
#' @examples # Stringify some data
#' jsoncars <- toJSON(mtcars, pretty=TRUE)
#' cat(jsoncars)
#'
#' # Parse it back
#' fromJSON(jsoncars)
#'
#' # Parse escaped unicode
#' fromJSON('{"city" : "Z\\u00FCrich"}')
#'
#' # Decimal vs significant digits
#' toJSON(pi, digits=3)
#' toJSON(pi, digits=I(3))
#'
#' \dontrun{
#' #retrieve data frame
#' data1 <- fromJSON("https://api.github.com/users/hadley/orgs")
#' names(data1)
#' data1$login
#'
#' # Nested data frames:
#' data2 <- fromJSON("https://api.github.com/users/hadley/repos")
#' names(data2)
#' names(data2$owner)
#' data2$owner$login
#'
#' # Flatten the data into a regular non-nested dataframe
#' names(flatten(data2))
#'
#' # Flatten directly (more efficient):
#' data3 <- fromJSON("https://api.github.com/users/hadley/repos", flatten = TRUE)
#' identical(data3, flatten(data2))
#' }
fromJSON <- function(txt, simplifyVector = TRUE, simplifyDataFrame = simplifyVector,
  simplifyMatrix = simplifyVector, flatten = FALSE, ...) {

  # check type
  if (!is.character(txt) && !inherits(txt, "connection")) {
    stop("Argument 'txt' must be a JSON string, URL or file.")
  }

  # overload for URL or path
  if (is.character(txt) && length(txt) == 1 && nchar(txt, type="bytes") < 2084 && !validate(txt)) {
    if (grepl("^https?://", txt, useBytes=TRUE)) {
      loadpkg("curl")
      h <- curl::new_handle(useragent = paste("jsonlite /", R.version.string))
      curl::handle_setheaders(h, Accept = "application/json, text/*, */*")
      txt <- curl::curl(txt, handle = h)
    } else if (file.exists(txt)) {
      # With files we can never know for sure the encoding. Lets try UTF8 first.
      # txt <- raw_to_json(readBin(txt, raw(), file.info(txt)$size));
      txt <- file(txt)
    }
  }

  # call the actual function (with deprecated arguments)
  parse_and_simplify(txt = txt, simplifyVector = simplifyVector, simplifyDataFrame = simplifyDataFrame,
    simplifyMatrix = simplifyMatrix, flatten = flatten, ...)
}

parse_and_simplify <- function(txt, simplifyVector = TRUE, simplifyDataFrame = simplifyVector,
  simplifyMatrix = simplifyVector, flatten = FALSE, unicode = TRUE, validate = TRUE, bigint_as_char = FALSE, ...){

  if(!missing(unicode)){
    message("Argument unicode has been deprecated. YAJL always parses unicode.")
  }

  if(!missing(validate)){
    message("Argument validate has been deprecated. YAJL automatically validates json while parsing.")
  }

  # parse
  obj <- parseJSON(txt, bigint_as_char)

  # post processing
  if (any(isTRUE(simplifyVector), isTRUE(simplifyDataFrame), isTRUE(simplifyMatrix))) {
    return(simplify(obj, simplifyVector = simplifyVector, simplifyDataFrame = simplifyDataFrame,
      simplifyMatrix = simplifyMatrix, flatten = flatten, ...))
  } else {
    return(obj)
  }
}


# Backward compatiblity
fromJSON_string <- parse_and_simplify

test_that("Non Nested", {
  mydata <- fromJSON("https://api.github.com/users/hadley/orgs")
  expect_s3_class(mydata, "data.frame")
})

test_that("Nested 1 Level", {
  mydata <- fromJSON("https://api.github.com/users/hadley/repos")
  expect_s3_class(mydata, "data.frame")
  expect_s3_class(mydata$owner, "data.frame")
  expect_equal(nrow(mydata), nrow(mydata$owner))
})


test_that("Nested 1 Level", {
  mydata <- fromJSON("https://api.github.com/repos/hadley/ggplot2/issues")
  expect_s3_class(mydata, "data.frame")
  expect_s3_class(mydata$user, "data.frame")
  expect_s3_class(mydata$pull_request, "data.frame")
  expect_equal(nrow(mydata), nrow(mydata$pull_request))
})

test_that("Nested 1 Level within list", {
  mydata <- fromJSON("https://api.github.com/search/repositories?q=tetris+language:assembly&sort=stars&order=desc")
  expect_type(mydata, "list")
  expect_s3_class(mydata$items, "data.frame")
  expect_s3_class(mydata$items$owner, "data.frame")
  expect_equal(nrow(mydata$items), nrow(mydata$items$owner))
})

test_that("Nested 2 Level", {
  mydata <- fromJSON("https://api.github.com/repos/hadley/ggplot2/commits")
  expect_s3_class(mydata, "data.frame")
  expect_s3_class(mydata$commit, "data.frame")
  expect_s3_class(mydata$commit$author, "data.frame")
  expect_type(mydata$commit$author$name, "character")
  expect_equal(nrow(mydata), nrow(mydata$commit))
  expect_equal(nrow(mydata), nrow(mydata$commit$author))
})

test_that("Nested inconsistent (payload), one-to-many", {
  mydata <- fromJSON("https://api.github.com/users/hadley/events")
  expect_s3_class(mydata, "data.frame")
  expect_s3_class(mydata$actor, "data.frame")
  expect_s3_class(mydata$repo, "data.frame")
  expect_type(mydata$type, "character")
  expect_s3_class(mydata$payload, "data.frame")

  #this is dynamic, depends on data
  if (any(mydata$type == "PushEvent")) {
    expect_true(all(vapply(
      mydata$payload$commits,
      function(x) {
        is.null(x) || is.data.frame(x)
      },
      logical(1)
    )))
  }
})

test_that("Nested inconsistent (payload), one-to-many", {
  mydata <- fromJSON("https://api.github.com/repos/hadley/ggplot2/events")
  if (any("ForkEvent" %in% mydata$type)) {
    expect_s3_class(mydata$payload$forkee$owner, "data.frame")
  }

  if (any(mydata$type %in% c("IssuesEvent", "IssueCommentEvent"))) {
    expect_s3_class(mydata$payload$issue, "data.frame")
    expect_s3_class(mydata$payload$issue$user, "data.frame")
  }
})

context("Github API")

test_that("Non Nested", {
  mydata <- fromJSON("https://api.github.com/users/hadley/orgs");
  expect_that(mydata, is_a("data.frame"));
});

test_that("Nested 1 Level", {
  mydata <- fromJSON("https://api.github.com/users/hadley/repos");
  expect_that(mydata, is_a("data.frame"));
  expect_that(mydata$owner, is_a("data.frame"));
  expect_that(nrow(mydata), equals(nrow(mydata$owner)));
});


test_that("Nested 1 Level", {
  mydata <- fromJSON("https://api.github.com/repos/hadley/ggplot2/issues");
  expect_that(mydata, is_a("data.frame"));
  expect_that(mydata$user, is_a("data.frame"));
  expect_that(mydata$pull_request, is_a("data.frame"));
  expect_that(nrow(mydata), equals(nrow(mydata$pull_request)));
});

test_that("Nested 1 Level within list", {
  mydata <- fromJSON("https://api.github.com/search/repositories?q=tetris+language:assembly&sort=stars&order=desc");
  expect_that(mydata, is_a("list"));
  expect_that(mydata$items, is_a("data.frame"));
  expect_that(mydata$items$owner, is_a("data.frame"));
  expect_that(nrow(mydata$items), equals(nrow(mydata$items$owner)));
});

test_that("Nested 2 Level", {
  mydata <- fromJSON("https://api.github.com/repos/hadley/ggplot2/commits");
  expect_that(mydata, is_a("data.frame"));
  expect_that(mydata$commit, is_a("data.frame"));
  expect_that(mydata$commit$author, is_a("data.frame"));
  expect_that(mydata$commit$author$name, is_a("character"));
  expect_that(nrow(mydata), equals(nrow(mydata$commit)));
  expect_that(nrow(mydata), equals(nrow(mydata$commit$author)));
});

test_that("Nested inconsistent (payload), one-to-many", {
  mydata <- fromJSON("https://api.github.com/users/hadley/events");
  expect_that(mydata, is_a("data.frame"));
  expect_that(mydata$actor, is_a("data.frame"));
  expect_that(mydata$repo, is_a("data.frame"));
  expect_that(mydata$type, is_a("character"));
  expect_that(mydata$payload, is_a("data.frame"));

  #this is dynamic, depends on data
  if(any(mydata$type == "PushEvent")){
    expect_true(all(vapply(mydata$payload$commits, function(x){is.null(x) || is.data.frame(x)}, logical(1))));
  }
});

test_that("Nested inconsistent (payload), one-to-many", {
  mydata <- fromJSON("https://api.github.com/repos/hadley/ggplot2/events");
  if(any("ForkEvent" %in% mydata$type)){
    expect_that(mydata$payload$forkee$owner, is_a("data.frame"))
  }

  if(any(mydata$type %in% c("IssuesEvent", "IssueCommentEvent"))){
    expect_that(mydata$payload$issue, is_a("data.frame"));
    expect_that(mydata$payload$issue$user, is_a("data.frame"));
  }
});

test_that("Non Nested", {
  mydata <- fromJSON("https://api.github.com/users/hadley/orgs");
  expect_s3_class(mydata, "data.frame");
});

test_that("Nested 1 Level", {
  mydata <- fromJSON("https://api.github.com/users/hadley/repos");
  expect_s3_class(mydata, "data.frame");
  expect_s3_class(mydata$owner, "data.frame");
  expect_equal(nrow(mydata), nrow(mydata$owner));
});


test_that("Nested 1 Level", {
  mydata <- fromJSON("https://api.github.com/repos/hadley/ggplot2/issues");
  expect_s3_class(mydata, "data.frame");
  expect_s3_class(mydata$user, "data.frame");
  expect_s3_class(mydata$pull_request, "data.frame");
  expect_equal(nrow(mydata), nrow(mydata$pull_request));
});

test_that("Nested 1 Level within list", {
  mydata <- fromJSON("https://api.github.com/search/repositories?q=tetris+language:assembly&sort=stars&order=desc");
  expect_type(mydata, "list");
  expect_s3_class(mydata$items, "data.frame");
  expect_s3_class(mydata$items$owner, "data.frame");
  expect_equal(nrow(mydata$items), nrow(mydata$items$owner));
});

test_that("Nested 2 Level", {
  mydata <- fromJSON("https://api.github.com/repos/hadley/ggplot2/commits");
  expect_s3_class(mydata, "data.frame");
  expect_s3_class(mydata$commit, "data.frame");
  expect_s3_class(mydata$commit$author, "data.frame");
  expect_type(mydata$commit$author$name, "character");
  expect_equal(nrow(mydata), nrow(mydata$commit));
  expect_equal(nrow(mydata), nrow(mydata$commit$author));
});

test_that("Nested inconsistent (payload), one-to-many", {
  mydata <- fromJSON("https://api.github.com/users/hadley/events");
  expect_s3_class(mydata, "data.frame");
  expect_s3_class(mydata$actor, "data.frame");
  expect_s3_class(mydata$repo, "data.frame");
  expect_type(mydata$type, "character");
  expect_s3_class(mydata$payload, "data.frame");

  #this is dynamic, depends on data
  if(any(mydata$type == "PushEvent")){
    expect_true(all(vapply(mydata$payload$commits, function(x){is.null(x) || is.data.frame(x)}, logical(1))));
  }
});

test_that("Nested inconsistent (payload), one-to-many", {
  mydata <- fromJSON("https://api.github.com/repos/hadley/ggplot2/events");
  if(any("ForkEvent" %in% mydata$type)){
    expect_s3_class(mydata$payload$forkee$owner, "data.frame");
  }

  if(any(mydata$type %in% c("IssuesEvent", "IssueCommentEvent"))){
    expect_s3_class(mydata$payload$issue, "data.frame");
    expect_s3_class(mydata$payload$issue$user, "data.frame");
  }
});

# classRepresentation is an object that defines an S4 class encoding it usually
# doesn't serve much purpose, however as we don't wnat to encode it as a regular
# S4 data object.

# it currently only encodes the slots. we could add encoding of methods of that
# would be desired.

setMethod("asJSON", "classRepresentation", function(x, ...) {
  return(asJSON(attributes(x)$slots, ...))
})

#' These functions are used to convert between JSON data and \R{} objects. The \code{\link{toJSON}} and \code{\link{fromJSON}}
#' functions use a class based mapping, which follows conventions outlined in this paper:  \url{https://arxiv.org/abs/1403.2805} (also available as vignette).
#'
#' The \code{\link{toJSON}} and \code{\link{fromJSON}} functions are drop-in replacements for the identically named functions
#' in packages \code{rjson} and \code{RJSONIO}. Our implementation uses an alternative, somewhat more consistent mapping
#' between \R{} objects and JSON strings.
#'
#' The \code{\link{serializeJSON}} and \code{\link{unserializeJSON}} functions in this package use an
#' alternative system to convert between \R{} objects and JSON, which supports more classes but is much more verbose.
#'
#' A JSON string is always unicode, using \code{UTF-8} by default, hence there is usually no need to escape any characters.
#' However, the JSON format does support escaping of unicode characters, which are encoded using a backslash followed by
#' a lower case \code{"u"} and 4 hex characters, for example: \code{"Z\\u00FCrich"}. The \code{fromJSON} function
#' will parse such escape sequences but it is usually preferable to encode unicode characters in JSON using native
#' \code{UTF-8} rather than escape sequences.
#
#' @rdname fromJSON
#' @title Convert \R{} objects to/from JSON
#' @name toJSON, fromJSON
#' @aliases fromJSON toJSON jsonlite
#' @export fromJSON toJSON
#' @param txt a JSON string, URL or file
#' @param simplifyVector coerce JSON arrays containing only primitives into an atomic vector
#' @param simplifyDataFrame coerce JSON arrays containing only records (JSON objects) into a data frame
#' @param simplifyMatrix coerce JSON arrays containing vectors of equal mode and dimension into matrix or array
#' @param flatten automatically \code{\link{flatten}} nested data frames into a single non-nested data frame
#' @param x the object to be encoded
#' @param dataframe how to encode data.frame objects: must be one of 'rows', 'columns' or 'values'
#' @param matrix how to encode matrices and higher dimensional arrays: must be one of 'rowmajor' or 'columnmajor'.
#' @param Date how to encode Date objects: must be one of 'ISO8601' or 'epoch'
#' @param POSIXt how to encode POSIXt (datetime) objects: must be one of 'string', 'ISO8601', 'epoch' or 'mongo'
#' @param factor how to encode factor objects: must be one of 'string' or 'integer'
#' @param complex how to encode complex numbers: must be one of 'string' or 'list'
#' @param raw how to encode raw objects: must be one of 'base64', 'hex' or 'mongo'
#' @param null how to encode NULL values within a list: must be one of 'null' or 'list'
#' @param na how to print NA values: must be one of 'null' or 'string'. Defaults are class specific
#' @param auto_unbox automatically \code{\link{unbox}} all atomic vectors of length 1. It is usually safer to avoid this and instead use the \code{\link{unbox}} function to unbox individual elements.
#'   An exception is that objects of class \code{AsIs} (i.e. wrapped in \code{I()}) are not automatically unboxed. This is a way to mark single values as length-1 arrays.
#' @param digits max number of decimal digits to print for numeric values. Use \code{I()} to specify significant digits. Use \code{NA} for max precision.
#' @param force unclass/skip objects of classes with no defined JSON mapping
#' @param pretty adds indentation whitespace to JSON output. Can be TRUE/FALSE or a number specifying the number of spaces to indent. See \code{\link{prettify}}
#' @param ... arguments passed on to class specific \code{print} methods
#' @references Jeroen Ooms (2014). The \code{jsonlite} Package: A Practical and Consistent Mapping Between JSON Data and \R{} Objects. \emph{arXiv:1403.2805}. \url{https://arxiv.org/abs/1403.2805}
#' @examples # Stringify some data
#' jsoncars <- toJSON(mtcars, pretty=TRUE)
#' cat(jsoncars)
#'
#' # Parse it back
#' fromJSON(jsoncars)
#'
#' # Parse escaped unicode
#' fromJSON('{"city" : "Z\\u00FCrich"}')
#'
#' # Decimal vs significant digits
#' toJSON(pi, digits=3)
#' toJSON(pi, digits=I(3))
#'
#' \dontrun{
#' #retrieve data frame
#' data1 <- fromJSON("https://api.github.com/users/hadley/orgs")
#' names(data1)
#' data1$login
#'
#' # Nested data frames:
#' data2 <- fromJSON("https://api.github.com/users/hadley/repos")
#' names(data2)
#' names(data2$owner)
#' data2$owner$login
#'
#' # Flatten the data into a regular non-nested dataframe
#' names(flatten(data2))
#'
#' # Flatten directly (more efficient):
#' data3 <- fromJSON("https://api.github.com/users/hadley/repos", flatten = TRUE)
#' identical(data3, flatten(data2))
#' }
fromJSON <- function(txt, simplifyVector = TRUE, simplifyDataFrame = simplifyVector,
  simplifyMatrix = simplifyVector, flatten = FALSE, ...) {

  # check type
  if (!is.character(txt) && !inherits(txt, "connection")) {
    stop("Argument 'txt' must be a JSON string, URL or file.")
  }

  # overload for URL or path
  if (is.character(txt) && length(txt) == 1 && nchar(txt, type="bytes") < 2084 && !validate(txt)) {
    if (grepl("^https?://", txt, useBytes=TRUE)) {
      loadpkg("curl")
      h <- curl::new_handle(useragent = paste("jsonlite /", R.version.string))
      curl::handle_setheaders(h, Accept = "application/json, text/*, */*")
      txt <- curl::curl(txt, handle = h)
    } else if (file.exists(txt)) {
      # With files we can never know for sure the encoding. Lets try UTF8 first.
      # txt <- raw_to_json(readBin(txt, raw(), file.info(txt)$size));
      txt <- file(txt)
    }
  }

  # call the actual function (with deprecated arguments)
  parse_and_simplify(txt = txt, simplifyVector = simplifyVector, simplifyDataFrame = simplifyDataFrame,
    simplifyMatrix = simplifyMatrix, flatten = flatten, ...)
}

parse_and_simplify <- function(txt, simplifyVector = TRUE, simplifyDataFrame = simplifyVector,
  simplifyMatrix = simplifyVector, flatten = FALSE, unicode = TRUE, validate = TRUE, bigint_as_char = FALSE, ...){

  if(!missing(unicode)){
    message("Argument unicode has been deprecated. YAJL always parses unicode.")
  }

  if(!missing(validate)){
    message("Argument validate has been deprecated. YAJL automatically validates json while parsing.")
  }

  # parse
  obj <- parseJSON(txt, bigint_as_char)

  # post processing
  if (any(isTRUE(simplifyVector), isTRUE(simplifyDataFrame), isTRUE(simplifyMatrix))) {
    return(simplify(obj, simplifyVector = simplifyVector, simplifyDataFrame = simplifyDataFrame,
      simplifyMatrix = simplifyMatrix, flatten = flatten, ...))
  } else {
    return(obj)
  }
}


# Backward compatiblity
fromJSON_string <- parse_and_simplify

#' @useDynLib jsonlite C_escape_chars
deparse_vector_c <- function(x) {
  .Call(C_escape_chars, x)
}

deparse_vector_r <- function(x) {
  stopifnot(is.character(x))
  if(!length(x)) return(x)
  x <- gsub("\\", "\\\\", x, fixed=TRUE)
  x <- gsub("\"", "\\\"", x, fixed=TRUE)
  x <- gsub("\n", "\\n", x, fixed=TRUE)
  x <- gsub("\r", "\\r", x, fixed=TRUE)
  x <- gsub("\t", "\\t", x, fixed=TRUE)
  x <- gsub("\b", "\\b", x, fixed=TRUE)
  x <- gsub("\f", "\\f", x, fixed=TRUE)
  paste0("\"", x, "\"")
}

# Which implementation to use
deparse_vector <- deparse_vector_c

#Below are older implementations of the same function
deparse_vector_old <- function(x) {
  stopifnot(is.character(x))
  x <- gsub("[\v\a]", "", x)
  vapply(x, deparse, character(1), USE.NAMES=FALSE)
}

#Vignettes that depend on internet access have been precompiled:

library(knitr)
knit("vignettes/json-apis.Rmd.orig", "vignettes/json-apis.Rmd")
knit("vignettes/json-paging.Rmd.orig", "vignettes/json-paging.Rmd")

#Vignettes that depend on internet access have been precompiled:

library(knitr)
knit("vignettes/json-apis.Rmd.orig", "vignettes/json-apis.Rmd")
knit("vignettes/json-paging.Rmd.orig", "vignettes/json-paging.Rmd")

library(devtools)
build_vignettes()

list_to_vec <- function(x) {
  isdates <- is_datelist(x)
  out <- unlist(null_to_na(x), recursive = FALSE, use.names = FALSE)
  if(isdates && is.numeric(out)){
    structure(out, class = c("POSIXct", "POSIXt"))
  } else{
    out
  }
}

#' Flatten nested data frames
#'
#' In a nested data frame, one or more of the columns consist of another data
#' frame. These structures frequently appear when parsing JSON data from the web.
#' We can flatten such data frames into a regular 2 dimensional tabular structure.
#'
#' @export
#' @param x a data frame
#' @param recursive flatten recursively
#' @examples options(stringsAsFactors=FALSE)
#' x <- data.frame(driver = c("Bowser", "Peach"), occupation = c("Koopa", "Princess"))
#' x$vehicle <- data.frame(model = c("Piranha Prowler", "Royal Racer"))
#' x$vehicle$stats <- data.frame(speed = c(55, 34), weight = c(67, 24), drift = c(35, 32))
#' str(x)
#' str(flatten(x))
#' str(flatten(x, recursive = FALSE))
#'
#' \dontrun{
#' data1 <- fromJSON("https://api.github.com/users/hadley/repos")
#' colnames(data1)
#' colnames(data1$owner)
#' colnames(flatten(data1))
#'
#' # or for short:
#' data2 <- fromJSON("https://api.github.com/users/hadley/repos", flatten = TRUE)
#' colnames(data2)
#' }
#'
flatten <- function(x, recursive = TRUE){
  stopifnot(is.data.frame(x))
  nr <- nrow(x)
  dfcolumns <- vapply(x, is.data.frame, logical(1))
  if(!any(dfcolumns)){
    return(x)
  }
  x <- if(recursive){
    c(x[!dfcolumns], do.call(c, lapply(x[dfcolumns], flatten)))
  } else {
    c(x[!dfcolumns], do.call(c, x[dfcolumns]))
  }
  class(x) <- "data.frame"
  row.names(x) <- if(!nr) character(0) else 1:nr;
  x
}

#1,2,3,df1,5,6,7,df2,9

setMethod("asJSON", "factor", function(x, factor = c("string", "integer"), keep_vec_names = FALSE, ...) {
  # validate
  factor <- match.arg(factor)

  # dispatch
  if (factor == "integer") {
    # encode factor as enum
    asJSON(unclass(x), ...)
  } else {
    # encode as strings
    xc <- as.character(x)
    if(isTRUE(keep_vec_names)){
      names(xc) <- names(x)
    }
    asJSON(xc, keep_vec_names = keep_vec_names, ...)
  }
})

#' @useDynLib jsonlite C_collapse_array C_collapse_array_pretty_inner C_collapse_array_pretty_outer
collapse <- function(x, inner = TRUE, indent = 0L) {
  if(is.na(indent)){
    .Call(C_collapse_array, x)
  } else if(isTRUE(inner)){
    .Call(C_collapse_array_pretty_inner, x)
  } else {
    .Call(C_collapse_array_pretty_outer, x, indent)
  }
}

#' @useDynLib jsonlite C_row_collapse_array
row_collapse <- function(m, indent = NA_integer_){
  .Call(C_row_collapse_array, m, indent = indent)
}


# Iteratively collapse a high dimensional matrix / array
# Does not perform the final collapse, which is done in asJSON.array()
collapse_array <- function(x, columnmajor = FALSE, indent){
  # dimensionality of the array
  n <- length(dim(x))

  # Collapse the inner vectors
  dim <- 1:(n-1) + as.numeric(columnmajor)
  x <- apply(x, dim, collapse, inner = TRUE, indent = indent)

  # Collapse higher dimensions
  for(i in rev(seq_along(dim(x)))[-1]) {
    dim <- 1:(length(dim(x))-1) + as.numeric(columnmajor)
    x <- apply(x, dim, collapse, inner = FALSE, indent = indent + 2L * i)
  }
  x
}

#' @useDynLib jsonlite C_is_recordlist
is_recordlist_c <- function(x){
  .Call(C_is_recordlist, x)
}

is_recordlist_r <- function(x) {
  if (!(is.unnamedlist(x) && length(x))) {
    return(FALSE)
  }
  at_least_one_object = FALSE
  for(i in x){
    if(!(is.namedlist(i) || is.null(i))) return(FALSE)
    if(!at_least_one_object && is.namedlist(i)) at_least_one_object <- TRUE
  }
  return(at_least_one_object)
}

is.recordlist <- is_recordlist_c;

is.namedlist <- function(x) {
  isTRUE(is.list(x) && !is.null(names(x)))
}

is.unnamedlist <- function(x) {
  isTRUE(is.list(x) && is.null(names(x)))
}

#' Prettify adds indentation to a JSON string; minify removes all indentation/whitespace.
#'
#' @rdname prettify
#' @title Prettify or minify a JSON string
#' @name prettify, minify
#' @aliases minify prettify
#' @export prettify minify
#' @param txt JSON string
#' @param indent number of spaces to indent
#' @useDynLib jsonlite R_reformat
#' @examples myjson <- toJSON(cars)
#' cat(myjson)
#' prettify(myjson)
#' minify(myjson)
prettify <- function(txt, indent = 4) {
  txt <- paste(txt, collapse = "\n")
  reformat(txt, TRUE, indent_string = paste(rep(" ", as.integer(indent)), collapse=""))
}

#' @rdname prettify
minify <- function(txt) {
  txt <- paste(txt, collapse = "\n")
  reformat(txt, FALSE)
}

reformat <- function(x, pretty, indent_string = ""){
  out <- .Call(R_reformat, x, pretty, indent_string = indent_string);
  if(out[[1]] == 0) {
    return(out[[2]])
  } else {
    stop(out[[2]], call.=FALSE)
  }
}

as.scalar <- function(obj) {
  # Lists can never be a scalar (this can arise if a dataframe contains a column
  # with lists)
  if(length(dim(obj)) > 1){
    if(!identical(nrow(obj), 1L)){
      warning("Tried to use as.scalar on an array or dataframe with ", nrow(obj), " rows.", call.=FALSE)
      return(obj)
    }
  } else if(!identical(length(obj), 1L)) {
    warning("Tried to use as.scalar on an object of length ", length(obj), call.=FALSE)
    return(obj)
  } else if(is.namedlist(obj)){
    warning("Tried to use as.scalar on a named list.", call.=FALSE)
    return(obj)
  }

  class(obj) <- c("scalar", class(obj))
  return(obj)
}

#' Prettify adds indentation to a JSON string; minify removes all indentation/whitespace.
#'
#' @rdname prettify
#' @title Prettify or minify a JSON string
#' @name prettify, minify
#' @aliases minify prettify
#' @export prettify minify
#' @param txt JSON string
#' @param indent number of spaces to indent. Use a negative number for tabs instead of spaces.
#' @useDynLib jsonlite R_reformat
#' @examples myjson <- toJSON(cars)
#' cat(myjson)
#' prettify(myjson)
#' minify(myjson)
prettify <- function(txt, indent = 4) {
  stopifnot(is.numeric(indent))
  txt <- paste(txt, collapse = "\n")
  indent_char <- ifelse(indent > 0, " ", "\t")
  indent_string <- paste(rep(indent_char, as.integer(abs(indent))), collapse = "")
  reformat(txt, TRUE, indent_string)
}

#' @rdname prettify
minify <- function(txt) {
  txt <- paste(txt, collapse = "\n")
  reformat(txt, FALSE)
}

reformat <- function(x, pretty, indent_string = "") {
  out <- .Call(R_reformat, x, pretty, indent_string = indent_string)
  if (out[[1]] == 0) {
    return(out[[2]])
  } else {
    stop(out[[2]], call. = FALSE)
  }
}

as.scalar <- function(obj) {
  # Lists can never be a scalar (this can arise if a dataframe contains a column
  # with lists)
  if (length(dim(obj)) > 1) {
    if (!identical(nrow(obj), 1L)) {
      warning("Tried to use as.scalar on an array or dataframe with ", nrow(obj), " rows.", call. = FALSE)
      return(obj)
    }
  } else if (!identical(length(obj), 1L)) {
    warning("Tried to use as.scalar on an object of length ", length(obj), call. = FALSE)
    return(obj)
  } else if (is.namedlist(obj)) {
    warning("Tried to use as.scalar on a named list.", call. = FALSE)
    return(obj)
  }

  class(obj) <- c("scalar", class(obj))
  return(obj)
}

setMethod("asJSON", "blob", function(x, raw = "base64", ...){
  if(identical(raw, "base64")){
    str <- vapply(x, base64_enc, character(1))
    return(asJSON(str, ...))
  }
  asJSON(as.list(x), raw = raw, ...)
})

setMethod("asJSON", "raw", function(x, raw = c("base64", "hex", "mongo", "int", "js"), ...) {

  # validate
  raw <- match.arg(raw)

  # encode based on schema
  if (raw == "mongo") {
    type <- ifelse(length(attr(x, "type")), attr(x, "type"), 5)
    return(asJSON(list(`$binary` = as.scalar(base64_enc(x)), `$type` = as.scalar(as.character(type)))))
  } else if (raw == "hex") {
    return(asJSON(as.character.hexmode(x), ...))
  } else if (raw == "int") {
    return(asJSON(as.integer(x), ...))
  } else if (raw == "js") {
    paste0('(new Uint8Array(', asJSON(as.integer(x), collapse = TRUE), '))')
  } else {
    # no as scalar here!
    return(asJSON(base64_enc(x), ...))
  }
})

# Note: 'symbol' is the same thing as 'name' For some reason, as.name('') gives
# an error, even though it is needed sometimes. This is a workaround
makesymbol <- function(x) {
  if (missing(x) || nchar(x) == 0) {
    return(substitute())
  } else {
    as.name(x)
  }
}

#' Combine pages into a single data frame
#'
#' The \code{rbind_pages} function is used to combine a list of data frames into a single
#' data frame. This is often needed when working with a JSON API that limits the amount
#' of data per request. If we need more data than what fits in a single request, we need to
#' perform multiple requests that each retrieve a fragment of data, not unlike pages in a
#' book. In practice this is often implemented using a \code{page} parameter in the API. The
#' \code{rbind_pages} function can be used to combine these pages back into a single dataset.
#'
#' The \code{\link{rbind_pages}} function generalizes \code{\link[base:cbind]{base::rbind}} and
#' \code{\link[plyr:rbind.fill]{plyr::rbind.fill}} with added support for nested data frames. Not each column
#' has to be present in each of the individual data frames; missing columns will be filled
#' up in \code{NA} values.
#'
#' @export
#' @param pages a list of data frames, each representing a \emph{page} of data
#' @examples # Basic example
#' x <- data.frame(foo = rnorm(3), bar = c(TRUE, FALSE, TRUE))
#' y <- data.frame(foo = rnorm(2), col = c("blue", "red"))
#' rbind_pages(list(x, y))
#'
#' \donttest{
#' baseurl <- "https://projects.propublica.org/nonprofits/api/v2/search.json"
#' pages <- list()
#' for(i in 0:20){
#'   mydata <- fromJSON(paste0(baseurl, "?order=revenue&sort_order=desc&page=", i))
#'   message("Retrieving page ", i)
#'   pages[[i+1]] <- mydata$organizations
#' }
#' organizations <- rbind_pages(pages)
#' nrow(organizations)
#' colnames(organizations)
#' }
rbind_pages <- function(pages){
  #Load plyr
  loadpkg("plyr")

  #validate input
  stopifnot(is.list(pages))

  # edge case
  if(!length(pages)){
    return(data.frame())
  }

  # All elements must be data frames or NULL.
  pages <- Filter(function(x) {!is.null(x)}, pages);
  stopifnot(all(vapply(pages, is.data.frame, logical(1))))

  # Extract data frame column names
  dfdf <- lapply(pages, vapply, is.data.frame, logical(1))
  dfnames <- unique(names(which(unlist(unname(dfdf)))))

  # No sub data frames
  if(!length(dfnames)){
    return(plyr::rbind.fill(pages))
  }

  # Extract the nested data frames
  subpages <- lapply(dfnames, function(colname){
    rbind_pages(lapply(pages, function(df) {
      if(!is.null(df[[colname]]))
        df[[colname]]
      else
        as.data.frame(matrix(nrow=nrow(df), ncol=0))
    }))
  })

  # Remove data frame columns
  pages <- lapply(pages, function(df){
    issubdf <- vapply(df, is.data.frame, logical(1))
    if(any(issubdf))
      df[issubdf] <- rep(NA, nrow(df))
    df
  })

  # Bind rows
  outdf <- plyr::rbind.fill(pages)

  # Combine wih sub dataframes
  for(i in seq_along(subpages)){
    outdf[[dfnames[i]]] <- subpages[[i]]
  }

  #out
  outdf
}

context("rbind_pages")

options(stringsAsFactors=FALSE)

test_that("handles named list argument", {
  x <- data.frame(foo = c(1:2))
  x$bar <- data.frame(name = c("jeroen", "eli"),
                     age  = c(28, 24))
  x  <- rep(list(x), 4)
  xn <- setNames(x, letters[1:4])

  expect_equal(rbind_pages(xn), rbind_pages(x))
  expect_false(all(is.na(rbind_pages(xn)$bar)))
})

test_that("handles empty input", {
  x <- rbind_pages(list())
  expect_is(x, "data.frame")
  expect_identical(dim(x), c(0L, 0L))
})

test_that("handles regular data frames", {
  x <- data.frame(a=1:2, b=3:4)
  y <- data.frame(c=5:6, d=7:8)

  xy <- rbind_pages(list(x, y))

  expect_equal(xy$a, c(1, 2, NA, NA))
  expect_equal(xy$b, c(3, 4, NA, NA))
  expect_equal(xy$c, c(NA, NA, 5, 6))
  expect_equal(xy$d, c(NA, NA, 7, 8))
})

test_that("rejects non-NULL, non-data frame inputs", {
  x <- 1:4
  y <- data.frame(a=1:4)
  expect_error(rbind_pages(list(x, y)))
})

test_that("handles nested data frames", {
  # need to construct this carefully to avoid data.frame() unnesting inputs
  dfx <- data.frame(a=1:2)
  dfx$df1 <- data.frame(b=3:4)
  dfx$df1$df2 <- data.frame(c=5:6, d=7:8)

  out <- rbind_pages(list(dfx, dfx))

  expect_is(out, "data.frame")
  expect_is(out$df1, "data.frame")
  expect_is(out$df1$df2, "data.frame")
  expect_identical(names(out$df1$df2), c("c", "d"))
  expect_identical(out$df1$df2$c, c(5L, 6L, 5L, 6L))
  expect_identical(out$df1$df2$d, c(7L, 8L, 7L, 8L))
})

context("rbind_pages")

options(stringsAsFactors=FALSE)

test_that("handles named list argument", {
  x <- data.frame(foo = c(1:2))
  x$bar = data.frame(name = c("jeroen", "eli"),
                     age  = c(28, 24))
  x  <- rep(list(x), 4)
  xn <- setNames(x, letters[1:4])

  expect_equal(rbind_pages(xn), rbind_pages(x))
  expect_false(all(is.na(rbind_pages(xn)$bar)))
})

#' Combine pages into a single data frame
#'
#' The \code{rbind_pages} function is used to combine a list of data frames into a single
#' data frame. This is often needed when working with a JSON API that limits the amount
#' of data per request. If we need more data than what fits in a single request, we need to
#' perform multiple requests that each retrieve a fragment of data, not unlike pages in a
#' book. In practice this is often implemented using a \code{page} parameter in the API. The
#' \code{rbind_pages} function can be used to combine these pages back into a single dataset.
#'
#' The \code{\link{rbind_pages}} function generalizes \code{\link[base:cbind]{base::rbind}} and
#' \code{\link[plyr:rbind.fill]{plyr::rbind.fill}} with added support for nested data frames. Not each column
#' has to be present in each of the individual data frames; missing columns will be filled
#' up in \code{NA} values.
#'
#' @export
#' @param pages a list of data frames, each representing a \emph{page} of data
#' @examples # Basic example
#' x <- data.frame(foo = rnorm(3), bar = c(TRUE, FALSE, TRUE))
#' y <- data.frame(foo = rnorm(2), col = c("blue", "red"))
#' rbind_pages(list(x, y))
#'
#' \donttest{
#' baseurl <- "https://projects.propublica.org/nonprofits/api/v2/search.json"
#' pages <- list()
#' for(i in 0:20){
#'   mydata <- fromJSON(paste0(baseurl, "?order=revenue&sort_order=desc&page=", i))
#'   message("Retrieving page ", i)
#'   pages[[i+1]] <- mydata$organizations
#' }
#' organizations <- rbind_pages(pages)
#' nrow(organizations)
#' colnames(organizations)
#' }
rbind_pages <- function(pages){
  #Load plyr
  loadpkg("plyr")

  #validate input
  stopifnot(is.list(pages))

  # edge case
  if(!length(pages)){
    return(data.frame())
  }

  # All elements must be data frames or NULL.
  pages <- Filter(function(x) {!is.null(x)}, pages);
  stopifnot(all(vapply(pages, is.data.frame, logical(1))))

  # Extract data frame column names
  dfdf <- lapply(pages, vapply, is.data.frame, logical(1))
  dfnames <- unique(names(which(unlist(dfdf))))

  # No sub data frames
  if(!length(dfnames)){
    return(plyr::rbind.fill(pages))
  }

  # Extract the nested data frames
  subpages <- lapply(dfnames, function(colname){
    rbind_pages(lapply(pages, function(df) {
      if(!is.null(df[[colname]]))
        df[[colname]]
      else
        as.data.frame(matrix(nrow=nrow(df), ncol=0))
    }))
  })

  # Remove data frame columns
  pages <- lapply(pages, function(df){
    issubdf <- vapply(df, is.data.frame, logical(1))
    if(any(issubdf))
      df[issubdf] <- rep(NA, nrow(df))
    df
  })

  # Bind rows
  outdf <- plyr::rbind.fill(pages)

  # Combine wih sub dataframes
  for(i in seq_along(subpages)){
    outdf[[dfnames[i]]] <- subpages[[i]]
  }

  #out
  outdf
}

setMethod("asJSON", "function", function(x, collapse = TRUE, fun = c("source", "list"), 
  ...) {
  # validate
  fun <- match.arg(fun)
  
  if (fun == "source") {
    return(asJSON(deparse(x), ...))
  } else {
    return(asJSON(as.list(x), ...))
  }
}) 

#' Combine pages into a single data frame
#'
#' The `rbind_pages` function is used to combine a list of data frames into a single
#' data frame. This is often needed when working with a JSON API that limits the amount
#' of data per request. If we need more data than what fits in a single request, we need to
#' perform multiple requests that each retrieve a fragment of data, not unlike pages in a
#' book. In practice this is often implemented using a `page` parameter in the API. The
#' `rbind_pages` function can be used to combine these pages back into a single dataset.
#'
#' The `rbind_pages` function uses [vctrs::vec_rbind()]
#' to bind the pages together. This generalizes [`base::rbind()`][base::cbind] in two
#' ways:
#'
#' - Not each column has to be present in each of the individual data frames; missing
#'   columns will be filled up in `NA` values.
#' - Data frames can be nested (can contain other data frames).
#'
#' @export
#' @param pages a list of data frames, each representing a *page* of data
#' @examples # Basic example
#' x <- data.frame(foo = rnorm(3), bar = c(TRUE, FALSE, TRUE))
#' y <- data.frame(foo = rnorm(2), col = c("blue", "red"))
#' rbind_pages(list(x, y))
#'
#' \donttest{
#' baseurl <- "https://projects.propublica.org/nonprofits/api/v2/search.json"
#' pages <- list()
#' for(i in 0:20){
#'   mydata <- fromJSON(paste0(baseurl, "?order=revenue&sort_order=desc&page=", i))
#'   message("Retrieving page ", i)
#'   pages[[i+1]] <- mydata$organizations
#' }
#' organizations <- rbind_pages(pages)
#' nrow(organizations)
#' colnames(organizations)
#' }
rbind_pages <- function(pages){
  loadpkg("vctrs")

  #validate input
  stopifnot(is.list(pages))

  # All elements must be data frames or NULL.
  pages <- Filter(function(x) {!is.null(x)}, pages);
  stopifnot(all(vapply(pages, is.data.frame, logical(1))))

  do.call(vctrs::vec_rbind, pages)
}

#' Read/write JSON
#'
#' These functions are similar to \link{toJSON} and \link{fromJSON} except they
#' explicitly distinguish between path and literal input, and do not simplify
#' by default.
#'
#' @export
#' @rdname read_json
#' @param path file on disk
#' @param simplifyVector simplifies nested lists into vectors and data frames. See \link{fromJSON}.
#' @seealso \code{\link{fromJSON}}, \code{\link{stream_in}}
#' @examples tmp <- tempfile()
#' write_json(iris, tmp)
#'
#' # Nested lists
#' read_json(tmp)
#'
#' # A data frame
#' read_json(tmp, simplifyVector = TRUE)
read_json <- function(path, simplifyVector = FALSE, ...){
  parse_json(file(path), simplifyVector = simplifyVector, ...)
}

#' @export
#' @rdname read_json
#' @param json string with literal json or connection object to read from
parse_json <- function(json, simplifyVector = FALSE, ...){
  parse_and_simplify(json, simplifyVector = simplifyVector, ...)
}

#' @export
#' @rdname read_json
#' @param x an object to be serialized to JSON
#' @param ... additional conversion arguments, see also \link{toJSON} or \link{fromJSON}
write_json <- function(x, path, ...) {
  json <- jsonlite::toJSON(x, ...)
  writeLines(json, path, useBytes = TRUE)
}

context("libjson UTF-8 characters")

# Some notes: JSON defines UTF-8 as the default charset. Therefore all encoders and
# decoders are required to support UTF-8. JSON also allows for escaped unicode, i.e
# \u00F8 however this is mostly for legacy purposes. Using actual UTF-8 characters
# is easier and more efficient.


test_that("test that non ascii characters are ok", {

  #create random strings
  objects <- list(
    enc2utf8("Z\u00fcrich"),
    enc2native("Ma\u00eblle"),
    "\u5317\u4eac\u586b\u9d28\u4eec",
    "\u0e1c\u0e31\u0e14\u0e44\u0e17",
    "\u5bff\u53f8",
    c("\u5bff\u53f8", "Z\\u00fcrich", "foo", "bla\001\002\003bla"),
    rawToChar(as.raw(1:40))
  )

  lapply(objects, function(x){
    #Encoding(x) <- "UTF-8"
    myjson <- toJSON(x, pretty=TRUE);
    expect_true(validate(myjson));
    expect_that(fromJSON(myjson), equals(x));

    #prettify needs to parse + output
    prettyjson <- prettify(myjson);
    expect_true(validate(prettyjson));
    expect_that(fromJSON(prettyjson), equals(x));

    #test encoding is preserved when roundtripping to disk
    tmp <- tempfile()
    write_json(x, tmp)
    expect_that(read_json(tmp, simplifyVector = TRUE), equals(x));
    unlink(tmp)
  });

  #Test escaped unicode characters
  expect_that(fromJSON('["Z\\u00FCrich"]'), equals("Z\u00fcrich"));
  expect_that(fromJSON(prettify('["Z\\u00FCrich"]')), equals("Z\u00fcrich"));

  expect_that(length(unique(fromJSON('["Z\\u00FCrich", "Z\u00fcrich"]'))), equals(1L))
  expect_that(fromJSON('["\\u586B"]'), equals("\u586b"));
  expect_that(fromJSON(prettify('["\\u586B"]')), equals("\u586B"));

});

context("libjson UTF-8 characters")

# Some notes: JSON defines UTF-8 as the default charset. Therefore all encoders and
# decoders are required to support UTF-8. JSON also allows for escaped unicode, i.e
# \u00F8 however this is mostly for legacy purposes. Using actual UTF-8 characters
# is easier and more efficient.


test_that("test that non ascii characters are ok", {

  #create random strings
  objects <- list(
    enc2utf8("Z\u00fcrich"),
    enc2native("Ma\u00eblle"),
    "\u5317\u4eac\u586b\u9d28\u4eec",
    "\u0e1c\u0e31\u0e14\u0e44\u0e17",
    "\u5bff\u53f8",
    c("\u5bff\u53f8", "Z\\u00fcrich", "foo", "bla\001\002\003bla"),
    rawToChar(as.raw(1:40))
  )

  lapply(objects, function(x){
    #Encoding(x) <- "UTF-8"
    myjson <- toJSON(x, pretty=TRUE);
    expect_true(validate(myjson));
    expect_equal(fromJSON(myjson), x);

    #prettify needs to parse + output
    prettyjson <- prettify(myjson);
    expect_true(validate(prettyjson));
    expect_equal(fromJSON(prettyjson), x);

    #test encoding is preserved when roundtripping to disk
    tmp <- tempfile()
    write_json(x, tmp)
    expect_equal(read_json(tmp, simplifyVector = TRUE), x);
    unlink(tmp)
  });

  #Test escaped unicode characters
  expect_equal(fromJSON('["Z\\u00FCrich"]'), "Z\u00fcrich");
  expect_equal(fromJSON(prettify('["Z\\u00FCrich"]')), "Z\u00fcrich");

  expect_equal(length(unique(fromJSON('["Z\\u00FCrich", "Z\u00fcrich"]'))), 1L);
  expect_equal(fromJSON('["\\u586B"]'), "\u586b");
  expect_equal(fromJSON(prettify('["\\u586B"]')), "\u586B");

});

test_that("Writing SF objects", {
  skip_if_not(require(sf))
  compare_to_geojson_obj <- function(sf_obj){
    sf_as_dataframe <- fromJSON(toJSON(sf_obj, digits = 8))
    sf_as_features <- fromJSON(toJSON(sf_obj, sf = 'features', digits = 8))
    geojson_string <- toJSON(sf_obj, sf = 'geojson', digits = 8)
    sf_as_geojson <- parse_json(geojson_string)
    tmp <- file.path(tempdir(), 'sfdata.geojson')
    on.exit(unlink(tmp))
    sf::write_sf(sf_obj, tmp, driver = 'GeoJSON')
    geojson <- fromJSON(tmp)
    geojson_exact <- read_json(tmp)
    geojson_exact$crs = NULL # We don't add CRS because it was deprecated in geojson spec
    expect_equal(sf_as_dataframe[[attr(sf_obj, 'sf_column')]], geojson$features$geometry)
    expect_equal(sf_as_features, geojson$features)
    expect_equal(sf_as_geojson, geojson_exact)
  }

  compare_to_geojson_file <- function(file){
    sf_obj <- sf::st_read(file, quiet = TRUE)
    compare_to_geojson_obj(sf_obj)
    compare_to_geojson_obj(sf_obj[1,])
    compare_to_geojson_obj(sf_obj[0,])
  }

  # Test with some standard data
  compare_to_geojson_file(system.file("shape/storms_xyz.shp", package = "sf"))
  compare_to_geojson_file(system.file("shape/nc.shp", package = "sf"))
  #compare_to_geojson_file(system.file("examples", "us_states.topojson", package = "geojsonio"))

  # Test special types, from ?st examples
  outer = matrix(c(0,0,10,0,10,10,0,10,0,0.0), ncol=2, byrow=TRUE)
  hole1 = matrix(c(1,1,1,2,2,2,2,1,1,1.0), ncol=2, byrow=TRUE)
  hole2 = matrix(c(5,5,5,6,6,6,6,5,5,5.0), ncol=2, byrow=TRUE)
  pts = list(outer, hole1, hole2)
  ml1 = st_multilinestring(pts)
  pl1 = st_polygon(pts)
  pol1 = list(outer, hole1, hole2)
  pol2 = list(outer + 12, hole1 + 12)
  pol3 = list(outer + 24)
  mpl1 = st_multipolygon(list(pol1,pol2,pol3))
  p1 = st_point(as.double(1:2))
  mp1 = st_multipoint(matrix(as.double(1:10), ncol = 2))
  ls1 = st_linestring(matrix(as.double(1:10), ncol = 2))
  gcol = st_geometrycollection(list(p1, ls1, pl1, mp1))
  geometry = st_sfc(
    p1,
    mp1,
    ls1,
    ml1,
    pl1,
    mpl1,
    gcol
  )
  sf_obj <- st_sf(geoms = geometry)
  compare_to_geojson_obj(sf_obj)

  # One very strict test
  geojson_string <- toJSON(sf_obj, sf = 'geojson', always_decimal = TRUE, digits = 8)
  tmp <- file.path(tempdir(), 'sfdata.geojson')
  on.exit(unlink(tmp))
  sf::write_sf(sf_obj, tmp, driver = 'GeoJSON')
  expect_equal(minify(geojson_string), minify(readLines(tmp)))
})

test_that("Writing SF objects", {
  skip_if_not(require(sf))
  compare_to_geojson_obj <- function(sf_obj){
    sf_as_dataframe <- fromJSON(toJSON(sf_obj, digits = 8))
    sf_as_features <- fromJSON(toJSON(sf_obj, sf = 'features', digits = 8))
    geojson_string <- toJSON(sf_obj, sf = 'geojson', digits = 8)
    sf_as_geojson <- parse_json(geojson_string)
    tmp <- file.path(tempdir(), 'sfdata.geojson')
    on.exit(unlink(tmp))
    sf::write_sf(sf_obj, tmp, driver = 'GeoJSON')
    geojson <- fromJSON(tmp)
    geojson_exact <- read_json(tmp)
    geojson_exact$crs = NULL # We don't add CRS because it was deprecated in geojson spec
    expect_equal(sf_as_dataframe$geometry, geojson$features$geometry)
    expect_equal(sf_as_features, geojson$features)
    expect_equal(sf_as_geojson, geojson_exact)
  }

  compare_to_geojson_file <- function(file){
    sf_obj <- sf::st_read(file, quiet = TRUE)
    compare_to_geojson_obj(sf_obj)
    compare_to_geojson_obj(sf_obj[1,])
    compare_to_geojson_obj(sf_obj[0,])
  }

  # Test with some standard data
  compare_to_geojson_file(system.file("shape/storms_xyz.shp", package = "sf"))
  compare_to_geojson_file(system.file("shape/nc.shp", package = "sf"))
  #compare_to_geojson_file(system.file("examples", "us_states.topojson", package = "geojsonio"))

  # Test special types, from ?st examples
  outer = matrix(c(0,0,10,0,10,10,0,10,0,0.0), ncol=2, byrow=TRUE)
  hole1 = matrix(c(1,1,1,2,2,2,2,1,1,1.0), ncol=2, byrow=TRUE)
  hole2 = matrix(c(5,5,5,6,6,6,6,5,5,5.0), ncol=2, byrow=TRUE)
  pts = list(outer, hole1, hole2)
  ml1 = st_multilinestring(pts)
  pl1 = st_polygon(pts)
  pol1 = list(outer, hole1, hole2)
  pol2 = list(outer + 12, hole1 + 12)
  pol3 = list(outer + 24)
  mpl1 = st_multipolygon(list(pol1,pol2,pol3))
  p1 = st_point(as.double(1:2))
  mp1 = st_multipoint(matrix(as.double(1:10), ncol = 2))
  ls1 = st_linestring(matrix(as.double(1:10), ncol = 2))
  gcol = st_geometrycollection(list(p1, ls1, pl1, mp1))
  geometry = st_sfc(
    p1,
    mp1,
    ls1,
    ml1,
    pl1,
    mpl1,
    gcol
  )
  sf_obj <- st_sf(geometry)
  compare_to_geojson_obj(sf_obj)

  # One very strict test
  geojson_string <- toJSON(sf_obj, sf = 'geojson', always_decimal = TRUE, digits = 8)
  tmp <- file.path(tempdir(), 'sfdata.geojson')
  on.exit(unlink(tmp))
  sf::write_sf(sf_obj, tmp, driver = 'GeoJSON')
  expect_equal(minify(geojson_string), minify(readLines(tmp)))
})

#' Read/write JSON
#'
#' These functions are similar to \link{toJSON} and \link{fromJSON} except they
#' explicitliy distinguish between path and literal input, and do not simplify
#' by default.
#'
#' @export
#' @rdname read_json
#' @param path file on disk
#' @param simplifyVector simplifies nested lists into vectors and data frames. See \link{fromJSON}.
#' @examples tmp <- tempfile()
#' write_json(iris, tmp)
#'
#' # Nested lists
#' read_json(tmp)
#'
#' # A data frame
#' read_json(tmp, simplifyVector = TRUE)
read_json <- function(path, simplifyVector = FALSE, ...){
  parse_json(file(path), simplifyVector = simplifyVector, ...)
}

#' @export
#' @rdname read_json
#' @param json string with literal json or connection object to read from
parse_json <- function(json, simplifyVector = FALSE, ...){
  parse_and_simplify(json, simplifyVector = simplifyVector, ...)
}

#' @export
#' @rdname read_json
#' @param x an object to be serialized to JSON
#' @param ... additional conversion arguments, see also \link{toJSON} or \link{fromJSON}
write_json <- function(x, path, ...) {
  json <- jsonlite::toJSON(x, ...)
  writeLines(json, path, useBytes = TRUE)
}

#' Validate JSON
#'
#' Test if a string contains valid JSON. Characters vectors will be collapsed into a single string.
#'
#' @param txt JSON string
#' @export
#' @useDynLib jsonlite R_validate
#' @examples #Output from toJSON and serializeJSON should pass validation
#' myjson <- toJSON(mtcars)
#' validate(myjson) #TRUE
#'
#' #Something bad happened
#' truncated <- substring(myjson, 1, 100)
#' validate(truncated) #FALSE
validate <- function(txt) {
  stopifnot(is.character(txt))
  txt <- paste(txt, collapse = "\n")
  .Call(R_validate, as.character(txt))
}

is_scalarlist_r <- function(x) {
  if(!is.list(x)) return(FALSE)
  for(i in x){
    if(!is.atomic(i) || length(i) > 1) return(FALSE)
  }
  return(TRUE)
}

#' @useDynLib jsonlite C_is_scalarlist
is_scalarlist_c <- function(x){
  .Call(C_is_scalarlist, x)
}

is.scalarlist <- is_scalarlist_c;

cleannames <- function(objnames, no_dots = FALSE){
  objnames[objnames == ""] <- NA_character_
  is_missing <- is.na(objnames)
  objnames[is_missing] <- as.character(seq_len(length(objnames)))[is_missing]
  if(isTRUE(no_dots))
    objnames <- gsub(".", "_", objnames, fixed = TRUE)
  make.unique(objnames)
}

# For 'sf' geometry columns; use same structure as GeoJSON
setOldClass('sf')
setMethod("asJSON", "sf", function(x, sf = c("dataframe", "features", "geojson"), ...) {
  sf <- match.arg(sf)
  if(sf == 'dataframe'){
    callNextMethod()
  } else {
    sf_column <- attr(x, 'sf_column')
    if(!length(sf_column))
      sf_column <- 'geometry'
    geometry <- x[[sf_column]]
    input <- as.data.frame(x)
    features <- data.frame(type = rep('Feature', nrow(input)), stringsAsFactors = FALSE)
    features$properties = input[names(input) != sf_column]
    features$geometry = geometry
    if(sf == 'features'){
      asJSON(features, sf = sf, ...)
    } else {
      output <- list(
        type = unbox('FeatureCollection'),
        name = unbox('sfdata'),
        features = features
      )
      asJSON(output, sf = sf, ...)
    }
  }
})

setOldClass('sfc')
setMethod("asJSON", "sfc", function(x, ...) {
  y <- lapply(unclass(x), geom_to_geojson)
  asJSON(y, ...)
})

geom_to_geojson <- function(x){
  val <- list(
    type = unbox(sf_to_titlecase(class(x)[2])) # see: sf::st_geometry_type
  )
  if(inherits(x, "GEOMETRYCOLLECTION")){
    val$geometries = lapply(x, geom_to_geojson)
  } else {
    val$coordinates = unclass(x)
  }
  return(val)
}

# See sf::sf.tp
sf_to_titlecase <- function(x){
  sf_types <-
    c("Point", "LineString", "Polygon", "MultiPoint", "MultiLineString",
      "MultiPolygon", "GeometryCollection", "CircularString", "CompoundCurve",
      "CurvePolygon", "MultiCurve", "MultiSurface", "Curve", "Surface",
      "PolyhedralSurface", "TIN", "Triangle")
  matches <- match(as.character(x), toupper(sf_types))
  sf_types[matches]
}

setMethod("asJSON", "POSIXt", function(x, POSIXt = c("string", "ISO8601", "epoch",
  "mongo"), UTC = FALSE, digits, time_format = NULL, always_decimal = FALSE, ...) {
  # note: UTC argument doesn't seem to be working consistently maybe use ?format
  # instead of ?as.character

  # Validate
  POSIXt <- match.arg(POSIXt)

  # Encode based on a schema
  if (POSIXt == "mongo") {
    return(asJSON_posix_mongo(x, ...))
  }

  # Epoch millis
  if (POSIXt == "epoch") {
    return(asJSON(floor(unclass(as.POSIXct(x)) * 1000), digits = digits, always_decimal = FALSE, ...))
  }

  # Strings
  if(is.null(time_format)){
    time_format <- if(POSIXt == "string"){
      ""
    } else if(isTRUE(UTC)){
      "%Y-%m-%dT%H:%M:%SZ"
    } else {
      "%Y-%m-%dT%H:%M:%S"
    }
  }

  if (isTRUE(UTC)) {
    asJSON(as.character(x, format = time_format, tz = "UTC"), ...)
  } else {
    asJSON(as.character(x, format = time_format), ...)
  }
})

asJSON_posix_mongo <- function(x, collapse = TRUE, indent = NA_integer_, ...){
  if (inherits(x, "POSIXlt")) {
    x <- as.POSIXct(x)
  }
  df <- data.frame("$date" = floor(unclass(x) * 1000), check.names = FALSE)
  if(inherits(x, "scalar"))
    class(df) <- c("scalar", class(df))
  tmp <- asJSON(df, digits = NA, always_decimal = FALSE, ..., collapse = FALSE)
  tmp[is.na(x)] <- asJSON(NA_character_, collapse = FALSE, ...)
  if(isTRUE(collapse)){
    collapse(tmp, inner = FALSE, indent = indent)
  } else {
    tmp
  }
}

simplifyDataFrame <- function(recordlist, columns, flatten, simplifyMatrix) {

  # no records at all
  if (!length(recordlist)) {
    if (!missing(columns)) {
      return(as.data.frame(matrix(ncol = length(columns), nrow = 0, dimnames = list(NULL,
        columns))))
    } else {
      return(data.frame())
    }
  }

  # only empty records and unknown columns
  if (!any(vapply(recordlist, length, integer(1), USE.NAMES = FALSE)) && missing(columns)) {
    return(data.frame(matrix(nrow = length(recordlist), ncol = 0)))
  }

  # find columns if not specified
  if (missing(columns)) {
    columns <- unique(unlist(lapply(recordlist, names), recursive = FALSE, use.names = FALSE))
  }

  # Convert row lists to column lists. This is the heavy lifting
  # columnlist <- lapply(columns, function(x) lapply(recordlist, "[[", x))
  # Now slighlty optimized
  columnlist <- transpose_list(recordlist, columns)

  # simplify vectors and nested data frames
  columnlist <- lapply(columnlist, simplify, simplifyVector = TRUE, simplifyDataFrame = TRUE,
    simplifyMatrix = FALSE, simplifySubMatrix = simplifyMatrix, flatten = flatten)

  # check that all elements have equal length
  columnlengths <- unlist(vapply(columnlist, function(z) {
    ifelse(length(dim(z)) > 1, nrow(z), length(z))
  }, integer(1)))
  n <- unique(columnlengths)
  if (length(n) > 1) {
    stop("Elements not of equal length: ", paste(columnlengths, collapse = " "))
  }

  # add the column names before flattening
  names(columnlist) <- columns

  # flatten nested data frames
  if(isTRUE(flatten)) {
    dfcolumns <- vapply(columnlist, is.data.frame, logical(1))
    if(any(dfcolumns)){
      columnlist <- c(columnlist[!dfcolumns], do.call(c, columnlist[dfcolumns]))
    }
  }

  # make into data frame
  class(columnlist) <- "data.frame"

  # set row names
  if("_row" %in% names(columnlist)) {
    rn <- columnlist[["_row"]];
    columnlist["_row"] <- NULL;

    # row.names() casts double to character which is undesired.
    if(is.double(rn)) {
      rn <- as.integer(rn);
    }

    # Replace missing values with numbers
    rn_na <- is.na(rn)
    if(sum(rn_na) > 0){
      rn[rn_na] <- paste0("NA_", seq_len(sum(rn_na)))
    }

    # data frames MUST have row names
    if(any(duplicated(rn))){
      warning('Duplicate names in "_row" field. Data frames must have unique row names.', call. = FALSE)
      if(is.character(rn)) {
        row.names(columnlist)  <- make.unique(rn)
      } else {
        row.names(columnlist) <- seq_len(n)
      }
    } else {
      row.names(columnlist) <- rn;
    }
  } else {
    row.names(columnlist) <- seq_len(n)
  }

  return(columnlist)
}

# This function deals with some uncertainty in character encoding when reading
# from files and URLs. It tries UTF8 first, but falls back on native if it is
# certainly not UTF8.
raw_to_json <- function(x){
  txt <- rawToChar(x);
  Encoding(txt) <- "UTF-8"
  isvalid <- validate(txt)
  if(!isvalid && grepl("invalid bytes in UTF8", attr(isvalid, "err"), fixed=TRUE, useBytes=TRUE)){
    warning("The json string is not valid UTF-8. Assuming native encoding.", call. = FALSE)
    Encoding(txt) <- "";
  }
  return(txt)
}

# For 'sf' geometry columns; use same structure as GeoJSON
setMethod("asJSON", "sf", function(x, sf = c("dataframe", "features", "geojson"), ...) {
  sf <- match.arg(sf)
  if(sf == 'dataframe'){
    callNextMethod()
  } else {
    sf_column <- attr(x, 'sf_column')
    if(!length(sf_column))
      sf_column <- 'geometry'
    geometry <- x[[sf_column]]
    input <- as.data.frame(x)
    features <- data.frame(type = rep('Feature', nrow(input)), stringsAsFactors = FALSE)
    features$properties = input[names(input) != sf_column]
    features$geometry = geometry
    if(sf == 'features'){
      asJSON(features, sf = sf, ...)
    } else {
      output <- list(
        type = unbox('FeatureCollection'),
        name = unbox('sfdata'),
        features = features
      )
      asJSON(output, sf = sf, ...)
    }
  }
})

setMethod("asJSON", "sfc", function(x, ...) {
  y <- lapply(unclass(x), geom_to_geojson)
  asJSON(y, ...)
})

geom_to_geojson <- function(x){
  val <- list(
    type = unbox(sf_to_titlecase(class(x)[2])) # see: sf::st_geometry_type
  )
  if(inherits(x, "GEOMETRYCOLLECTION")){
    val$geometries = lapply(x, geom_to_geojson)
  } else {
    val$coordinates = unclass(x)
  }
  return(val)
}

# See sf::sf.tp
sf_to_titlecase <- function(x){
  sf_types <-
    c("Point", "LineString", "Polygon", "MultiPoint", "MultiLineString",
      "MultiPolygon", "GeometryCollection", "CircularString", "CompoundCurve",
      "CurvePolygon", "MultiCurve", "MultiSurface", "Curve", "Surface",
      "PolyhedralSurface", "TIN", "Triangle")
  matches <- match(as.character(x), toupper(sf_types))
  sf_types[matches]
}

setMethod("asJSON", "Date", function(x, Date = c("ISO8601", "epoch"), always_decimal = FALSE, ...) {

  # Validate argument
  Date <- match.arg(Date)

  # select a schema
  output <- switch(Date,
    ISO8601 = as.character(x),
    epoch = unclass(x),
    default = stop("Invalid argument for 'Date':", Date)
  )

  # Dispatch to character encoding
  asJSON(output, always_decimal = FALSE, ...)
})

simplify <- function(x, simplifyVector = TRUE, simplifyDataFrame = TRUE, simplifyMatrix = TRUE,
  simplifyDate = simplifyVector, homoList = TRUE, flatten = FALSE, columnmajor = FALSE,
  simplifySubMatrix = simplifyMatrix) {

  #This includes '[]' and '{}')
  if (!is.list(x) || !length(x)) {
    return(x)
  }

  # list can be a dataframe recordlist
  if (isTRUE(simplifyDataFrame) && is.recordlist(x)) {
    mydf <- simplifyDataFrame(x, flatten = flatten, simplifyMatrix = simplifySubMatrix)
    if(isTRUE(simplifyDate) && is.data.frame(mydf) && is.datelist(mydf)){
      return(parse_date(mydf[["$date"]]))
    }
    return(mydf)
  }

  # or a scalar list (atomic vector)
  if (isTRUE(simplifyVector) && is.null(names(x)) && is.scalarlist(x)) {
    return(list_to_vec(x))
  }

  # apply recursively
  out <- lapply(x, simplify, simplifyVector = simplifyVector, simplifyDataFrame = simplifyDataFrame,
    simplifyMatrix = simplifySubMatrix, columnmajor = columnmajor, flatten = flatten)

  # fix for mongo style dates turning into scalars *after* simplifying
  # only happens when simplifyDataframe=FALSE
  if(isTRUE(simplifyVector) && is.scalarlist(out) && all(vapply(out, inherits, logical(1), "POSIXt"))){
    return(structure(list_to_vec(out), class=c("POSIXct", "POSIXt")))
  }

  # test for matrix. Note that we have to take another look at x (before
  # list_to_vec on its elements) to differentiate between matrix and vector.
  if (isTRUE(simplifyMatrix) && isTRUE(simplifyVector) && is.matrixlist(out) && all(unlist(vapply(x, is.scalarlist, logical(1))))) {
    if(isTRUE(columnmajor)){
      return(do.call(cbind, out))
    } else {
      #this is currently the default
      return(do.call(rbind, out))
    }
  }

  # Simplify higher arrays
  if (isTRUE(simplifyMatrix) && is.arraylist(out)){
    if(isTRUE(columnmajor)){
      return(array(
        data = do.call(cbind, out),
        dim = c(dim(out[[1]]), length(out))
      ));
    } else {
      #this is currently the default
      return(array(
        data = do.call(rbind, lapply(out, as.vector)),
        dim = c(length(out), dim(out[[1]]))
      ));
    }
  }

  # try to enfoce homoList on unnamed lists
  if (isTRUE(homoList) && is.null(names(out))) {
    # coerse empty lists, caused by the ambiguous fromJSON('[]')
    isemptylist <- vapply(out, identical, logical(1), list())
    if (any(isemptylist) & !all(isemptylist)) {
      # if all the others look like data frames, coerse to data frames!
      if (all(vapply(out[!isemptylist], is.data.frame, logical(1)))) {
        for (i in which(isemptylist)) {
        out[[i]] <- data.frame()
        }
        return(out)
      }

      # if all others look like atomic vectors, unlist all
      if (all(vapply(out[!isemptylist], function(z) {
        isTRUE(is.vector(z) && is.atomic(z))
      }, logical(1)))) {
        for (i in which(isemptylist)) {
        out[[i]] <- vector(mode = typeof(out[[which(!isemptylist)[1]]]))
        }
        return(out)
      }
    }
  }

  # convert date object
  if( isTRUE(simplifyDate) && is.datelist(out) ){
    return(parse_date(out[["$date"]]))
  }

  # return object
  return(out)
}

is.matrixlist <- function(x) {
  isTRUE(is.list(x)
    && length(x)
    && is.null(names(x))
    && all(vapply(x, is.atomic, logical(1)))
    && all.identical(vapply(x, length, integer(1)))
    #&& all.identical(vapply(x, mode, character(1))) #this fails for: [ [ 1, 2 ], [ "NA", "NA" ] ]
  );
}

is.arraylist <- function(x) {
  isTRUE(is.list(x)
    && length(x)
    && is.null(names(x))
    && all(vapply(x, is.array, logical(1)))
    && all.identical(vapply(x, function(y){paste(dim(y), collapse="-")}, character(1)))
  );
}

is.datelist <- function(x){
  isTRUE(is.list(x)
     && identical(names(x), "$date")
     && (is.numeric(x[["$date"]]) || is.character(x[["$date"]]))
  );
}

parse_date <- function(x){
  if(is.numeric(x)){
    return(structure(x/1000, class=c("POSIXct", "POSIXt")))
  } else if(is.character(x)) {
    #tz is not vectorized, so assume all() are the same
    is_utc <- ifelse(all(grepl("Z$", x)), "UTC", "")
    return(as.POSIXct(strptime(x, format = '%Y-%m-%dT%H:%M:%OS', tz = is_utc)))
  } else {
    return(x)
  }
}

all.identical <- function(x){
  if(!length(x)) return(FALSE)
  for(i in x){
    if(x[1] != i) return(FALSE)
  }
  return(TRUE)
}

#' Encode/decode base64
#'
#' Simple in-memory base64 encoder and decoder. Used internally for converting
#' raw vectors to text. Interchangeable with encoder from \code{base64enc} or
#' \code{openssl} package.
#'
#' @param input string or raw vector to be encoded/decoded
#' @export
#' @rdname base64
#' @name base64
#' @useDynLib jsonlite R_base64_decode
#' @examples str <- base64_enc(serialize(iris, NULL))
#' out <- unserialize(base64_dec(str))
#' stopifnot(identical(out, iris))
base64_dec <- function(input) {
  if(is.character(input)){
    input <- charToRaw(paste(input, collapse = "\n"))
  }
  stopifnot(is.raw(input))
  .Call(R_base64_decode, input)
}

#' @export
#' @rdname base64
#' @useDynLib jsonlite R_base64_encode
base64_enc <- function(input) {
  if(is.null(input))
    return(NA_character_)
  if(is.character(input)){
    input <- charToRaw(paste(input, collapse = "\n"))
  }
  stopifnot(is.raw(input))
  .Call(R_base64_encode, input)
}

#' Encode/decode base64
#'
#' Simple in-memory base64 encoder and decoder. Used internally for converting
#' raw vectors to text. Interchangeable with encoder from \code{base64enc} or
#' \code{openssl} package.
#'
#' @param input string or raw vector to be encoded/decoded
#' @export
#' @rdname base64
#' @name base64
#' @useDynLib jsonlite R_base64_decode
#' @examples str <- base64_enc(serialize(iris, NULL))
#' out <- unserialize(base64_dec(str))
#' stopifnot(identical(out, iris))
base64_dec <- function(input) {
  if(is.character(input)){
    input <- charToRaw(paste(input, collapse = "\n"))
  }
  stopifnot(is.raw(input))
  .Call(R_base64_decode, input)
}

#' @export
#' @rdname base64
#' @useDynLib jsonlite R_base64_encode
base64_enc <- function(input) {
  if(is.character(input)){
    input <- charToRaw(paste(input, collapse = "\n"))
  }
  stopifnot(is.raw(input))
  .Call(R_base64_encode, input)
}

setMethod("asJSON", "Date", function(x, Date = c("ISO8601", "epoch"), always_decimal = FALSE, ...) {

  # Validate argument
  Date <- match.arg(Date)

  # select a schema
  output <- switch(Date,
    ISO8601 = format(x),
    epoch = unclass(x),
    default = stop("Invalid argument for 'Date':", Date)
  )

  # Dispatch to character encoding
  asJSON(output, always_decimal = FALSE, ...)
})

simplify <- function(x, simplifyVector = TRUE, simplifyDataFrame = TRUE, simplifyMatrix = TRUE,
  simplifyDate = simplifyVector, homoList = TRUE, flatten = FALSE, columnmajor = FALSE,
  simplifySubMatrix = simplifyMatrix) {

  #This includes '[]' and '{}')
  if (!is.list(x) || !length(x)) {
    return(x)
  }

  # list can be a dataframe recordlist
  if (isTRUE(simplifyDataFrame) && is.recordlist(x)) {
    mydf <- simplifyDataFrame(x, flatten = flatten, simplifyMatrix = simplifySubMatrix)
    if(isTRUE(simplifyDate) && is.data.frame(mydf) && is.datelist(mydf)){
      return(parse_date(mydf[["$date"]]))
    }
    return(mydf)
  }

  # or a scalar list (atomic vector)
  if (isTRUE(simplifyVector) && is.null(names(x)) && is.scalarlist(x)) {
    return(list_to_vec(x))
  }

  # apply recursively
  out <- lapply(x, simplify, simplifyVector = simplifyVector, simplifyDataFrame = simplifyDataFrame,
    simplifyMatrix = simplifySubMatrix, columnmajor = columnmajor, flatten = flatten)

  # fix for mongo style dates turning into scalars *after* simplifying
  # only happens when simplifyDataframe=FALSE
  if(isTRUE(simplifyVector) && is.scalarlist(out) && all(vapply(out, inherits, logical(1), "POSIXt"))){
    return(structure(list_to_vec(out), class=c("POSIXct", "POSIXt")))
  }

  # test for matrix. Note that we have to take another look at x (before
  # list_to_vec on its elements) to differentiate between matrix and vector.
  if (isTRUE(simplifyMatrix) && isTRUE(simplifyVector) && is.matrixlist(out) && all(unlist(vapply(x, is.scalarlist, logical(1))))) {
    if(isTRUE(columnmajor)){
      return(do.call(cbind, out))
    } else {
      #this is currently the default
      return(do.call(rbind, out))
    }
  }

  # Simplify higher arrays
  if (isTRUE(simplifyMatrix) && is.arraylist(out)){
    if(isTRUE(columnmajor)){
      return(array(
        data = do.call(cbind, out),
        dim = c(dim(out[[1]]), length(out))
      ));
    } else {
      #this is currently the default
      return(array(
        data = do.call(rbind, lapply(out, as.vector)),
        dim = c(length(out), dim(out[[1]]))
      ));
    }
  }

  # try to enfoce homoList on unnamed lists
  if (isTRUE(homoList) && is.null(names(out))) {
    # coerse empty lists, caused by the ambiguous fromJSON('[]')
    isemptylist <- vapply(out, identical, logical(1), list())
    if (any(isemptylist) & !all(isemptylist)) {
      # if all the others look like data frames, coerse to data frames!
      if (all(vapply(out[!isemptylist], is.data.frame, logical(1)))) {
        for (i in which(isemptylist)) {
        out[[i]] <- data.frame()
        }
        return(out)
      }

      # if all others look like atomic vectors, unlist all
      if (all(vapply(out[!isemptylist], function(z) {
        isTRUE(is.vector(z) && is.atomic(z))
      }, logical(1)))) {
        for (i in which(isemptylist)) {
        out[[i]] <- vector(mode = typeof(out[[which(!isemptylist)[1]]]))
        }
        return(out)
      }
    }
  }

  # convert date object
  if( isTRUE(simplifyDate) && is.datelist(out) ){
    return(parse_date(out[["$date"]]))
  }

  # return object
  return(out)
}

is.matrixlist <- function(x) {
  isTRUE(is.list(x)
    && length(x)
    && is.null(names(x))
    && all(vapply(x, is.atomic, logical(1)))
    && all_identical(vapply(x, length, integer(1)))
    #&& all_identical(vapply(x, mode, character(1))) #this fails for: [ [ 1, 2 ], [ "NA", "NA" ] ]
  );
}

is.arraylist <- function(x) {
  isTRUE(is.list(x)
    && length(x)
    && is.null(names(x))
    && all(vapply(x, is.array, logical(1)))
    && all_identical(vapply(x, function(y){paste(dim(y), collapse="-")}, character(1)))
  );
}

is.datelist <- function(x){
  isTRUE(is.list(x)
     && identical(names(x), "$date")
     && (is.numeric(x[["$date"]]) || is.character(x[["$date"]]))
  );
}

parse_date <- function(x){
  if(is.numeric(x)){
    return(structure(x/1000, class=c("POSIXct", "POSIXt")))
  } else if(is.character(x)) {
    #tz is not vectorized, so assume all() are the same
    is_utc <- ifelse(all(grepl("Z$", x)), "UTC", "")
    return(as.POSIXct(strptime(x, format = '%Y-%m-%dT%H:%M:%OS', tz = is_utc)))
  } else {
    return(x)
  }
}

all_identical <- function(x){
  if(!length(x)) return(FALSE)
  for(i in x){
    if(x[1] != i) return(FALSE)
  }
  return(TRUE)
}

#' Encode/decode base64
#'
#' Simple in-memory base64 encoder and decoder. Used internally for converting
#' raw vectors to text. Interchangeable with encoder from `base64enc` or
#' `openssl` package.
#'
#' The [base64url_enc] and [base64url_dec] functions use a variation of base64
#' that substitute characters `+/`  for `-_` respectively, such that the output
#' does not require URL-encoding. See also section 5 of rfc4648.
#'
#' @param input string or raw vector to be encoded/decoded
#' @export
#' @rdname base64
#' @name base64
#' @useDynLib jsonlite R_base64_decode
#' @examples str <- base64_enc(serialize(iris, NULL))
#' out <- unserialize(base64_dec(str))
#' stopifnot(identical(out, iris))
base64_dec <- function(input) {
  if(is.character(input)){
    input <- charToRaw(paste(input, collapse = "\n"))
  }
  stopifnot(is.raw(input))
  .Call(R_base64_decode, input)
}

#' @export
#' @rdname base64
#' @useDynLib jsonlite R_base64_encode
base64_enc <- function(input) {
  if(is.null(input))
    return(NA_character_)
  if(is.character(input)){
    input <- charToRaw(paste(input, collapse = "\n"))
  }
  stopifnot(is.raw(input))
  .Call(R_base64_encode, input)
}

#' @export
#' @rdname base64
base64url_enc <- function(input){
  text <- base64_enc(input)
  sub("=+$", "", chartr('+/', '-_', text))
}

#' @export
#' @rdname base64
base64url_dec <- function(input){
  text <- fix_padding(chartr('-_', '+/', input))
  base64_dec(text)
}

# Ensures base64 length is a multiple of 4
fix_padding <- function(text){
  text <- gsub("[\r\n]", "", text)[[1]]
  mod <- nchar(text) %% 4;
  if(mod > 0){
    padding <- paste(rep("=", (4 - mod)), collapse = "")
    text <- paste0(text, padding)
  }
  text
}

setOldClass("AsIs")
setMethod("asJSON", "AsIs", function(x, auto_unbox = FALSE, ...) {

  # Strip off the AsIs class so we can dispatch to other asJSON methods.
  class(x) <- setdiff(class(x), "AsIs")

  if (is.atomic(x) && length(x) == 1) {
    # Never auto_unbox single values when wrapped with I()
    asJSON(x, auto_unbox = FALSE, ...)

  } else {
    asJSON(x, auto_unbox = auto_unbox, ...)
  }
})

# Note: For S4, the value is the class defintion. The slots (data) are in the
# attributes.
pack <- function(obj, ...) {

  # encode by storage mode
  encoding.mode <- typeof(obj)

  # null may not have attributes
  if (encoding.mode == "NULL" || identical(obj, as.name('\001NULL\001'))) {
    return(list(type = as.scalar("NULL")))
  }

  # needed because formals become attributes, etc
  if (encoding.mode == "closure") {
    obj <- as.list(obj)
  }

  # special exception
  if (encoding.mode == "environment" && isNamespace(obj)) {
    encoding.mode <- "namespace"
  }

  # Strip off 'class' from S4 attributes
  attrib <- attributes(obj)
  if(isS4(obj)){
    attrib <- attrib[slotNames(obj)]
    names(attrib) <- slotNames(obj)
  }

  # encode recursively
  list(
    type = as.scalar(encoding.mode),
    attributes = givename(lapply(attrib, pack, ...)),
    value = switch(encoding.mode,
      environment = NULL,
      externalptr = NULL,
      namespace = lapply(as.list(getNamespaceInfo(obj, "spec")), as.scalar),
      S4 = list(class = as.scalar(class(obj)),
                package = as.scalar(attr(class(obj), "package"))),
      raw = as.scalar(base64_enc(unclass(obj))),
      logical = as.vector(unclass(obj), mode = "logical"),
      integer = as.vector(unclass(obj), mode = "integer"),
      numeric = as.vector(unclass(obj), mode = "numeric"),
      double = as.vector(unclass(obj), mode = "double"),
      character = as.vector(unclass(obj), mode = "character"),
      complex = as.vector(unclass(obj), mode = "complex"),
      list = unname(lapply(unclass(obj), pack, ...)),
      pairlist = unname(lapply(as.vector(obj, mode = "list"), pack, ...)),
      closure = unname(lapply(obj, pack, ...)),
      builtin = as.scalar(base64_enc(serialize(unclass(obj), NULL))),
      special = as.scalar(base64_enc(serialize(unclass(obj), NULL))),
      language = deparse(unclass(obj)),
      name = deparse(unclass(obj)),
      symbol = deparse(unclass(obj)),
      expression = deparse(obj[[1]]),
      warning("No encoding has been defined for objects with storage mode ", encoding.mode, " and will be skipped.")
    )
  )
}

unpack <- function(obj) {

  encoding.mode <- obj$type

  # functions are special
  if (encoding.mode == "NULL") {
    return(NULL)
  }

  if(identical(encoding.mode, "S4")){
    obj_class <- load_s4_class(obj$value$class, package = obj$value$package)
    obj_data <- lapply(obj$attributes, unpack)
    if(!length(obj_class))
      obj_class <- obj$value$class
    return(do.call(new, c(Class = obj_class, obj_data)))
  }

  newdata <- c(
    list(.Data = switch(encoding.mode,
      environment = new.env(parent=emptyenv()),
      namespace = getNamespace(obj$value$name),
      externalptr = NULL,
      raw = base64_dec(obj$value),
      logical = as.logical(list_to_vec(obj$value)),
      integer = as.integer(list_to_vec(obj$value)),
      numeric = as.numeric(list_to_vec(obj$value)),
      double = as.double(list_to_vec(obj$value)),
      character = as.character(list_to_vec(obj$value)),
      complex = as.complex(list_to_vec(obj$value)),
      list = lapply(obj$value, unpack),
      pairlist = lapply(obj$value, unpack),
      symbol = makesymbol(x = unlist(obj$value)),
      name = makesymbol(x = unlist(obj$value)),
      expression = parse(text = obj$value),
      language = as.call(parse(text = unlist(obj$value)))[[1]],
      special = unserialize(base64_dec(obj$value)),
      builtin = unserialize(base64_dec(obj$value)),
      closure = lapply(obj$value, unpack),
      stop("Switch falling through for encode.mode: ", encoding.mode)
    )
  ), lapply(obj$attributes, unpack))

  # this is for serializing functions arguments: as.list(lm)$data
  if (identical(newdata[[1]], substitute())) {
    return(substitute())
  }

  # build the output object
  output <- do.call("structure", newdata, quote = TRUE)

  # functions are special
  if (encoding.mode == "closure") {
    myfn <- as.function(output)
    environment(myfn) <- globalenv()
    return(myfn)
  }

  # functions are special
  if (encoding.mode == "pairlist") {
    return(as.pairlist(output))
  }

  # try to fix native symbols
  if (is(output, "NativeSymbolInfo")) {
    try(output <- fixNativeSymbol(output))
  }

  # return
  return(output)
}

load_s4_class <- function(name, package){
  cls <- tryCatch({
    getClassDef(name, package = package)
  }, error = function(e){
    stop(sprintf("Failed to load S4 class definition '%s' from '%s' (%s)", name, package, e$message), call. = FALSE)
  })
}

# Note: For S4, the value is the class defintion. The slots (data) are in the
# attributes.
pack <- function(obj, ...) {

  # encode by storage mode
  encoding.mode <- typeof(obj)

  # null may not have attributes
  if (encoding.mode == "NULL" || identical(obj, as.name('\001NULL\001'))) {
    return(list(type = as.scalar("NULL")))
  }

  # needed because formals become attributes, etc
  if (encoding.mode == "closure") {
    obj <- as.list(obj)
  }

  # special exception
  if (encoding.mode == "environment" && isNamespace(obj)) {
    encoding.mode <- "namespace"
  }

  # Strip off 'class' from S4 attributes
  attrib <- attributes(obj)
  if(isS4(obj)){
    encoding.mode <- "S4"
    if (".Data" %in% slotNames(obj)) {
      attrib[[".Data"]] = obj@.Data
    }
    attrib <- attrib[slotNames(obj)]
    names(attrib) <- slotNames(obj)
  }

  # encode recursively
  list(
    type = as.scalar(encoding.mode),
    attributes = givename(lapply(attrib, pack, ...)),
    value = switch(encoding.mode,
      environment = NULL,
      externalptr = NULL,
      namespace = lapply(as.list(getNamespaceInfo(obj, "spec")), as.scalar),
      S4 = list(class = as.scalar(class(obj)),
                package = as.scalar(attr(class(obj), "package"))),
      raw = as.scalar(base64_enc(unclass(obj))),
      logical = as.vector(unclass(obj), mode = "logical"),
      integer = as.vector(unclass(obj), mode = "integer"),
      numeric = as.vector(unclass(obj), mode = "numeric"),
      double = as.vector(unclass(obj), mode = "double"),
      character = as.vector(unclass(obj), mode = "character"),
      complex = as.vector(unclass(obj), mode = "complex"),
      list = unname(lapply(unclass(obj), pack, ...)),
      pairlist = unname(lapply(as.vector(obj, mode = "list"), pack, ...)),
      closure = unname(lapply(obj, pack, ...)),
      builtin = as.scalar(base64_enc(serialize(unclass(obj), NULL))),
      special = as.scalar(base64_enc(serialize(unclass(obj), NULL))),
      language = deparse(unclass(obj)),
      name = deparse(unclass(obj)),
      symbol = deparse(unclass(obj)),
      expression = deparse(obj[[1]]),
      warning("No encoding has been defined for objects with storage mode ", encoding.mode, " and will be skipped.")
    )
  )
}

unpack <- function(obj) {

  encoding.mode <- obj$type

  # functions are special
  if (encoding.mode == "NULL") {
    return(NULL)
  }

  if(identical(encoding.mode, "S4")){
    obj_class <- load_s4_class(obj$value$class, package = obj$value$package)
    obj_data <- lapply(obj$attributes, unpack)
    if(!length(obj_class))
      obj_class <- obj$value$class
    return(do.call(new, c(Class = obj_class, obj_data)))
  }

  newdata <- c(
    list(.Data = switch(encoding.mode,
      environment = new.env(parent=emptyenv()),
      namespace = getNamespace(obj$value$name),
      externalptr = NULL,
      raw = base64_dec(obj$value),
      logical = as.logical(list_to_vec(obj$value)),
      integer = as.integer(list_to_vec(obj$value)),
      numeric = as.numeric(list_to_vec(obj$value)),
      double = as.double(list_to_vec(obj$value)),
      character = as.character(list_to_vec(obj$value)),
      complex = as.complex(list_to_vec(obj$value)),
      list = lapply(obj$value, unpack),
      pairlist = lapply(obj$value, unpack),
      symbol = makesymbol(x = unlist(obj$value)),
      name = makesymbol(x = unlist(obj$value)),
      expression = parse(text = obj$value),
      language = as.call(parse(text = unlist(obj$value)))[[1]],
      special = unserialize(base64_dec(obj$value)),
      builtin = unserialize(base64_dec(obj$value)),
      closure = lapply(obj$value, unpack),
      stop("Switch falling through for encode.mode: ", encoding.mode)
    )
  ), lapply(obj$attributes, unpack))

  # this is for serializing functions arguments: as.list(lm)$data
  if (identical(newdata[[1]], substitute())) {
    return(substitute())
  }

  # build the output object
  output <- do.call("structure", newdata, quote = TRUE)

  # functions are special
  if (encoding.mode == "closure") {
    myfn <- as.function(output)
    environment(myfn) <- globalenv()
    return(myfn)
  }

  # functions are special
  if (encoding.mode == "pairlist") {
    return(as.pairlist(output))
  }

  # try to fix native symbols
  if (is(output, "NativeSymbolInfo")) {
    try(output <- fixNativeSymbol(output))
  }

  # return
  return(output)
}

load_s4_class <- function(name, package){
  cls <- tryCatch({
    getClassDef(name, package = package)
  }, error = function(e){
    stop(sprintf("Failed to load S4 class definition '%s' from '%s' (%s)", name, package, e$message), call. = FALSE)
  })
}

#test serializeJSON

# Note about numeric precision
# In the unit tests we use digits=10. Lowever values will result in problems for some datasets
test_that("Serializing datasets", {
  library(datasets)
  lapply(as.list(ls("package:datasets")), function(x) {
    mycall <- call("expect_equal", call("unserializeJSON", call("serializeJSON", as.name(x), digits = 10)), as.name(x))
    eval(mycall)
  })
})

#test serializeJSON 

context("Serializing Datasets")

# Note about numeric precision
# In the unit tests we use digits=10. Lowever values will result in problems for some datasets
test_that("Serializing datasets", {
  library(datasets);
  lapply(as.list(ls("package:datasets")), function(x){
    mycall <- call("expect_that", 
      call("unserializeJSON", call("serializeJSON", as.name(x), digits=10)),
      call("equals", as.name(x))
    );
    eval(mycall)
  });
});

---
Title: "Getting started with JSON and jsonlite"
date: "`r Sys.Date()`"
output:
  html_document
vignette: >
  %\VignetteIndexEntry{Getting started with JSON and jsonlite}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---


```{r echo=FALSE}
library(knitr)
opts_chunk$set(comment="")

#this replaces tabs by spaces because latex-verbatim doesn't like tabs
#no longer needed because yajl does not use tabs.
#toJSON <- function(...){
#  gsub("\t", "  ", jsonlite::toJSON(...), fixed=TRUE);
#}
```

# Getting started with JSON and jsonlite

The jsonlite package is a JSON parser/generator optimized for the web. Its main strength is that it implements a bidirectional mapping between JSON data and the most important R data types. Thereby we can convert between R objects and JSON without loss of type or information, and without the need for any manual data munging. This is ideal for interacting with web APIs, or to build pipelines where data structures seamlessly flow in and out of R using JSON.

```{r message=FALSE}
library(jsonlite)
all.equal(mtcars, fromJSON(toJSON(mtcars)))
```

This vignette introduces basic concepts to get started with jsonlite. For a more detailed outline and motivation of the mapping, see: [arXiv:1403.2805](https://arxiv.org/abs/1403.2805).

## Simplification

Simplification is the process where JSON arrays automatically get converted from a list into a more specific R class. The `fromJSON` function has 3 arguments which control the simplification process: `simplifyVector`, `simplifyDataFrame` and `simplifyMatrix`. Each one is enabled by default.

| JSON structure        | Example JSON data                                        | Simplifies to R class | Argument in fromJSON | 
| ----------------------|----------------------------------------------------------|-----------------------|----------------------|
| Array of primitives   | `["Amsterdam", "Rotterdam", "Utrecht", "Den Haag"]`      | Atomic Vector         | simplifyVector       | 
| Array of objects      | `[{"name":"Erik", "age":43}, {"name":"Anna", "age":32}]` | Data Frame            | simplifyDataFrame    | 
| Array of arrays       | `[ [1, 2, 3], [4, 5, 6] ]`                               | Matrix                | simplifyMatrix       |

### Atomic Vectors

When `simplifyVector` is enabled, JSON arrays containing **primitives** (strings, numbers, booleans or null) simplify into an atomic vector:

```{r}
# A JSON array of primitives
json <- '["Mario", "Peach", null, "Bowser"]'

# Simplifies into an atomic vector
fromJSON(json)
```

Without simplification, any JSON array turns into a list: 

```{r}
# No simplification:
fromJSON(json, simplifyVector = FALSE)
```


### Data Frames

When `simplifyDataFrame` is enabled, JSON arrays containing **objects** (key-value pairs) simplify into a data frame:

```{r}
json <-
'[
  {"Name" : "Mario", "Age" : 32, "Occupation" : "Plumber"}, 
  {"Name" : "Peach", "Age" : 21, "Occupation" : "Princess"},
  {},
  {"Name" : "Bowser", "Occupation" : "Koopa"}
]'
mydf <- fromJSON(json)
mydf
```

The data frame gets converted back into the original JSON structure by `toJSON` (whitespace and line breaks are ignorable in JSON).

```{r}
mydf$Ranking <- c(3, 1, 2, 4)
toJSON(mydf, pretty=TRUE)
```

Hence you can go back and forth between dataframes and JSON, without any manual data restructuring.

### Matrices and Arrays

When `simplifyMatrix` is enabled, JSON arrays containing **equal-length sub-arrays** simplify into a matrix (or higher order R array):

```{r}
json <- '[
  [1, 2, 3, 4],
  [5, 6, 7, 8],
  [9, 10, 11, 12]
]'
mymatrix <- fromJSON(json)
mymatrix
```

Again, we can use `toJSON` to convert the matrix or array back into the original JSON structure:

```{r}
toJSON(mymatrix, pretty = TRUE)
```

The simplification works for arrays of arbitrary dimensionality, as long as the dimensions match (R does not support ragged arrays).

```{r}
json <- '[
   [[1, 2], 
    [3, 4]],
   [[5, 6], 
    [7, 8]],
   [[9, 10],
    [11, 12]]
]'
myarray <- fromJSON(json)
myarray[1, , ]
myarray[ , ,1]
```

This is all there is to it! For a more detailed outline and motivation of the mapping, see: [arXiv:1403.2805](https://arxiv.org/abs/1403.2805).

---
title: "Combining pages of JSON data with jsonlite"
date: "2020-06-25"
output:
  html_document
vignette: >
  %\VignetteIndexEntry{Combining pages of JSON data with jsonlite}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---






The [jsonlite](https://cran.r-project.org/package=jsonlite) package is a `JSON` parser/generator for R which is optimized for pipelines and web APIs. It is used by the OpenCPU system and many other packages to get data in and out of R using the `JSON` format.

## A bidirectional mapping

One of the main strengths of `jsonlite` is that it implements a bidirectional [mapping](https://arxiv.org/abs/1403.2805) between JSON and data frames. Thereby it can convert nested collections of JSON records, as they often appear on the web, immediately into the appropriate R structure. For example to grab some data from ProPublica we can simply use:


```r
library(jsonlite)
mydata <- fromJSON("https://projects.propublica.org/forensics/geos.json", flatten = TRUE)
View(mydata)
```

The `mydata` object is a data frame which can be used directly for modeling or visualization, without the need for any further complicated data manipulation.

## Paging with jsonlite

A question that comes up frequently is how to combine pages of data. Most web APIs limit the amount of data that can be retrieved per request. If the client needs more data than what can fits in a single request, it needs to break down the data into multiple requests that each retrieve a fragment (page) of data, not unlike pages in a book. In practice this is often implemented using a `page` parameter in the API. Below an example from the [ProPublica Nonprofit Explorer API](https://projects.propublica.org/nonprofits/api) where we retrieve the first 3 pages of tax-exempt organizations in the USA, ordered by revenue:


```r
baseurl <- "https://projects.propublica.org/nonprofits/api/v2/search.json?order=revenue&sort_order=desc"
mydata0 <- fromJSON(paste0(baseurl, "&page=0"), flatten = TRUE)
mydata1 <- fromJSON(paste0(baseurl, "&page=1"), flatten = TRUE)
mydata2 <- fromJSON(paste0(baseurl, "&page=2"), flatten = TRUE)

#The actual data is in the organizations element
mydata0$organizations[1:10, c("name", "city", "strein")]
```

```
                            name        city     strein
1           0 DEBT EDUCATION INC  SANTA ROSA 46-4744976
2                0 TOLERANCE INC     SUWANEE 27-2620044
3                  0 U R PASSION   KENNEWICK 81-4045228
4                00 MOVEMENT INC   PENSACOLA 82-4704419
5                    00006 LOCAL       MEDIA 22-6062777
6             0003 POSTAL FAMILY  CINCINNATI 31-0240910
7                        0005 GA   HEPHZIBAH 58-1514574
8  0005 WRIGHT-PATT CREDIT UNION BEAVERCREEK 31-0278870
9                        0009 DE   GREENWOOD 26-4507405
10               0011 CALIFORNIA      REDWAY 36-4654777
```

To analyze or visualize these data, we need to combine the pages into a single dataset. We can do this with the `rbind_pages` function. Note that in this example, the actual data is contained by the `organizations` field:


```r
#Rows per data frame
nrow(mydata0$organizations)
```

```
[1] 100
```

```r
#Combine data frames
organizations <- rbind_pages(
  list(mydata0$organizations, mydata1$organizations, mydata2$organizations)
)

#Total number of rows
nrow(organizations)
```

```
[1] 300
```

## Automatically combining many pages

We can write a simple loop that automatically downloads and combines many pages. For example to retrieve the first 20 pages with non-profits from the example above:


```r
#store all pages in a list first
baseurl <- "https://projects.propublica.org/nonprofits/api/v2/search.json?order=revenue&sort_order=desc"
pages <- list()
for(i in 0:20){
  mydata <- fromJSON(paste0(baseurl, "&page=", i))
  message("Retrieving page ", i)
  pages[[i+1]] <- mydata$organizations
}

#combine all into one
organizations <- rbind_pages(pages)

#check output
nrow(organizations)
```

```
[1] 2100
```

```r
colnames(organizations)
```

```
 [1] "ein"           "strein"        "name"          "sub_name"      "city"          "state"        
 [7] "ntee_code"     "raw_ntee_code" "subseccd"      "has_subseccd"  "have_filings"  "have_extracts"
[13] "have_pdfs"     "score"        
```

From here, we can go straight to analyzing the organizations data without any further tedious data manipulation.

---
title: "Combining pages of JSON data with jsonlite"
date: "2018-12-05"
output:
  html_document
vignette: >
  %\VignetteIndexEntry{Combining pages of JSON data with jsonlite}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---






The [jsonlite](https://cran.r-project.org/package=jsonlite) package is a `JSON` parser/generator for R which is optimized for pipelines and web APIs. It is used by the OpenCPU system and many other packages to get data in and out of R using the `JSON` format.

## A bidirectional mapping

One of the main strengths of `jsonlite` is that it implements a bidirectional [mapping](http://arxiv.org/abs/1403.2805) between JSON and data frames. Thereby it can convert nested collections of JSON records, as they often appear on the web, immediately into the appropriate R structure. For example to grab some data from ProPublica we can simply use:


```r
library(jsonlite)
mydata <- fromJSON("https://projects.propublica.org/forensics/geos.json", flatten = TRUE)
View(mydata)
```

The `mydata` object is a data frame which can be used directly for modeling or visualization, without the need for any further complicated data manipulation.

## Paging with jsonlite

A question that comes up frequently is how to combine pages of data. Most web APIs limit the amount of data that can be retrieved per request. If the client needs more data than what can fits in a single request, it needs to break down the data into multiple requests that each retrieve a fragment (page) of data, not unlike pages in a book. In practice this is often implemented using a `page` parameter in the API. Below an example from the [ProPublica Nonprofit Explorer API](https://projects.propublica.org/nonprofits/api) where we retrieve the first 3 pages of tax-exempt organizations in the USA, ordered by revenue:


```r
baseurl <- "https://projects.propublica.org/nonprofits/api/v2/search.json?order=revenue&sort_order=desc"
mydata0 <- fromJSON(paste0(baseurl, "&page=0"), flatten = TRUE)
mydata1 <- fromJSON(paste0(baseurl, "&page=1"), flatten = TRUE)
mydata2 <- fromJSON(paste0(baseurl, "&page=2"), flatten = TRUE)

#The actual data is in the organizations element
mydata0$organizations[1:10, c("name", "city", "strein")]
```

```
                           name         city     strein
1                   00295 LOCAL        MEDIA 23-6420101
2               007 BENEFIT LTD       RESTON 47-4146355
3                   00736 LOCAL     BARTLETT 42-1693318
4               03XX FOUNDATION       SANTEE 38-3915658
5  05-THE FILSON CLUB ET AL TUW PHILADELPHIA 61-6125263
6     06 UNITED SOCCER CLUB INC    REGO PARK 35-2518301
7                 08 CHURCH INC  BAKERSFIELD 27-3924877
8                1 1 FOUNDATION    PLACENTIA 47-4335155
9                     1 BOX LLC     SOMERSET 81-3408531
10       1 FAMILY 2GETHER 4EVER   PLAINFIELD 81-1287436
```

To analyze or visualize these data, we need to combine the pages into a single dataset. We can do this with the `rbind_pages` function. Note that in this example, the actual data is contained by the `organizations` field:


```r
#Rows per data frame
nrow(mydata0$organizations)
```

```
[1] 100
```

```r
#Combine data frames
organizations <- rbind_pages(
  list(mydata0$organizations, mydata1$organizations, mydata2$organizations)
)

#Total number of rows
nrow(organizations)
```

```
[1] 300
```

## Automatically combining many pages

We can write a simple loop that automatically downloads and combines many pages. For example to retrieve the first 20 pages with non-profits from the example above:


```r
#store all pages in a list first
baseurl <- "https://projects.propublica.org/nonprofits/api/v2/search.json?order=revenue&sort_order=desc"
pages <- list()
for(i in 0:20){
  mydata <- fromJSON(paste0(baseurl, "&page=", i))
  message("Retrieving page ", i)
  pages[[i+1]] <- mydata$organizations
}

#combine all into one
organizations <- rbind_pages(pages)

#check output
nrow(organizations)
```

```
[1] 2100
```

```r
colnames(organizations)
```

```
 [1] "ein"           "strein"        "name"          "sub_name"     
 [5] "city"          "state"         "ntee_code"     "raw_ntee_code"
 [9] "subseccd"      "has_subseccd"  "have_filings"  "have_extracts"
[13] "have_pdfs"     "score"        
```

From here, we can go straight to analyzing the organizations data without any further tedious data manipulation.

---
title: "Fetching JSON data from REST APIs"
date: "2020-06-25"
output:
  html_document
vignette: >
  %\VignetteIndexEntry{Fetching JSON data from REST APIs}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---



This section lists some examples of public HTTP APIs that publish data in JSON format. These are great to get a sense of the complex structures that are encountered in real world JSON data. All services are free, but some require registration/authentication. Each example returns lots of data, therefore not all output is printed in this document.


```r
library(jsonlite)
```

## Github

Github is an online code repository and has APIs to get live data on almost all activity. Below some examples from a well known R package and author:


```r
hadley_orgs <- fromJSON("https://api.github.com/users/hadley/orgs")
hadley_repos <- fromJSON("https://api.github.com/users/hadley/repos")
gg_commits <- fromJSON("https://api.github.com/repos/hadley/ggplot2/commits")
gg_issues <- fromJSON("https://api.github.com/repos/hadley/ggplot2/issues")

#latest issues
paste(format(gg_issues$user$login), ":", gg_issues$title)
```

```
 [1] "ds-jim          : Nothing plotted with manual_scale when a named vector is used as the input."                  
 [2] "thomasp85       : Should ggsave use ragg if available?"                                                         
 [3] "jdsher          : Cannot override.aes with guide_bins?"                                                         
 [4] "karawoo         : Combined facet labels aren't parsed when .multi_line = FALSE"                                 
 [5] "mevers          : `coord_polar` causes error with `ggtext::element_markdown`"                                   
 [6] "yutannihilation : WIP: Deprecate qplot()"                                                                       
 [7] "tdhock          : Fix aes(groupS)"                                                                              
 [8] "tdhock          : same argument/param in both stat and geom?"                                                   
 [9] "tdhock          : undefined columns selected with groupS aes in custom geom"                                    
[10] "SimonDedman     : geom_violin default adjust value for integers"                                                
[11] "tdhock          : group column in built data even when aes(group) absent"                                       
[12] "TylerGrantSmith : Add layer names"                                                                              
[13] "krlmlr          : Support ptype argument for scale() functions"                                                 
[14] "clauswilke      : Annotate all facets with axis ticks and labels for fixed scales"                              
[15] "evodevosys      : theme_void() removes geom_segments (at least visually) when an alpha aesthetic is used"       
[16] "hadley          : ggsave should use plot theme for default background"                                          
[17] "yqgchen         : strip.text.y = element_blank() yields an error when there are multiple layers of strip labels"
[18] "DrrDom          : Points fill in legend"                                                                        
[19] "xvrdm           : WIP: Add scale_color_viridis_b"                                                               
[20] "thomas-neitmann : `ggsave()` produces aliased png files on Windows"                                             
[21] "atusy           : Export pch_table"                                                                             
[22] "moodymudskipper : default xlim and ylim in qplot are not supportd when non missing"                             
[23] "yutannihilation : Can geom_abline() draw lines a bit longer than the actual Coord range?"                       
[24] "vitor-mendes-iq : scale_*_reverse() is ignored when limits are set on Coord"                                    
[25] "LiRogers        : Justifying the legend with respect to the full plot area rather than the panel"               
[26] "Shians          : scale_fill_steps produces unevenly spaced legend when limits are set"                         
[27] "SimonDedman     : Add 'reverse' option to scale_y_date?"                                                        
[28] "echasnovski     : Add `bounds` argument to `geom_density()`"                                                    
[29] "swebs           : timezone parameter for scale_x_datetime has no effect"                                        
[30] "jgjl            : Update stat_ecdf to work either on the x or the y aesthetic."                                 
```

## CitiBike NYC

A single public API that shows location, status and current availability for all stations in the New York City bike sharing imitative.


```r
citibike <- fromJSON("http://citibikenyc.com/stations/json")
stations <- citibike$stationBeanList
colnames(stations)
```

```
 [1] "id"                    "stationName"           "availableDocks"        "totalDocks"           
 [5] "latitude"              "longitude"             "statusValue"           "statusKey"            
 [9] "availableBikes"        "stAddress1"            "stAddress2"            "city"                 
[13] "postalCode"            "location"              "altitude"              "testStation"          
[17] "lastCommunicationTime" "landMark"             
```

```r
nrow(stations)
```

```
[1] 973
```

## Ergast

The Ergast Developer API is an experimental web service which provides a historical record of motor racing data for non-commercial purposes.


```r
res <- fromJSON('http://ergast.com/api/f1/2004/1/results.json')
drivers <- res$MRData$RaceTable$Races$Results[[1]]$Driver
colnames(drivers)
```

```
[1] "driverId"        "code"            "url"             "givenName"       "familyName"      "dateOfBirth"    
[7] "nationality"     "permanentNumber"
```

```r
drivers[1:10, c("givenName", "familyName", "code", "nationality")]
```

```
   givenName    familyName code nationality
1    Michael    Schumacher  MSC      German
2     Rubens   Barrichello  BAR   Brazilian
3   Fernando        Alonso  ALO     Spanish
4       Ralf    Schumacher  SCH      German
5       Juan Pablo Montoya  MON   Colombian
6     Jenson        Button  BUT     British
7      Jarno        Trulli  TRU     Italian
8      David     Coulthard  COU     British
9     Takuma          Sato  SAT    Japanese
10 Giancarlo    Fisichella  FIS     Italian
```


## ProPublica

Below an example from the [ProPublica Nonprofit Explorer API](https://projects.propublica.org/nonprofits/api) where we retrieve the first 10 pages of tax-exempt organizations in the USA, ordered by revenue. The `rbind_pages` function is used to combine the pages into a single data frame.



```r
#store all pages in a list first
baseurl <- "https://projects.propublica.org/nonprofits/api/v2/search.json?order=revenue&sort_order=desc"
pages <- list()
for(i in 0:10){
  mydata <- fromJSON(paste0(baseurl, "&page=", i), flatten=TRUE)
  message("Retrieving page ", i)
  pages[[i+1]] <- mydata$organizations
}

#combine all into one
organizations <- rbind_pages(pages)

#check output
nrow(organizations)
```

```
[1] 1100
```

```r
organizations[1:10, c("name", "city", "strein")]
```

```
                            name        city     strein
1           0 DEBT EDUCATION INC  SANTA ROSA 46-4744976
2                0 TOLERANCE INC     SUWANEE 27-2620044
3                  0 U R PASSION   KENNEWICK 81-4045228
4                00 MOVEMENT INC   PENSACOLA 82-4704419
5                    00006 LOCAL       MEDIA 22-6062777
6             0003 POSTAL FAMILY  CINCINNATI 31-0240910
7                        0005 GA   HEPHZIBAH 58-1514574
8  0005 WRIGHT-PATT CREDIT UNION BEAVERCREEK 31-0278870
9                        0009 DE   GREENWOOD 26-4507405
10               0011 CALIFORNIA      REDWAY 36-4654777
```


## New York Times

The New York Times has several APIs as part of the NYT developer network. These interface to data from various departments, such as news articles, book reviews, real estate, etc. Registration is required (but free) and a key can be obtained at [here](http://developer.nytimes.com/signup). The code below includes some example keys for illustration purposes.


```r
#search for articles
article_key <- "&api-key=b75da00e12d54774a2d362adddcc9bef"
url <- "http://api.nytimes.com/svc/search/v2/articlesearch.json?q=obamacare+socialism"
req <- fromJSON(paste0(url, article_key))
articles <- req$response$docs
colnames(articles)
```

```
 [1] "abstract"         "web_url"          "snippet"          "lead_paragraph"   "print_section"   
 [6] "print_page"       "source"           "multimedia"       "headline"         "keywords"        
[11] "pub_date"         "document_type"    "news_desk"        "section_name"     "byline"          
[16] "type_of_material" "_id"              "word_count"       "uri"              "subsection_name" 
```

```r
#search for best sellers
books_key <- "&api-key=76363c9e70bc401bac1e6ad88b13bd1d"
url <- "http://api.nytimes.com/svc/books/v2/lists/overview.json?published_date=2013-01-01"
req <- fromJSON(paste0(url, books_key))
bestsellers <- req$results$list
category1 <- bestsellers[[1, "books"]]
subset(category1, select = c("author", "title", "publisher"))
```

```
           author                title                  publisher
1   Gillian Flynn            GONE GIRL           Crown Publishing
2    John Grisham        THE RACKETEER Knopf Doubleday Publishing
3       E L James FIFTY SHADES OF GREY Knopf Doubleday Publishing
4 Nicholas Sparks           SAFE HAVEN   Grand Central Publishing
5  David Baldacci        THE FORGOTTEN   Grand Central Publishing
```

## Twitter

The twitter API requires OAuth2 authentication. Some example code:


```r
#Create your own appication key at https://dev.twitter.com/apps
consumer_key = "EZRy5JzOH2QQmVAe9B4j2w";
consumer_secret = "OIDC4MdfZJ82nbwpZfoUO4WOLTYjoRhpHRAWj6JMec";

#Use basic auth
secret <- jsonlite::base64_enc(paste(consumer_key, consumer_secret, sep = ":"))
req <- httr::POST("https://api.twitter.com/oauth2/token",
  httr::add_headers(
    "Authorization" = paste("Basic", gsub("\n", "", secret)),
    "Content-Type" = "application/x-www-form-urlencoded;charset=UTF-8"
  ),
  body = "grant_type=client_credentials"
);

#Extract the access token
httr::stop_for_status(req, "authenticate with twitter")
token <- paste("Bearer", httr::content(req)$access_token)

#Actual API call
url <- "https://api.twitter.com/1.1/statuses/user_timeline.json?count=10&screen_name=Rbloggers"
req <- httr::GET(url, httr::add_headers(Authorization = token))
json <- httr::content(req, as = "text")
tweets <- fromJSON(json)
substring(tweets$text, 1, 100)
```

```
 [1] "https://t.co/Jac2KxZJkv in R: How to Make a Computer Vision Model within an R Environment  {https://"
 [2] "Estimating Group Differences in Network Models using Moderation  {https://t.co/3ViArl9OZ2} #rstats #"
 [3] "Deep attractors: Where deep learning meets chaos  {https://t.co/u3HniDkjWw} #rstats #DataScience"    
 [4] "R Communities in South Africa  {https://t.co/cRBfDMPtBE} #rstats #DataScience"                       
 [5] "Interactively perform a spatial interpolation with the GUInterp Shiny interface  {https://t.co/jzidD"
 [6] "Advanced Modelling in R with CARET – a focus on supervised machine learning  {https://t.co/TSQtoxWrb"
 [7] "Color Bars  {https://t.co/HJ2Ip24rnb} #rstats #DataScience"                                          
 [8] "Why R? Webinar – Neural Networks for Modelling Molecular Interactions with Tensorflow  {https://t.co"
 [9] "COVID-19: False Positive Alarm  {https://t.co/0ufxeYAPQc} #rstats #DataScience"                      
[10] "#27: R and CRAN Binaries for Ubuntu  {https://t.co/yi5Xi9xQT9} #rstats #DataScience"                 
```

---
title: "Fetching JSON data from REST APIs"
date: "2018-12-05"
output:
  html_document
vignette: >
  %\VignetteIndexEntry{Fetching JSON data from REST APIs}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---



This section lists some examples of public HTTP APIs that publish data in JSON format. These are great to get a sense of the complex structures that are encountered in real world JSON data. All services are free, but some require registration/authentication. Each example returns lots of data, therefore not all output is printed in this document.


```r
library(jsonlite)
```

## Github

Github is an online code repository and has APIs to get live data on almost all activity. Below some examples from a well known R package and author:


```r
hadley_orgs <- fromJSON("https://api.github.com/users/hadley/orgs")
hadley_repos <- fromJSON("https://api.github.com/users/hadley/repos")
gg_commits <- fromJSON("https://api.github.com/repos/hadley/ggplot2/commits")
gg_issues <- fromJSON("https://api.github.com/repos/hadley/ggplot2/issues")

#latest issues
paste(format(gg_issues$user$login), ":", gg_issues$title)
```

```
 [1] "sebneus         : geom_raster plots differently to geom_tile"                                                         
 [2] "clauswilke      : fix nudging with multiple values. closes #2977"                                                     
 [3] "slowkow         : text is misplaced with position_dodge()"                                                            
 [4] "wongjingping    : Allow ggsave to create directory if path doesn't exist"                                             
 [5] "llrs            : Updating a theme to remove panel.grid.major.x"                                                      
 [6] "IndrajeetPatil  : feature request: `layer_data` returns a tibble"                                                     
 [7] "danielsjf       : Invalid filename error with ggsave after saving in a folder with a percentage sign (%)"             
 [8] "thomasp85       : No plyr"                                                                                            
 [9] "PaulLantos      : geom_sf layers do not align"                                                                        
[10] "dpseidel        : Fix tick misalignment with secondary axes (#2978)"                                                  
[11] "blueskypie      : possible bug in resolution() causes wrong height and width in geom_jitter()"                        
[12] "jarauh          : Documentation of geom_bar: aesthetics \"weight\" is not mentioned"                                  
[13] "clauswilke      : coord_sf() doesn't adjust line size for graticule lines"                                            
[14] "anthonytw       : Secondary axis doesn't show axis ticks or labels with coord_trans"                                  
[15] "lionel-         : Should we compact facet grid specs?"                                                                
[16] "clauswilke      : coord_sf() drops axis labels if graticules don't extend all the way to the plot boundary"           
[17] "ptoche          : breaks = NULL drops axis altogether"                                                                
[18] "mbertolacci     : Ticks misaligned for sec_axis with some scale transformations and data in 3.1.0"                    
[19] "steffilazerte   : Multiple nudge arguments results in warning"                                                        
[20] "ptoche          : scale_x_discrete with numeric drops axis with no warning"                                           
[21] "danielsjf       : geom_curve with curvature aesthetic"                                                                
[22] "felipegerard    : Reference lines break facet_wrap when facets are the product of a function"                         
[23] "hadley          : Update economics data"                                                                              
[24] "hadley          : Ensure core developers are listed in chronological order"                                           
[25] "RichardJActon   : Warn when a supplied mapping is going to be overwritten by geom_hline / vline / abline"             
[26] "mkoohafkan      : using `stat_ydensity` with `geom = \"density\"`---scaling the density line similar to `geom_violin`"
[27] "earthcli        : strange behavior with the margin of legend.text for R3.5"                                           
[28] "rharfoot        : Vertical line and crossbar jitter being applied differently."                                       
[29] "yutannihilation : Use .ignore_empty=\"all\" for enquos()"                                                             
[30] "pank            : theme: Add different ticks length for different axes"                                               
```

## CitiBike NYC

A single public API that shows location, status and current availability for all stations in the New York City bike sharing imitative.


```r
citibike <- fromJSON("http://citibikenyc.com/stations/json")
stations <- citibike$stationBeanList
colnames(stations)
```

```
 [1] "id"                    "stationName"          
 [3] "availableDocks"        "totalDocks"           
 [5] "latitude"              "longitude"            
 [7] "statusValue"           "statusKey"            
 [9] "availableBikes"        "stAddress1"           
[11] "stAddress2"            "city"                 
[13] "postalCode"            "location"             
[15] "altitude"              "testStation"          
[17] "lastCommunicationTime" "landMark"             
```

```r
nrow(stations)
```

```
[1] 813
```

## Ergast

The Ergast Developer API is an experimental web service which provides a historical record of motor racing data for non-commercial purposes.


```r
res <- fromJSON('http://ergast.com/api/f1/2004/1/results.json')
drivers <- res$MRData$RaceTable$Races$Results[[1]]$Driver
colnames(drivers)
```

```
[1] "driverId"        "code"            "url"             "givenName"      
[5] "familyName"      "dateOfBirth"     "nationality"     "permanentNumber"
```

```r
drivers[1:10, c("givenName", "familyName", "code", "nationality")]
```

```
   givenName    familyName code nationality
1    Michael    Schumacher  MSC      German
2     Rubens   Barrichello  BAR   Brazilian
3   Fernando        Alonso  ALO     Spanish
4       Ralf    Schumacher  SCH      German
5       Juan Pablo Montoya  MON   Colombian
6     Jenson        Button  BUT     British
7      Jarno        Trulli  TRU     Italian
8      David     Coulthard  COU     British
9     Takuma          Sato  SAT    Japanese
10 Giancarlo    Fisichella  FIS     Italian
```


## ProPublica

Below an example from the [ProPublica Nonprofit Explorer API](https://projects.propublica.org/nonprofits/api) where we retrieve the first 10 pages of tax-exempt organizations in the USA, ordered by revenue. The `rbind_pages` function is used to combine the pages into a single data frame.



```r
#store all pages in a list first
baseurl <- "https://projects.propublica.org/nonprofits/api/v2/search.json?order=revenue&sort_order=desc"
pages <- list()
for(i in 0:10){
  mydata <- fromJSON(paste0(baseurl, "&page=", i), flatten=TRUE)
  message("Retrieving page ", i)
  pages[[i+1]] <- mydata$organizations
}

#combine all into one
organizations <- rbind_pages(pages)

#check output
nrow(organizations)
```

```
[1] 1100
```

```r
organizations[1:10, c("name", "city", "strein")]
```

```
                           name         city     strein
1                   00295 LOCAL        MEDIA 23-6420101
2               007 BENEFIT LTD       RESTON 47-4146355
3                   00736 LOCAL     BARTLETT 42-1693318
4               03XX FOUNDATION       SANTEE 38-3915658
5  05-THE FILSON CLUB ET AL TUW PHILADELPHIA 61-6125263
6     06 UNITED SOCCER CLUB INC    REGO PARK 35-2518301
7                 08 CHURCH INC  BAKERSFIELD 27-3924877
8                1 1 FOUNDATION    PLACENTIA 47-4335155
9                     1 BOX LLC     SOMERSET 81-3408531
10       1 FAMILY 2GETHER 4EVER   PLAINFIELD 81-1287436
```


## New York Times

The New York Times has several APIs as part of the NYT developer network. These interface to data from various departments, such as news articles, book reviews, real estate, etc. Registration is required (but free) and a key can be obtained at [here](http://developer.nytimes.com/signup). The code below includes some example keys for illustration purposes.


```r
#search for articles
article_key <- "&api-key=b75da00e12d54774a2d362adddcc9bef"
url <- "http://api.nytimes.com/svc/search/v2/articlesearch.json?q=obamacare+socialism"
req <- fromJSON(paste0(url, article_key))
articles <- req$response$docs
colnames(articles)
```

```
 [1] "web_url"          "snippet"          "print_page"      
 [4] "blog"             "source"           "multimedia"      
 [7] "headline"         "keywords"         "pub_date"        
[10] "document_type"    "news_desk"        "byline"          
[13] "type_of_material" "_id"              "word_count"      
[16] "score"            "uri"              "section_name"    
```

```r
#search for best sellers
books_key <- "&api-key=76363c9e70bc401bac1e6ad88b13bd1d"
url <- "http://api.nytimes.com/svc/books/v2/lists/overview.json?published_date=2013-01-01"
req <- fromJSON(paste0(url, books_key))
bestsellers <- req$results$list
category1 <- bestsellers[[1, "books"]]
subset(category1, select = c("author", "title", "publisher"))
```

```
           author                title                  publisher
1   Gillian Flynn            GONE GIRL           Crown Publishing
2    John Grisham        THE RACKETEER Knopf Doubleday Publishing
3       E L James FIFTY SHADES OF GREY Knopf Doubleday Publishing
4 Nicholas Sparks           SAFE HAVEN   Grand Central Publishing
5  David Baldacci        THE FORGOTTEN   Grand Central Publishing
```

```r
#movie reviews
movie_key <- "&api-key=b75da00e12d54774a2d362adddcc9bef"
url <- "http://api.nytimes.com/svc/movies/v2/reviews/dvd-picks.json?order=by-date"
req <- fromJSON(paste0(url, movie_key))
reviews <- req$results
colnames(reviews)
```

```
 [1] "display_title"    "mpaa_rating"      "critics_pick"    
 [4] "byline"           "headline"         "summary_short"   
 [7] "publication_date" "opening_date"     "date_updated"    
[10] "link"             "multimedia"      
```

```r
reviews[1:5, c("display_title", "byline", "mpaa_rating")]
```

```
       display_title        byline mpaa_rating
1        Ben Is Back    A.O. SCOTT           R
2              Tyrel   BILGE EBIRI            
3        The Charmer WESLEY MORRIS            
4 Head Full of Honey   BILGE EBIRI       PG-13
5   Happy as Lazzaro    A.O. SCOTT       PG-13
```

## Twitter

The twitter API requires OAuth2 authentication. Some example code:


```r
#Create your own appication key at https://dev.twitter.com/apps
consumer_key = "EZRy5JzOH2QQmVAe9B4j2w";
consumer_secret = "OIDC4MdfZJ82nbwpZfoUO4WOLTYjoRhpHRAWj6JMec";

#Use basic auth
secret <- jsonlite::base64_enc(paste(consumer_key, consumer_secret, sep = ":"))
req <- httr::POST("https://api.twitter.com/oauth2/token",
  httr::add_headers(
    "Authorization" = paste("Basic", gsub("\n", "", secret)),
    "Content-Type" = "application/x-www-form-urlencoded;charset=UTF-8"
  ),
  body = "grant_type=client_credentials"
);

#Extract the access token
httr::stop_for_status(req, "authenticate with twitter")
token <- paste("Bearer", httr::content(req)$access_token)

#Actual API call
url <- "https://api.twitter.com/1.1/statuses/user_timeline.json?count=10&screen_name=Rbloggers"
req <- httr::GET(url, httr::add_headers(Authorization = token))
json <- httr::content(req, as = "text")
tweets <- fromJSON(json)
substring(tweets$text, 1, 100)
```

```
 [1] "Trust in ML models. Slides from TWiML &amp; AI EMEA Meetup + iX Articles https://t.co/XUVyu5D5gW #rs"
 [2] "Solving #AdventOfCode day 3 and 4 with R https://t.co/lvZlUqMZhS #rstats #DataScience"               
 [3] "Automated Dashboard with various correlation visualizations in R https://t.co/hC36eeFQLR #rstats #Da"
 [4] "New R job: Adjunct Professor https://t.co/2K75pHzPey #rstats #DataScience #jobs"                     
 [5] "ggQC | ggplot Quality Control Charts – New Release https://t.co/ctfhMzMf3z #rstats #DataScience"     
 [6] "A Tidy Text Analysis of R Weekly Posts https://t.co/EAleVu4tjo #rstats #DataScience"                 
 [7] "Day 05 – little helper get_network https://t.co/whv74exvQS #rstats #DataScience"                     
 [8] "Community Call – Governance strategies for open source research software projects https://t.co/tkBpz"
 [9] "NBA Team Twitter Analysis Flexdashboard https://t.co/uSL2myAK0W #rstats #DataScience"                
[10] "Bayesian Nonparametric Models in NIMBLE, Part 1: Density Estimation https://t.co/GZS0w3MwAI #rstats "
```

---
title: "Fetching JSON data from REST APIs"
date: "2022-01-16"
output:
  html_document
vignette: >
  %\VignetteIndexEntry{Fetching JSON data from REST APIs}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---



This section lists some examples of public HTTP APIs that publish data in JSON format. These are great to get a sense of the complex structures that are encountered in real world JSON data. All services are free, but some require registration/authentication. Each example returns lots of data, therefore not all output is printed in this document.


```r
library(jsonlite)
```

## Github

Github is an online code repository and has APIs to get live data on almost all activity. Below some examples from a well known R package and author:


```r
hadley_orgs <- fromJSON("https://api.github.com/users/hadley/orgs")
hadley_repos <- fromJSON("https://api.github.com/users/hadley/repos")
gg_commits <- fromJSON("https://api.github.com/repos/hadley/ggplot2/commits")
gg_issues <- fromJSON("https://api.github.com/repos/hadley/ggplot2/issues")

#latest issues
paste(format(gg_issues$user$login), ":", gg_issues$title)
```

```
 [1] "petres               : Inconsistency in `scale_` functions for args `values` and `labels` for `NA` values"                                                
 [2] "PursuitOfDataScience : Update data.R"                                                                                                                     
 [3] "cmaimone             : scale_x_datetime limits with histogram/stat_bin: warning message about missing values"                                             
 [4] "tomsaunders98        : Add options to guide_colourstep"                                                                                                   
 [5] "teunbrand            : Duplicated aes warning with multiple modified aesthetics"                                                                          
 [6] "krlmlr               : Support scale functions in packages not attached via scale_type()"                                                                 
 [7] "elong0527            : Shall `NextMethod` be used in `$<-.uneval`"                                                                                        
 [8] "bkmgit               : Update presidential terms dataset"                                                                                                 
 [9] "bkmgit               : Presidents terms"                                                                                                                  
[10] "coolbutuseless       : Export `datetime_scale`"                                                                                                           
[11] "davidhodge931        : Create one single legend for a numeric colour variable coloured and filled along a gradient of colours with different alpha values"
[12] "yutannihilation      : Use pak in R-CMD-check.yaml"                                                                                                       
[13] "hadley               : Option to make default colour schemes accessible?"                                                                                 
[14] "davidhodge931        : scale_fill_gradientn and scale_colour_gradientn should support na.translate"                                                       
[15] "davidhodge931        : should legend styling elements within guide_* instead be within theme?"                                                            
[16] "markjrieke           : `geom_ribbon`: aesthetics can not vary with a ribbon"                                                                              
[17] "bkmgit               : Dataset licenses"                                                                                                                  
[18] "jxu                  : geom_segment example confusing"                                                                                                    
[19] "twest820             : alpha legend keys darken when geom_ribbons share an alpha value"                                                                   
[20] "WillForan            : discarded breaks in scale_x_continuous(trans=\"log10\") w/ min(x)==0"                                                              
[21] "billdenney           : na.rm is ignored with geom_area"                                                                                                   
[22] "hugesingleton        : Is it possible to make the width of geom_boxplot and binwidth in geom_density, and position \"mapable\" in aes()?"                 
[23] "bersbersbers         : Fix warning in geom_violin with draw_quantiles"                                                                                    
[24] "eliocamp             : `geom_contour()` documentation states false precedence of bin and binwidth parameters"                                             
[25] "jtlandis             : Unexpected results using `guides(x = guide_axis(position = ...))`"                                                                 
[26] "albert-ying          : Smarter axis label -- allow string manipulate function in `labs` or `theme`"                                                       
[27] "Cumol                : Width argument to geom_errorbar not passed on when using stat_summary_bin"                                                         
[28] "twest820             : apparently spurious is.na() warning on use of language in label"                                                                   
[29] "benjaminrich         : Add `trans` option in `annotation_logticks()`"                                                                                     
[30] "benjaminrich         : `annotation_logticks()` with secondary axis"                                                                                       
```

## CitiBike NYC

A single public API that shows location, status and current availability for all stations in the New York City bike sharing imitative.


```r
citibike <- fromJSON("https://gbfs.citibikenyc.com/gbfs/en/station_information.json")
stations <- citibike$data$stations
colnames(stations)
```

```
 [1] "electric_bike_surcharge_waiver" "eightd_station_services"        "lat"                            "external_id"                   
 [5] "station_type"                   "name"                           "short_name"                     "station_id"                    
 [9] "rental_methods"                 "rental_uris"                    "has_kiosk"                      "region_id"                     
[13] "capacity"                       "legacy_id"                      "lon"                            "eightd_has_key_dispenser"      
```

```r
nrow(stations)
```

```
[1] 1598
```

## Ergast

The Ergast Developer API is an experimental web service which provides a historical record of motor racing data for non-commercial purposes.


```r
res <- fromJSON('http://ergast.com/api/f1/2004/1/results.json')
drivers <- res$MRData$RaceTable$Races$Results[[1]]$Driver
colnames(drivers)
```

```
[1] "driverId"        "code"            "url"             "givenName"       "familyName"      "dateOfBirth"     "nationality"    
[8] "permanentNumber"
```

```r
drivers[1:10, c("givenName", "familyName", "code", "nationality")]
```

```
   givenName    familyName code nationality
1    Michael    Schumacher  MSC      German
2     Rubens   Barrichello  BAR   Brazilian
3   Fernando        Alonso  ALO     Spanish
4       Ralf    Schumacher  SCH      German
5       Juan Pablo Montoya  MON   Colombian
6     Jenson        Button  BUT     British
7      Jarno        Trulli  TRU     Italian
8      David     Coulthard  COU     British
9     Takuma          Sato  SAT    Japanese
10 Giancarlo    Fisichella  FIS     Italian
```


## ProPublica

Below an example from the [ProPublica Nonprofit Explorer API](https://projects.propublica.org/nonprofits/api) where we retrieve the first 10 pages of tax-exempt organizations in the USA, ordered by revenue. The `rbind_pages` function is used to combine the pages into a single data frame.



```r
#store all pages in a list first
baseurl <- "https://projects.propublica.org/nonprofits/api/v2/search.json?order=revenue&sort_order=desc"
pages <- list()
for(i in 0:10){
  mydata <- fromJSON(paste0(baseurl, "&page=", i), flatten=TRUE)
  message("Retrieving page ", i)
  pages[[i+1]] <- mydata$organizations
}

#combine all into one
organizations <- rbind_pages(pages)

#check output
nrow(organizations)
```

```
[1] 1100
```

```r
organizations[1:10, c("name", "city", "strein")]
```

```
                            name        city     strein
1           0 DEBT EDUCATION INC  SANTA ROSA 46-4744976
2                0 TOLERANCE INC     SUWANEE 27-2620044
3                00 MOVEMENT INC   PENSACOLA 82-4704419
4                    00006 LOCAL       MEDIA 22-6062777
5             0003 POSTAL FAMILY  CINCINNATI 31-0240910
6                        0005 GA   HEPHZIBAH 58-1514574
7  0005 WRIGHT-PATT CREDIT UNION BEAVERCREEK 31-0278870
8                        0009 DE   GREENWOOD 26-4507405
9                0011 CALIFORNIA      REDWAY 36-4654777
10                   00141 LOCAL       MEDIA 94-0507697
```


## New York Times

The New York Times has several APIs as part of the NYT developer network. These interface to data from various departments, such as news articles, book reviews, real estate, etc. Registration is required (but free) and a key can be obtained at [here](http://developer.nytimes.com/signup). The code below includes some example keys for illustration purposes.


```r
#search for articles
article_key <- "&api-key=b75da00e12d54774a2d362adddcc9bef"
url <- "http://api.nytimes.com/svc/search/v2/articlesearch.json?q=obamacare+socialism"
req <- fromJSON(paste0(url, article_key))
articles <- req$response$docs
colnames(articles)
```

```
 [1] "abstract"         "web_url"          "snippet"          "lead_paragraph"   "print_section"    "print_page"       "source"          
 [8] "multimedia"       "headline"         "keywords"         "pub_date"         "document_type"    "news_desk"        "section_name"    
[15] "byline"           "type_of_material" "_id"              "word_count"       "uri"              "subsection_name" 
```

```r
#search for best sellers
books_key <- "&api-key=76363c9e70bc401bac1e6ad88b13bd1d"
url <- "http://api.nytimes.com/svc/books/v2/lists/overview.json?published_date=2013-01-01"
req <- fromJSON(paste0(url, books_key))
bestsellers <- req$results$list
category1 <- bestsellers[[1, "books"]]
subset(category1, select = c("author", "title", "publisher"))
```

```
           author                title                  publisher
1   Gillian Flynn            GONE GIRL           Crown Publishing
2    John Grisham        THE RACKETEER Knopf Doubleday Publishing
3       E L James FIFTY SHADES OF GREY Knopf Doubleday Publishing
4 Nicholas Sparks           SAFE HAVEN   Grand Central Publishing
5  David Baldacci        THE FORGOTTEN   Grand Central Publishing
```

## Twitter

The twitter API requires OAuth2 authentication. Some example code:


```r
#Create your own appication key at https://dev.twitter.com/apps
consumer_key = "EZRy5JzOH2QQmVAe9B4j2w";
consumer_secret = "OIDC4MdfZJ82nbwpZfoUO4WOLTYjoRhpHRAWj6JMec";

#Use basic auth
secret <- jsonlite::base64_enc(paste(consumer_key, consumer_secret, sep = ":"))
req <- httr::POST("https://api.twitter.com/oauth2/token",
  httr::add_headers(
    "Authorization" = paste("Basic", gsub("\n", "", secret)),
    "Content-Type" = "application/x-www-form-urlencoded;charset=UTF-8"
  ),
  body = "grant_type=client_credentials"
);

#Extract the access token
httr::stop_for_status(req, "authenticate with twitter")
token <- paste("Bearer", httr::content(req)$access_token)

#Actual API call
url <- "https://api.twitter.com/1.1/statuses/user_timeline.json?count=10&screen_name=Rbloggers"
req <- httr::GET(url, httr::add_headers(Authorization = token))
json <- httr::content(req, as = "text")
tweets <- fromJSON(json)
substring(tweets$text, 1, 100)
```

```
 [1] "Surface reconstruction with R(CGAL)  {https://t.co/Kou9gFUmod} #rstats #DataScience"                 
 [2] "A dashboard illustrating bivariate time series forecasting with `ahead`  {https://t.co/HYS6UIKMgl} #"
 [3] "Handling Categorical Data in R – Part 4  {https://t.co/aZa7O7Ppxd} #rstats #DataScience"             
 [4] "Solving the ‘preserving the sum after rounding’ problem for a soccer waffle viz  {https://t.co/uNtOL"
 [5] "Community Management Transition for rOpenSci. A Message from Stefanie Butland  {https://t.co/r7YuZjV"
 [6] "New R job: Data Services Specialist https://t.co/sy2goVMxbq #rstats #DataScience #jobs"              
 [7] "RTutor: Gasoline Taxes and Consumer Behavior  {https://t.co/nIxUNfihoK} #rstats #DataScience"        
 [8] "Shinywordle: A shiny app to solve the game Worldle and the power of regular expressions  {https://t."
 [9] "10 New books added to Big Book of R  {https://t.co/jD0IYutHTN} #rstats #DataScience"                 
[10] "Clipping an isosurface to a ball, and more  {https://t.co/Yz0qbSB3IB} #rstats #DataScience"          
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_json.R
\name{read_json}
\alias{read_json}
\alias{parse_json}
\alias{write_json}
\title{Read/write JSON}
\usage{
read_json(path, simplifyVector = FALSE, ...)

parse_json(json, simplifyVector = FALSE, ...)

write_json(x, path, ...)
}
\arguments{
\item{path}{file on disk}

\item{simplifyVector}{simplifies nested lists into vectors and data frames. See \link{fromJSON}.}

\item{...}{additional conversion arguments, see also \link{toJSON} or \link{fromJSON}}

\item{json}{string with literal json or connection object to read from}

\item{x}{an object to be serialized to JSON}
}
\description{
These functions are similar to \link{toJSON} and \link{fromJSON} except they
explicitly distinguish between path and literal input, and do not simplify
by default.
}
\examples{
tmp <- tempfile()
write_json(iris, tmp)

# Nested lists
read_json(tmp)

# A data frame
read_json(tmp, simplifyVector = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_json.R
\name{read_json}
\alias{read_json}
\alias{parse_json}
\alias{write_json}
\title{Read/write JSON}
\usage{
read_json(path, simplifyVector = FALSE, ...)

parse_json(json, simplifyVector = FALSE, ...)

write_json(x, path, ...)
}
\arguments{
\item{path}{file on disk}

\item{simplifyVector}{simplifies nested lists into vectors and data frames. See \link{fromJSON}.}

\item{...}{additional conversion arguments, see also \link{toJSON} or \link{fromJSON}}

\item{json}{string with literal json or connection object to read from}

\item{x}{an object to be serialized to JSON}
}
\description{
These functions are similar to \link{toJSON} and \link{fromJSON} except they
explicitly distinguish between path and literal input, and do not simplify
by default.
}
\examples{
tmp <- tempfile()
write_json(iris, tmp)

# Nested lists
read_json(tmp)

# A data frame
read_json(tmp, simplifyVector = TRUE)
}
\seealso{
\code{\link{fromJSON}}, \code{\link{stream_in}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/json_gzip.R
\name{gzjson}
\alias{gzjson}
\alias{as_gzjson_raw}
\alias{as_gzjson_b64}
\alias{parse_gzjson_raw}
\alias{parse_gzjson_b64}
\title{Gzipped JSON}
\usage{
as_gzjson_raw(x, ...)

as_gzjson_b64(x, ...)

parse_gzjson_raw(buf, ...)

parse_gzjson_b64(b64, ...)
}
\arguments{
\item{x}{R data object to be converted to JSON}

\item{...}{passed down to \link{toJSON} or \link{fromJSON}}

\item{buf}{raw vector with gzip compressed data}

\item{b64}{base64 encoded string containing gzipped json data}
}
\description{
Wrapper to generate and parse gzipped JSON, in order to save some disk or
network space. This is mainly effective for larger json objects with many
repeated keys, as is common in serialized data frames.
}
\details{
The \link{as_gzjson_raw} and \link{parse_gzjson_raw} functions work with raw (binary)
vectors of compressed data. To use this in a place where only text is allowed
you can wrap the output again in \link{base64} as done by \link{as_gzjson_b64} and
\link{parse_gzjson_b64}. This increases the size again with about 33\%.
}
\examples{
str <- as_gzjson_b64(iris[1:5,])
cat(str)
parse_gzjson_b64(str)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prettify.R
\name{prettify, minify}
\alias{prettify, minify}
\alias{prettify}
\alias{minify}
\title{Prettify or minify a JSON string}
\usage{
prettify(txt, indent = 4)

minify(txt)
}
\arguments{
\item{txt}{JSON string}

\item{indent}{number of spaces to indent}
}
\description{
Prettify adds indentation to a JSON string; minify removes all indentation/whitespace.
}
\examples{
myjson <- toJSON(cars)
cat(myjson)
prettify(myjson)
minify(myjson)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/serializeJSON.R
\name{serializeJSON}
\alias{serializeJSON}
\alias{unserializeJSON}
\title{serialize R objects to JSON}
\usage{
serializeJSON(x, digits = 8, pretty = FALSE)

unserializeJSON(txt)
}
\arguments{
\item{x}{an \R{} object to be serialized}

\item{digits}{max number of digits (after the dot) to print for numeric values}

\item{pretty}{add indentation/whitespace to JSON output. See \code{\link{prettify}}}

\item{txt}{a JSON string which was created using \code{serializeJSON}}
}
\description{
The \code{\link{serializeJSON}} and \code{\link{unserializeJSON}} functions convert between
\R{} objects to JSON data. Instead of using a class based mapping like
\code{\link{toJSON}} and \code{\link{fromJSON}}, the serialize functions base the encoding
schema on the storage type, and capture all data and attributes from any object.
Thereby the object can be restored almost perfectly from its JSON representation, but
the resulting JSON output is very verbose. Apart from environments, all standard storage
types are supported.
}
\note{
JSON is a text based format which leads to loss of precision when printing numbers.
}
\examples{
jsoncars <- serializeJSON(mtcars)
mtcars2 <- unserializeJSON(jsoncars)
identical(mtcars, mtcars2)

set.seed('123')
myobject <- list(
  mynull = NULL,
  mycomplex = lapply(eigen(matrix(-rnorm(9),3)), round, 3),
  mymatrix = round(matrix(rnorm(9), 3),3),
  myint = as.integer(c(1,2,3)),
  mydf = cars,
  mylist = list(foo='bar', 123, NA, NULL, list('test')),
  mylogical = c(TRUE,FALSE,NA),
  mychar = c('foo', NA, 'bar'),
  somemissings = c(1,2,NA,NaN,5, Inf, 7 -Inf, 9, NA),
  myrawvec = charToRaw('This is a test')
);
identical(unserializeJSON(serializeJSON(myobject)), myobject);
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stream.R
\name{stream_in, stream_out}
\alias{stream_in, stream_out}
\alias{stream_in}
\alias{stream_out}
\title{Streaming JSON input/output}
\usage{
stream_in(con, handler = NULL, pagesize = 500, verbose = TRUE, ...)

stream_out(x, con = stdout(), pagesize = 500, verbose = TRUE, prefix = "", ...)
}
\arguments{
\item{con}{a \code{\link{connection}} object. If the connection is not open,
\code{stream_in} and \code{stream_out} will automatically open
and later close (and destroy) the connection. See details.}

\item{handler}{a custom function that is called on each page of JSON data. If not specified,
the default handler stores all pages and binds them into a single data frame that will be
returned by \code{stream_in}. See details.}

\item{pagesize}{number of lines to read/write from/to the connection per iteration.}

\item{verbose}{print some information on what is going on.}

\item{...}{arguments for \code{\link{fromJSON}} and \code{\link{toJSON}} that
control JSON formatting/parsing where applicable. Use with caution.}

\item{x}{object to be streamed out. Currently only data frames are supported.}

\item{prefix}{string to write before each line (use \code{"\u001e"} to write rfc7464 text sequences)}
}
\value{
The \code{stream_out} function always returns \code{NULL}.
When no custom handler is specified, \code{stream_in} returns a data frame of all pages binded together.
When a custom handler function is specified, \code{stream_in} always returns \code{NULL}.
}
\description{
The \code{stream_in} and \code{stream_out} functions implement line-by-line processing
of JSON data over a \code{\link{connection}}, such as a socket, url, file or pipe. JSON
streaming requires the \href{http://ndjson.org}{ndjson} format, which slightly differs
from \code{\link{fromJSON}} and \code{\link{toJSON}}, see details.
}
\details{
Because parsing huge JSON strings is difficult and inefficient, JSON streaming is done
using \strong{lines of minified JSON records}, a.k.a. \href{http://ndjson.org}{ndjson}.
This is pretty standard: JSON databases such as \href{https://github.com/datproject/dat}{dat}
or MongoDB use the same format to import/export datasets. Note that this means that the
total stream combined is not valid JSON itself; only the individual lines are. Also note
that because line-breaks are used as separators, prettified JSON is not permitted: the
JSON lines \emph{must} be minified. In this respect, the format is a bit different from
\code{\link{fromJSON}} and \code{\link{toJSON}} where all lines are part of a single JSON
structure with optional line breaks.

The \code{handler} is a callback function which is called for each page (batch) of
JSON data with exactly one argument (usually a data frame with \code{pagesize} rows).
If \code{handler} is missing or \code{NULL}, a default handler is used which stores all
intermediate pages of data, and at the very end binds all pages together into one single
data frame that is returned by \code{stream_in}. When a custom \code{handler} function
is specified, \code{stream_in} does not store any intermediate results and always returns
\code{NULL}. It is then up to the \code{handler} to process or store data pages.
A \code{handler} function that does not store intermediate results in memory (for
example by writing output to another connection) results in a pipeline that can process an
unlimited amount of data. See example.

Note that a vector of JSON strings already in R can parsed with \code{stream_in} by
creating a connection to it with \code{\link{textConnection}}.

If a connection is not opened yet, \code{stream_in} and \code{stream_out}
will automatically open and later close the connection. Because R destroys connections
when they are closed, they cannot be reused. To use a single connection for multiple
calls to \code{stream_in} or \code{stream_out}, it needs to be opened
beforehand. See example.
}
\examples{
# compare formats
x <- iris[1:3,]
toJSON(x)
stream_out(x)

# Trivial example
mydata <- stream_in(url("http://httpbin.org/stream/100"))

\dontrun{
#stream large dataset to file and back
library(nycflights13)
stream_out(flights, file(tmp <- tempfile()))
flights2 <- stream_in(file(tmp))
unlink(tmp)
all.equal(flights2, as.data.frame(flights))

# stream over HTTP
diamonds2 <- stream_in(url("http://jeroen.github.io/data/diamonds.json"))

# stream over HTTP with gzip compression
flights3 <- stream_in(gzcon(url("http://jeroen.github.io/data/nycflights13.json.gz")))
all.equal(flights3, as.data.frame(flights))

# stream over HTTPS (HTTP+SSL) via curl
library(curl)
flights4 <- stream_in(gzcon(curl("https://jeroen.github.io/data/nycflights13.json.gz")))
all.equal(flights4, as.data.frame(flights))

# or alternatively:
flights5 <- stream_in(gzcon(pipe("curl https://jeroen.github.io/data/nycflights13.json.gz")))
all.equal(flights5, as.data.frame(flights))

# Full JSON IO stream from URL to file connection.
# Calculate delays for flights over 1000 miles in batches of 5k
library(dplyr)
con_in <- gzcon(url("http://jeroen.github.io/data/nycflights13.json.gz"))
con_out <- file(tmp <- tempfile(), open = "wb")
stream_in(con_in, handler = function(df){
  df <- dplyr::filter(df, distance > 1000)
  df <- dplyr::mutate(df, delta = dep_delay - arr_delay)
  stream_out(df, con_out, pagesize = 1000)
}, pagesize = 5000)
close(con_out)

# stream it back in
mydata <- stream_in(file(tmp))
nrow(mydata)
unlink(tmp)

# Data from http://openweathermap.org/current#bulk
# Each row contains a nested data frame.
daily14 <- stream_in(gzcon(url("http://78.46.48.103/sample/daily_14.json.gz")), pagesize=50)
subset(daily14, city$name == "Berlin")$data[[1]]

# Or with dplyr:
library(dplyr)
daily14f <- flatten(daily14)
filter(daily14f, city.name == "Berlin")$data[[1]]

# Stream import large data from zip file
tmp <- tempfile()
download.file("http://jsonstudio.com/wp-content/uploads/2014/02/companies.zip", tmp)
companies <- stream_in(unz(tmp, "companies.json"))
}
}
\references{
MongoDB export format: \url{https://docs.mongodb.com/manual/reference/program/mongoexport/}

Documentation for the JSON Lines text file format: \url{https://jsonlines.org/}
}
\seealso{
\code{\link{fromJSON}}, \code{\link{read_json}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stream.R
\name{stream_in, stream_out}
\alias{stream_in, stream_out}
\alias{stream_in}
\alias{stream_out}
\title{Streaming JSON input/output}
\usage{
stream_in(con, handler = NULL, pagesize = 500, verbose = TRUE, ...)

stream_out(x, con = stdout(), pagesize = 500, verbose = TRUE, prefix = "", ...)
}
\arguments{
\item{con}{a \link{connection} object. If the connection is not open,
\code{stream_in} and \code{stream_out} will automatically open
and later close (and destroy) the connection. See details.}

\item{handler}{a custom function that is called on each page of JSON data. If not specified,
the default handler stores all pages and binds them into a single data frame that will be
returned by \code{stream_in}. See details.}

\item{pagesize}{number of lines to read/write from/to the connection per iteration.}

\item{verbose}{print some information on what is going on.}

\item{...}{arguments for \code{\link[=fromJSON]{fromJSON()}} and \code{\link[=toJSON]{toJSON()}} that
control JSON formatting/parsing where applicable. Use with caution.}

\item{x}{object to be streamed out. Currently only data frames are supported.}

\item{prefix}{string to write before each line (use \code{"\\u001e"} to write rfc7464 text sequences)}
}
\value{
The \code{stream_out} function always returns \code{NULL}.
When no custom handler is specified, \code{stream_in} returns a data frame of all pages binded together.
When a custom handler function is specified, \code{stream_in} always returns \code{NULL}.
}
\description{
The \code{stream_in} and \code{stream_out} functions implement line-by-line processing
of JSON data over a \link{connection}, such as a socket, url, file or pipe. JSON
streaming requires the \href{https://ndjson.org}{ndjson} format, which slightly differs
from \code{\link[=fromJSON]{fromJSON()}} and \code{\link[=toJSON]{toJSON()}}, see details.
}
\details{
Because parsing huge JSON strings is difficult and inefficient, JSON streaming is done
using \strong{lines of minified JSON records}, a.k.a. \href{https://ndjson.org}{ndjson}.
This is pretty standard: JSON databases such as MongoDB use the same format to
import/export datasets. Note that this means that the
total stream combined is not valid JSON itself; only the individual lines are. Also note
that because line-breaks are used as separators, prettified JSON is not permitted: the
JSON lines \emph{must} be minified. In this respect, the format is a bit different from
\code{\link[=fromJSON]{fromJSON()}} and \code{\link[=toJSON]{toJSON()}} where all lines are part of a single JSON
structure with optional line breaks.

The \code{handler} is a callback function which is called for each page (batch) of
JSON data with exactly one argument (usually a data frame with \code{pagesize} rows).
If \code{handler} is missing or \code{NULL}, a default handler is used which stores all
intermediate pages of data, and at the very end binds all pages together into one single
data frame that is returned by \code{stream_in}. When a custom \code{handler} function
is specified, \code{stream_in} does not store any intermediate results and always returns
\code{NULL}. It is then up to the \code{handler} to process or store data pages.
A \code{handler} function that does not store intermediate results in memory (for
example by writing output to another connection) results in a pipeline that can process an
unlimited amount of data. See example.

Note that a vector of JSON strings already in R can parsed with \code{stream_in} by
creating a connection to it with \code{\link[=textConnection]{textConnection()}}.

If a connection is not opened yet, \code{stream_in} and \code{stream_out}
will automatically open and later close the connection. Because R destroys connections
when they are closed, they cannot be reused. To use a single connection for multiple
calls to \code{stream_in} or \code{stream_out}, it needs to be opened
beforehand. See example.
}
\examples{
# compare formats
x <- iris[1:3,]
toJSON(x)
stream_out(x)

# Trivial example
mydata <- stream_in(url("https://jeroen.github.io/data/iris.json"))

\dontrun{
#stream large dataset to file and back
library(nycflights13)
stream_out(flights, file(tmp <- tempfile()))
flights2 <- stream_in(file(tmp))
unlink(tmp)
all.equal(flights2, as.data.frame(flights))

# stream over HTTP
diamonds2 <- stream_in(url("https://jeroen.github.io/data/diamonds.json"))

# stream over HTTP with gzip compression
flights3 <- stream_in(gzcon(url("https://jeroen.github.io/data/nycflights13.json.gz")))
all.equal(flights3, as.data.frame(flights))

# stream over HTTPS (HTTP+SSL) via curl
library(curl)
flights4 <- stream_in(gzcon(curl("https://jeroen.github.io/data/nycflights13.json.gz")))
all.equal(flights4, as.data.frame(flights))

# or alternatively:
flights5 <- stream_in(gzcon(pipe("curl https://jeroen.github.io/data/nycflights13.json.gz")))
all.equal(flights5, as.data.frame(flights))

# Full JSON IO stream from URL to file connection.
# Calculate delays for flights over 1000 miles in batches of 5k
library(dplyr)
con_in <- gzcon(url("https://jeroen.github.io/data/nycflights13.json.gz"))
con_out <- file(tmp <- tempfile(), open = "wb")
stream_in(con_in, handler = function(df){
  df <- dplyr::filter(df, distance > 1000)
  df <- dplyr::mutate(df, delta = dep_delay - arr_delay)
  stream_out(df, con_out, pagesize = 1000)
}, pagesize = 5000)
close(con_out)

# stream it back in
mydata <- stream_in(file(tmp))
nrow(mydata)
unlink(tmp)

# Data from http://openweathermap.org/current#bulk
# Each row contains a nested data frame.
daily14 <- stream_in(gzcon(url("http://78.46.48.103/sample/daily_14.json.gz")), pagesize=50)
subset(daily14, city$name == "Berlin")$data[[1]]

# Or with dplyr:
library(dplyr)
daily14f <- flatten(daily14)
filter(daily14f, city.name == "Berlin")$data[[1]]

# Stream import large data from zip file
tmp <- tempfile()
download.file("http://jsonstudio.com/wp-content/uploads/2014/02/companies.zip", tmp)
companies <- stream_in(unz(tmp, "companies.json"))
}
}
\references{
MongoDB export format: \url{https://www.mongodb.com/docs/database-tools/mongoexport/}

Documentation for the JSON Lines text file format: \url{https://jsonlines.org/}
}
\seealso{
\code{\link[=fromJSON]{fromJSON()}}, \code{\link[=read_json]{read_json()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/validate.R
\name{validate}
\alias{validate}
\title{Validate JSON}
\usage{
validate(txt)
}
\arguments{
\item{txt}{JSON string}
}
\description{
Test if a string contains valid JSON. Characters vectors will be collapsed into a single string.
}
\examples{
#Output from toJSON and serializeJSON should pass validation
myjson <- toJSON(mtcars)
validate(myjson) #TRUE

#Something bad happened
truncated <- substring(myjson, 1, 100)
validate(truncated) #FALSE
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/base64.R
\name{base64}
\alias{base64}
\alias{base64_dec}
\alias{base64_enc}
\title{Encode/decode base64}
\usage{
base64_dec(input)

base64_enc(input)
}
\arguments{
\item{input}{string or raw vector to be encoded/decoded}
}
\description{
Simple in-memory base64 encoder and decoder. Used internally for converting
raw vectors to text. Interchangeable with encoder from \code{base64enc} or
\code{openssl} package.
}
\examples{
str <- base64_enc(serialize(iris, NULL))
out <- unserialize(base64_dec(str))
stopifnot(identical(out, iris))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/base64.R
\name{base64}
\alias{base64}
\alias{base64_dec}
\alias{base64_enc}
\alias{base64url_enc}
\alias{base64url_dec}
\title{Encode/decode base64}
\usage{
base64_dec(input)

base64_enc(input)

base64url_enc(input)

base64url_dec(input)
}
\arguments{
\item{input}{string or raw vector to be encoded/decoded}
}
\description{
Simple in-memory base64 encoder and decoder. Used internally for converting
raw vectors to text. Interchangeable with encoder from \code{base64enc} or
\code{openssl} package.
}
\details{
The \link{base64url_enc} and \link{base64url_dec} functions use a variation of base64
that substitute characters \verb{+/}  for \verb{-_} respectively, such that the output
does not require URL-encoding. See also section 5 of rfc4648.
}
\examples{
str <- base64_enc(serialize(iris, NULL))
out <- unserialize(base64_dec(str))
stopifnot(identical(out, iris))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fromJSON.R, R/toJSON.R
\name{toJSON, fromJSON}
\alias{toJSON, fromJSON}
\alias{fromJSON}
\alias{toJSON}
\alias{jsonlite}
\title{Convert \R{} objects to/from JSON}
\usage{
fromJSON(
  txt,
  simplifyVector = TRUE,
  simplifyDataFrame = simplifyVector,
  simplifyMatrix = simplifyVector,
  flatten = FALSE,
  ...
)

toJSON(
  x,
  dataframe = c("rows", "columns", "values"),
  matrix = c("rowmajor", "columnmajor"),
  Date = c("ISO8601", "epoch"),
  POSIXt = c("string", "ISO8601", "epoch", "mongo"),
  factor = c("string", "integer"),
  complex = c("string", "list"),
  raw = c("base64", "hex", "mongo", "int", "js"),
  null = c("list", "null"),
  na = c("null", "string"),
  auto_unbox = FALSE,
  digits = 4,
  pretty = FALSE,
  force = FALSE,
  ...
)
}
\arguments{
\item{txt}{a JSON string, URL or file}

\item{simplifyVector}{coerce JSON arrays containing only primitives into an atomic vector}

\item{simplifyDataFrame}{coerce JSON arrays containing only records (JSON objects) into a data frame}

\item{simplifyMatrix}{coerce JSON arrays containing vectors of equal mode and dimension into matrix or array}

\item{flatten}{automatically \code{\link{flatten}} nested data frames into a single non-nested data frame}

\item{...}{arguments passed on to class specific \code{print} methods}

\item{x}{the object to be encoded}

\item{dataframe}{how to encode data.frame objects: must be one of 'rows', 'columns' or 'values'}

\item{matrix}{how to encode matrices and higher dimensional arrays: must be one of 'rowmajor' or 'columnmajor'.}

\item{Date}{how to encode Date objects: must be one of 'ISO8601' or 'epoch'}

\item{POSIXt}{how to encode POSIXt (datetime) objects: must be one of 'string', 'ISO8601', 'epoch' or 'mongo'}

\item{factor}{how to encode factor objects: must be one of 'string' or 'integer'}

\item{complex}{how to encode complex numbers: must be one of 'string' or 'list'}

\item{raw}{how to encode raw objects: must be one of 'base64', 'hex' or 'mongo'}

\item{null}{how to encode NULL values within a list: must be one of 'null' or 'list'}

\item{na}{how to print NA values: must be one of 'null' or 'string'. Defaults are class specific}

\item{auto_unbox}{automatically \code{\link{unbox}} all atomic vectors of length 1. It is usually safer to avoid this and instead use the \code{\link{unbox}} function to unbox individual elements.
An exception is that objects of class \code{AsIs} (i.e. wrapped in \code{I()}) are not automatically unboxed. This is a way to mark single values as length-1 arrays.}

\item{digits}{max number of decimal digits to print for numeric values. Use \code{I()} to specify significant digits. Use \code{NA} for max precision.}

\item{pretty}{adds indentation whitespace to JSON output. Can be TRUE/FALSE or a number specifying the number of spaces to indent. See \code{\link{prettify}}}

\item{force}{unclass/skip objects of classes with no defined JSON mapping}
}
\description{
These functions are used to convert between JSON data and \R{} objects. The \code{\link{toJSON}} and \code{\link{fromJSON}}
functions use a class based mapping, which follows conventions outlined in this paper:  \url{https://arxiv.org/abs/1403.2805} (also available as vignette).
}
\details{
The \code{\link{toJSON}} and \code{\link{fromJSON}} functions are drop-in replacements for the identically named functions
in packages \code{rjson} and \code{RJSONIO}. Our implementation uses an alternative, somewhat more consistent mapping
between \R{} objects and JSON strings.

The \code{\link{serializeJSON}} and \code{\link{unserializeJSON}} functions in this package use an
alternative system to convert between \R{} objects and JSON, which supports more classes but is much more verbose.

A JSON string is always unicode, using \code{UTF-8} by default, hence there is usually no need to escape any characters.
However, the JSON format does support escaping of unicode characters, which are encoded using a backslash followed by
a lower case \code{"u"} and 4 hex characters, for example: \code{"Z\\u00FCrich"}. The \code{fromJSON} function
will parse such escape sequences but it is usually preferable to encode unicode characters in JSON using native
\code{UTF-8} rather than escape sequences.
}
\examples{
# Stringify some data
jsoncars <- toJSON(mtcars, pretty=TRUE)
cat(jsoncars)

# Parse it back
fromJSON(jsoncars)

# Parse escaped unicode
fromJSON('{"city" : "Z\\\\u00FCrich"}')

# Decimal vs significant digits
toJSON(pi, digits=3)
toJSON(pi, digits=I(3))

\dontrun{
#retrieve data frame
data1 <- fromJSON("https://api.github.com/users/hadley/orgs")
names(data1)
data1$login

# Nested data frames:
data2 <- fromJSON("https://api.github.com/users/hadley/repos")
names(data2)
names(data2$owner)
data2$owner$login

# Flatten the data into a regular non-nested dataframe
names(flatten(data2))

# Flatten directly (more efficient):
data3 <- fromJSON("https://api.github.com/users/hadley/repos", flatten = TRUE)
identical(data3, flatten(data2))
}
}
\references{
Jeroen Ooms (2014). The \code{jsonlite} Package: A Practical and Consistent Mapping Between JSON Data and \R{} Objects. \emph{arXiv:1403.2805}. \url{https://arxiv.org/abs/1403.2805}
}
\seealso{
\code{\link{read_json}}, \code{\link{stream_in}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/unbox.R
\name{unbox}
\alias{unbox}
\title{Unbox a vector or data frame}
\usage{
unbox(x)
}
\arguments{
\item{x}{atomic vector of length 1, or data frame with 1 row.}
}
\value{
Returns a singleton version of \code{x}.
}
\description{
This function marks an atomic vector or data frame as a
\href{https://en.wikipedia.org/wiki/Singleton_(mathematics)}{singleton}, i.e.
a set with exactly 1 element. Thereby, the value will not turn into an
\code{array} when encoded into JSON. This can only be done for
atomic vectors of length 1, or data frames with exactly 1 row. To automatically
unbox all vectors of length 1 within an object, use the \code{auto_unbox} argument
in \code{\link{toJSON}}.
}
\details{
It is usually recommended to avoid this function and stick with the default
encoding schema for the various \R{} classes. The only use case for this function
is if you are bound to some specific predefined JSON structure (e.g. to
submit to an API), which has no natural \R{} representation. Note that the default
encoding for data frames naturally results in a collection of key-value pairs,
without using \code{unbox}.
}
\examples{
toJSON(list(foo=123))
toJSON(list(foo=unbox(123)))

# Auto unbox vectors of length one:
x = list(x=1:3, y = 4, z = "foo", k = NULL)
toJSON(x)
toJSON(x, auto_unbox = TRUE)

x <- iris[1,]
toJSON(list(rec=x))
toJSON(list(rec=unbox(x)))
}
\references{
\url{https://en.wikipedia.org/wiki/Singleton_(mathematics)}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fromJSON.R, R/toJSON.R
\name{toJSON, fromJSON}
\alias{toJSON, fromJSON}
\alias{fromJSON}
\alias{toJSON}
\alias{jsonlite}
\title{Convert \R{} objects to/from JSON}
\usage{
fromJSON(
  txt,
  simplifyVector = TRUE,
  simplifyDataFrame = simplifyVector,
  simplifyMatrix = simplifyVector,
  flatten = FALSE,
  ...
)

toJSON(
  x,
  dataframe = c("rows", "columns", "values"),
  matrix = c("rowmajor", "columnmajor"),
  Date = c("ISO8601", "epoch"),
  POSIXt = c("string", "ISO8601", "epoch", "mongo"),
  factor = c("string", "integer"),
  complex = c("string", "list"),
  raw = c("base64", "hex", "mongo", "int", "js"),
  null = c("list", "null"),
  na = c("null", "string"),
  auto_unbox = FALSE,
  digits = 4,
  pretty = FALSE,
  force = FALSE,
  ...
)
}
\arguments{
\item{txt}{a JSON string, URL or file}

\item{simplifyVector}{coerce JSON arrays containing only primitives into an atomic vector}

\item{simplifyDataFrame}{coerce JSON arrays containing only records (JSON objects) into a data frame}

\item{simplifyMatrix}{coerce JSON arrays containing vectors of equal mode and dimension into matrix or array}

\item{flatten}{automatically \code{\link{flatten}} nested data frames into a single non-nested data frame}

\item{...}{arguments passed on to class specific \code{print} methods}

\item{x}{the object to be encoded}

\item{dataframe}{how to encode data.frame objects: must be one of 'rows', 'columns' or 'values'}

\item{matrix}{how to encode matrices and higher dimensional arrays: must be one of 'rowmajor' or 'columnmajor'.}

\item{Date}{how to encode Date objects: must be one of 'ISO8601' or 'epoch'}

\item{POSIXt}{how to encode POSIXt (datetime) objects: must be one of 'string', 'ISO8601', 'epoch' or 'mongo'}

\item{factor}{how to encode factor objects: must be one of 'string' or 'integer'}

\item{complex}{how to encode complex numbers: must be one of 'string' or 'list'}

\item{raw}{how to encode raw objects: must be one of 'base64', 'hex' or 'mongo'}

\item{null}{how to encode NULL values within a list: must be one of 'null' or 'list'}

\item{na}{how to print NA values: must be one of 'null' or 'string'. Defaults are class specific}

\item{auto_unbox}{automatically \code{\link{unbox}} all atomic vectors of length 1. It is usually safer to avoid this and instead use the \code{\link{unbox}} function to unbox individual elements.
An exception is that objects of class \code{AsIs} (i.e. wrapped in \code{I()}) are not automatically unboxed. This is a way to mark single values as length-1 arrays.}

\item{digits}{max number of decimal digits to print for numeric values. Use \code{I()} to specify significant digits. Use \code{NA} for max precision.}

\item{pretty}{adds indentation whitespace to JSON output. Can be TRUE/FALSE or a number specifying the number of spaces to indent. See \code{\link{prettify}}}

\item{force}{unclass/skip objects of classes with no defined JSON mapping}
}
\description{
These functions are used to convert between JSON data and \R{} objects. The \code{\link{toJSON}} and \code{\link{fromJSON}}
functions use a class based mapping, which follows conventions outlined in this paper:  \url{https://arxiv.org/abs/1403.2805} (also available as vignette).
}
\details{
The \code{\link{toJSON}} and \code{\link{fromJSON}} functions are drop-in replacements for the identically named functions
in packages \code{rjson} and \code{RJSONIO}. Our implementation uses an alternative, somewhat more consistent mapping
between \R{} objects and JSON strings.

The \code{\link{serializeJSON}} and \code{\link{unserializeJSON}} functions in this package use an
alternative system to convert between \R{} objects and JSON, which supports more classes but is much more verbose.

A JSON string is always unicode, using \code{UTF-8} by default, hence there is usually no need to escape any characters.
However, the JSON format does support escaping of unicode characters, which are encoded using a backslash followed by
a lower case \code{"u"} and 4 hex characters, for example: \code{"Z\\u00FCrich"}. The \code{fromJSON} function
will parse such escape sequences but it is usually preferable to encode unicode characters in JSON using native
\code{UTF-8} rather than escape sequences.
}
\examples{
# Stringify some data
jsoncars <- toJSON(mtcars, pretty=TRUE)
cat(jsoncars)

# Parse it back
fromJSON(jsoncars)

# Parse escaped unicode
fromJSON('{"city" : "Z\\\\u00FCrich"}')

# Decimal vs significant digits
toJSON(pi, digits=3)
toJSON(pi, digits=I(3))

\dontrun{
#retrieve data frame
data1 <- fromJSON("https://api.github.com/users/hadley/orgs")
names(data1)
data1$login

# Nested data frames:
data2 <- fromJSON("https://api.github.com/users/hadley/repos")
names(data2)
names(data2$owner)
data2$owner$login

# Flatten the data into a regular non-nested dataframe
names(flatten(data2))

# Flatten directly (more efficient):
data3 <- fromJSON("https://api.github.com/users/hadley/repos", flatten = TRUE)
identical(data3, flatten(data2))
}
}
\references{
Jeroen Ooms (2014). The \code{jsonlite} Package: A Practical and Consistent Mapping Between JSON Data and \R{} Objects. \emph{arXiv:1403.2805}. \url{https://arxiv.org/abs/1403.2805}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rbind_pages.R
\name{rbind_pages}
\alias{rbind_pages}
\title{Combine pages into a single data frame}
\usage{
rbind_pages(pages)
}
\arguments{
\item{pages}{a list of data frames, each representing a \emph{page} of data}
}
\description{
The \code{rbind_pages} function is used to combine a list of data frames into a single
data frame. This is often needed when working with a JSON API that limits the amount
of data per request. If we need more data than what fits in a single request, we need to
perform multiple requests that each retrieve a fragment of data, not unlike pages in a
book. In practice this is often implemented using a \code{page} parameter in the API. The
\code{rbind_pages} function can be used to combine these pages back into a single dataset.
}
\details{
The \code{\link{rbind_pages}} function generalizes \code{\link[base:cbind]{base::rbind}} and
\code{\link[plyr:rbind.fill]{plyr::rbind.fill}} with added support for nested data frames. Not each column
has to be present in each of the individual data frames; missing columns will be filled
up in \code{NA} values.
}
\examples{
# Basic example
x <- data.frame(foo = rnorm(3), bar = c(TRUE, FALSE, TRUE))
y <- data.frame(foo = rnorm(2), col = c("blue", "red"))
rbind_pages(list(x, y))

\donttest{
baseurl <- "https://projects.propublica.org/nonprofits/api/v2/search.json"
pages <- list()
for(i in 0:20){
  mydata <- fromJSON(paste0(baseurl, "?order=revenue&sort_order=desc&page=", i))
  message("Retrieving page ", i)
  pages[[i+1]] <- mydata$organizations
}
organizations <- rbind_pages(pages)
nrow(organizations)
colnames(organizations)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/flatten.R
\name{flatten}
\alias{flatten}
\title{Flatten nested data frames}
\usage{
flatten(x, recursive = TRUE)
}
\arguments{
\item{x}{a data frame}

\item{recursive}{flatten recursively}
}
\description{
In a nested data frame, one or more of the columns consist of another data
frame. These structures frequently appear when parsing JSON data from the web.
We can flatten such data frames into a regular 2 dimensional tabular structure.
}
\examples{
options(stringsAsFactors=FALSE)
x <- data.frame(driver = c("Bowser", "Peach"), occupation = c("Koopa", "Princess"))
x$vehicle <- data.frame(model = c("Piranha Prowler", "Royal Racer"))
x$vehicle$stats <- data.frame(speed = c(55, 34), weight = c(67, 24), drift = c(35, 32))
str(x)
str(flatten(x))
str(flatten(x, recursive = FALSE))

\dontrun{
data1 <- fromJSON("https://api.github.com/users/hadley/repos")
colnames(data1)
colnames(data1$owner)
colnames(flatten(data1))

# or for short:
data2 <- fromJSON("https://api.github.com/users/hadley/repos", flatten = TRUE)
colnames(data2)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/unbox.R
\name{unbox}
\alias{unbox}
\title{Unbox a vector or data frame}
\usage{
unbox(x)
}
\arguments{
\item{x}{atomic vector of length 1, or data frame with 1 row.}
}
\value{
Returns a singleton version of \code{x}.
}
\description{
This function marks an atomic vector or data frame as a
\href{http://en.wikipedia.org/wiki/Singleton_(mathematics)}{singleton}, i.e.
a set with exactly 1 element. Thereby, the value will not turn into an
\code{array} when encoded into JSON. This can only be done for
atomic vectors of length 1, or data frames with exactly 1 row. To automatically
unbox all vectors of length 1 within an object, use the \code{auto_unbox} argument
in \code{\link{toJSON}}.
}
\details{
It is usually recommended to avoid this function and stick with the default
encoding schema for the various \R{} classes. The only use case for this function
is if you are bound to some specific predefined JSON structure (e.g. to
submit to an API), which has no natural \R{} representation. Note that the default
encoding for data frames naturally results in a collection of key-value pairs,
without using \code{unbox}.
}
\examples{
toJSON(list(foo=123))
toJSON(list(foo=unbox(123)))

# Auto unbox vectors of length one:
x = list(x=1:3, y = 4, z = "foo", k = NULL)
toJSON(x)
toJSON(x, auto_unbox = TRUE)

x <- iris[1,]
toJSON(list(rec=x))
toJSON(list(rec=unbox(x)))
}
\references{
\url{http://en.wikipedia.org/wiki/Singleton_(mathematics)}
}
